<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.currency.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class currency {

//---- Currency Detail Validation Checks

    function currency_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=lang("Error") ;
	if ($dt[isocode]=="")			$err=lang("Currency ISO Code Missing");
		elseif (strlen($dt[isocode])<>3) $err=lang("ISO Code must be 3 chars long");
	    	else {
			$sql = "SELECT * from $table WHERE isocode='$dt[isocode]'";
			$phpgw->db->query($sql);
			if ($phpgw->db->num_rows()<>0 and $dt[isocode]<>$dt[oldisocode])
						$err=lang("ISO Code already exists");
		}
	if ($dt[description]=="")		$err=lang("Currency Description Missing");
	if ($dt[exrate]=="")			$err=lang("Currency exchange rate Missing");
	if ($dt[exrate]<=0)			$err=lang("Exchange rate must be > 0");
	if (!is_numeric($dt[exrate]))		$err=lang("Exchange rate must be numeric");
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Currency Delete Validation Checks

    function delete_validate() {

	$err=""; $error=lang('Error') ;
//	Currently, there is no need to perform currency deletion validation checks
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Currency Detail

    function currency_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_isocode',lang('ISO Code'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_exrate',lang('Exchange Rate'));
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('isocode',$dt[isocode]);
	$t->set_var('oldisocode',$dt[oldisocode]);
	$t->set_var('description',$dt[description]);
	$t->set_var('exrate',$dt[exrate]);
	$t->parse('out','report',True);
	}

    }

?>
