<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: header.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

	global	$ckapi ;
	$app = "ck-admin" ;

    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));

    $t->set_file(array('admin_header' => 'header.tpl'));
    $info1 = lang('Administration') ;
    $info2 = lang("You must read each module's index page in detail.") ;
    $info3 = lang("It contains the Terms & Conditions of usage and re-distribution.") ;
    $t->set_var('info',"$info1  [$info2  $info3]");
    $t->set_var('bg_color',$phpgw_info["theme"]["th_bg"]);

    $t->set_var('link_develop',$phpgw->link("/$app/developfilter.php"));
    $t->set_var('lang_develop',lang('Developer Use Only'));
    $t->set_var('link_admin',$phpgw->link("/$app/adminfilter.php"));
    $t->set_var('lang_admin',lang('Admin/Setup'));
    $t->set_var('link_backup',$phpgw->link("/$app/backup.php"));
    $t->set_var('lang_backup',lang('Data Backup'));
    $t->set_var('link_restore',$phpgw->link("/$app/restore.php"));
    $t->set_var('lang_restore',lang('Data Restore'));
    $t->set_var('link_currency',$phpgw->link("/$app/currencyfilter.php"));
    $t->set_var('lang_currency',lang('Currency'));
    $t->set_var('link_remark',$phpgw->link("/$app/remarkfilter.php"));
    $t->set_var('lang_remark',lang('Standard Remark'));
    $t->set_var('link_defaults',$phpgw->link("/$app/defaultsfilter.php"));
    $t->set_var('lang_defaults',lang('Default Values'));
    $t->set_var('link_log',$phpgw->link("/$app/logfilter.php"));
    $t->set_var('lang_log',lang('View Log'));
    $t->set_var('link_multiled',$phpgw->link("/$app/multiled.php"));
    $t->set_var('lang_multiled',lang('Multiple Ledger'));

	$admin = False ;
	$groups = ExecMethod('phpgwapi.accounts.membership') ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']=="Admins")	$admin = True ;
	if (!$admin) {
		$t->set_var(array('link_develop'=>"", 'lang_develop'=>""));
		$t->set_var(array('link_admin'=>"", 'lang_admin'=>""));
		$t->set_var(array('link_restore'=>"", 'lang_restore'=>""));
		$t->set_var(array('link_defaults'=>"", 'lang_defaults'=>""));
		
		$readonly = False ;
		$phpgw->db->query("SELECT readonlygrp FROM ${pre}defaults");
		$phpgw->db->next_record() ;
		$readonlygrp = $phpgw->db->f('readonlygrp') ;
		$groups = ExecMethod('phpgwapi.accounts.membership') ;
		while (list($key,$value)=each($groups))
			if ($groups["$key"]['account_name']==$readonlygrp)	$readonly = True ;
		if ($readonly) {
			$t->set_var(array('link_develop'=>"", 'lang_develop'=>""));
			$t->set_var(array('link_admin'=>"", 'lang_admin'=>""));
			$t->set_var(array('link_backup'=>"", 'lang_backup'=>""));
			$t->set_var(array('link_restore'=>"", 'lang_restore'=>""));
			$t->set_var(array('link_currency'=>"", 'lang_currency'=>""));
			$t->set_var(array('link_remark'=>"", 'lang_remark'=>""));
			$t->set_var(array('link_defaults'=>"", 'lang_defaults'=>""));
			$t->set_var(array('link_log'=>"", 'lang_log'=>""));
			$t->set_var(array('link_multiled'=>"", 'lang_multiled'=>""));
			}
		}
    $t->pparse('out','admin_header');
?>
