<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.vendor.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class vendor {

//---- Vendor Read

    function vendor_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("select * from ${pre}vendor where id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$phpgw->db->query("select * from ${pre}vendortax where vendor_id = '$id' and taxtype=1");
	$phpgw->db->next_record();
	$dt[tax1] = $phpgw->db->f('tax_id') ;
	$phpgw->db->query("select * from ${pre}vendortax where vendor_id = '$id' and taxtype=2");
	$phpgw->db->next_record();
	$dt[tax2] = $phpgw->db->f('tax_id') ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Vendor Detail Validation Checks

    function vendor_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err="";  $error=lang("Error") ;
	if ($dt[name]=="")				$err=lang("Vendor Name Missing") ;
	if ($dt[contact]=="")				$err=lang("Vendor Contact Missing");
	if ($dt[terms] and !is_numeric($dt[terms]))	$err=lang("payment term must be numeric");
	if ($dt[terms]<0 or $dt[terms]>366)		$err=lang("payment term must be 0-366 days");
	if ($dt[phone] and !is_numeric($dt[phone]))	$err=lang("phone# must be numeric") ;
	if ($dt[fax] and !is_numeric($dt[fax]))		$err=lang("fax# must be numeric");
	if ($dt[email] and strpos($dt[email],'@')=='')	$err=lang("invalid email address");
	if ($dt[name]<>$dt[oldname]) {
		$phpgw->db->query("SELECT * from ${pre}vendor where name='$dt[name]'");
		if ($phpgw->db->num_rows()>0)	$err = lang("Vendor Name already exists") ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Vendor Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$invoice = lang('invoice') ; $order = lang('purchase order');
	$errmsg1 = lang("This vendor is in use within an existing") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}ap WHERE vendor='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $invoice id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}po WHERE vendor='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $order id#".$phpgw->db->f('id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Vendor Detail

    function vendor_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_address',lang('Address'));
	$t->set_var('lang_terms',lang('Terms:Net'));
	$t->set_var('lang_day',lang('Days'));
	$t->set_var('lang_tax',lang('Tax Included'));
	$t->set_var('lang_taxnote',lang('Invoice Unit Price listed with Tax Included [Initial Default]'));
	$t->set_var('lang_contact',lang('Contact'));
	$t->set_var('lang_phone',lang('Phone'));
	$t->set_var('lang_fax',lang('Fax'));
	$t->set_var('lang_email',lang('E-Mail'));
	$t->set_var('lang_tax1',lang('Primary Tax'));
	$t->set_var('lang_tax2',lang('Secondary Tax'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_id',lang('Audit ID:'));
	$t->set_var('lang_reserved',lang('Reserved Space'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('name',$dt[name]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('addr1',$dt[addr1]);
	$t->set_var('addr2',$dt[addr2]);
	$t->set_var('addr3',$dt[addr3]);
	$t->set_var('addr4',$dt[addr4]);
	$t->set_var('terms',$dt[terms]);
	if ($dt[taxincluded]=='t' or $dt[taxincluded]=='yes')		$t->set_var('checked',"checked");
	$t->set_var('contact',$dt[contact]);
	$t->set_var('phone',$dt[phone]);
	$t->set_var('fax',$dt[fax]);
	$t->set_var('email',$dt[email]);
	$t->set_var('tax1_selectlist',tax_selectlist("WHERE taxgroup='ap'",$dt[tax1]));
	$t->set_var('tax2_selectlist',tax_selectlist("WHERE taxgroup='ap'",$dt[tax2]));
	$t->set_var('notes',$dt[notes]);
	$t->parse('out','report',True);
	}

//---- Vendor Post Initialisation

    function vendor_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt[taxincluded] = ($dt[taxincluded]=='yes') ? "t" : "f" ;
	$dt[terms] = ($dt[terms]=="") ? 0 : $dt[terms] ;
	}

//---- Vendor Post - PreCommit Routine

    function vendor_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;
	$table = "${pre}vendortax" ;

	if ($op<>'new')
		$phpgw->db->query("DELETE FROM $table WHERE vendor_id=$id and (taxtype=1 or taxtype=2)") ;
	if ($op<>'delete') {
		$sql="INSERT INTO $table (vendor_id,tax_id,taxtype) " ;
		if ($dt[tax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[tax1]','1')");
		if ($dt[tax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[tax2]','2')");
		}
	}

    }

?>
