<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ipmatchfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ap' ;
	$tran = 'ipmatch' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"			) ;
	$ckapi[phrases] = array('lang_title'=> lang("Search among posted Invoices with and w/o PO matched :"),
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$warning=lang("Make sure you have completed all invoice allocation (to POs) before checking on unallocated invoices") ;
	$ckapi[filter][] = array(criteria	=>	lang('Vendor') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.vendor_selectlist("","") ,
				varname		=>	'vendor' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate vendor') );

	$ckapi[filter][] = array(criteria	=>	lang('Currency') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.isocode_selectlist("","") ,
				varname		=>	'isocode' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate currency') );

	$ckapi[filter][] = array(criteria	=>	lang('Invoice Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	lang('Invoice Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	lang('Invoice Number') ,
				type		=>	'input' ,
				varname		=>	'invnumber' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word/number in the invoice number field') );

	$ckapi[filter][] = array(criteria	=>	lang('Unallocated Invoices Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	lang("Click box if only non fully allocated invoices are to be retrieved")."<br><b>".$warning."</b>" );

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
