<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invoicewtlist.php,v 0.0.5 2002/02/11 C K Wu $ */

	$app = 'ck-ar' ;
	$tran = 'invoicewt' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'invoice' ,
				'tran'		=> $tran ,
				'table'		=> "${pre}ar" 			);
	$ckapi[phrases] = array('lang_title'	=> lang("List of Invoices [with Tax]") ,
				'lang_add'	=> lang("Add New Invoice [with Tax]") ,	);
	$ckapi[columns] = array('transdate'	=> lang('Invoice Date') ,
				'duedate'	=> lang('Due Date') ,
				'name'		=> lang('Customer') ,
				'invnumber'	=> lang('Invoice#') ,
				'isocode'	=> lang('Currency') ,
				'amount'	=> lang('Amount') ,
				'id'		=> lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'rpthist'	=> "/$app/invrpthist.php" ,
				'oinvoice'	=> "/$app/${tran}off.php" ,
				'acctran'	=> "/$app/${tran}acctran.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"	) ;

	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_rpthist'	=> lang('Receipt History') ,
				'lang_oinvoice'	=> lang('Invoice / Reminder') ,
				'lang_bulk'	=> lang("Bulk Despatch") ,
				'lang_acctran'	=> lang('Accounting Entries') ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")			) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

	$temp1 = $ckapi[params_sql][temp1];
	$temp2 = $ckapi[params_sql][temp2];
	if ($temp1<>"")	$phpgw->db->query("DROP TABLE $temp1");
	if ($temp2<>"")	$phpgw->db->query("DROP TABLE $temp2");
	ExecMethod('ck-api.process.process_footer') ;

?>
