<?php
 /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: receiptoff.php,v 0.8.1 2004/03/31 C K Wu $ */
	
	$app = 'ck-ar' ;
	$tran = 'receipt' ;
	$noheader = $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=stripslashes($filter);

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array(	'report'	=> "${tran}off.tpl",
				'items'		=> "${tran}off.tpl"));
	$t->set_block('items','item_row','item_section');
	$t->set_block('items','done','done_section');
	$charset = lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$logourl = $phpgw->link("/ck-admin/logoview_image.php","imgfile=$logofile") ;	
	$t->set_var('logo',$logourl);

/*------------- Write Receipt Header to Screen Display ----------------------------*/

	$t->set_var('lang_receipt',strtoupper(lang('OFFICIAL RECEIPT')));
	$t->set_var('lang_rptnumber',lang('Receipt Number'));
	$t->set_var('lang_rdate',lang('Receipt Date'));
	$t->set_var('lang_customer',lang('Customer:'));

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$footer = $phpgw->db->f('inv_remark') ;

	$phpgw->db->query("SELECT * FROM ${pre}receipt WHERE id='$id'");
	$phpgw->db->next_record();
	$t->set_var('rptnumber',$phpgw->db->f('rptnumber')) ;
	$customer = $phpgw->db->f('customer') ;
	$rptamount = $amount = $phpgw->db->f('amount') ;
	$cheque = $phpgw->db->f('cheque') ;
	$t->set_var('rdate',$phpgw->db->f('transdate')) ;
	$t->set_var('amount',$phpgw->db->f('amount')) ;
	$currency = $phpgw->db->f('isocode') ;

	$phpgw->db->query("SELECT * FROM ${pre}customer a, ${pre}org b WHERE a.id='$customer' and contactid=b.id");
	if ($phpgw->db->next_record()) {
		$name = $phpgw->db->f('orgname') ;
		$emailname = lang('Accounts Department') ;
		$contactid = $phpgw->db->f('contactid') ;
		}
	  else	{
		$phpgw->db->query("SELECT * FROM ${pre}customer a,${pre}person b WHERE a.id='$customer' and contactid=b.id");
		$phpgw->db->next_record();
		$name = $emailname = strtoupper($phpgw->db->f('family'))." ".$phpgw->db->f('given') ;
		$contactid = $phpgw->db->f('contactid') ;
		}

	$t->set_var('name',$name) ;
	$phpgw->db->query("SELECT * FROM ${pre}comm WHERE contactid='$contactid' and commcode='bemail'");
	$phpgw->db->next_record();
	$custemail = $phpgw->db->f('commdata') ;
	$phpgw->db->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='billaddr'");
	$phpgw->db->next_record();
	$t->set_var('addr1',$phpgw->db->f('line1')) ;
	$t->set_var('addr2',$phpgw->db->f('line2')) ;
	$t->set_var('addr3',$phpgw->db->f('line3')) ;
	$t->set_var('addr4',$phpgw->db->f('line4')) ;

	$comment1 = lang("Thank you for your payment!") ;
	$comment1 = "<font size=+1>$comment1</font>" ;
	$t->set_var('comment1',$comment1) ;
	$t->set_var('comment2',"") ;
	$comment3 = lang("The validity of this receipt is subject to the clearance") ;
	$comment4 = lang("of all included cheques, remittance and pending funds.") ;
	$comment3 = "<font size=-1>$comment3</font>" ;
	$comment4 = "<font size=-1>$comment4</font>" ;
	$t->set_var('comment3',$comment3) ;
	$t->set_var('comment4',$comment4) ;

/*-----Translating $amount into $longhand------------------------------------------------*/


	$unit =		 array (9 => 'Hundred', 8 => '*', 7 => 'Million',
				6 => 'Hundred', 5 => '*', 4 => 'Thousand',
				3 => 'Hundred', 2 => '*', 1 => '' ) ;
	$digitword = array (	9 => 'Nine', 8 => 'Eight', 7 => 'Seven', 6 => 'Six',  5 => 'Five',
				4 => 'Four', 3 => 'Three', 2 => 'Two',   1 => 'One',  0 => '' ) ;
	$tens =		 array (9 => 'Ninety', 8 => 'Eighty', 7 => 'Seventy', 6 =>'Sixty', 5 =>'Fifty',
				4 => 'Forty', 3 => 'Thirty', 2 => 'Twenty', 1 => 'Ten', 0 =>'' ) ;
	$tenplus =	 array (9 => 'Nineteen', 8 => 'Eighteen', 7 => 'Seventeen',
				6 => 'Sixteen', 5 =>'Fifteen', 4 => 'Forteen',
				3 => 'Thirteen', 2 => 'Twelve', 1 => 'Eleven', 0 =>'' ) ;

$pamount = '$'.sprintf("%01.2f",$amount) ;
$cents  = round(($amount - floor($amount))* 100) % 100 ;

$divider = 100000000 ;
For ($i=9;$divider>=1;$i--)	{
	$digit[$i]=floor($amount/$divider) ;
	$word[$i] = $unit[$i]=='*'? $tens[$digit[$i]] : $digitword[$digit[$i]] ;
	$word[$i] = ($unit[$i+1]=='*' and $digit[$i+1]==1) ? $tenplus[$digit[$i]] : $word[$i] ;
	$word[$i+1] = ($word[$i+1]=='Ten' and $digit[$i]<>0) ? "" : $word[$i+1] ;
	if ($unit[$i]=="Hundred" and $digit[$i]==0) $unit[$i] = "" ;
	if ($unit[$i]=="Million" and $digit[$i]==0 and $digit[$i+1]==0 and $digit[$i+2]==0) $unit[$i]="" ;
	if ($unit[$i]=="Thousand" and $digit[$i]==0 and $digit[$i+1]==0 and $digit[$i+2]==0) $unit[$i]="" ;

	$amount = $amount % $divider ;
	$divider = $divider / 10 ;
	}
$longhand = "" ;
For ($i=9;$i>=1;$i--)	{$longhand .= "$word[$i] $unit[$i] " ; }
$longhand = str_replace("*","",$longhand);

$divider = 10 ;
For ($i=2;$divider>=1;$i--)	{
	$digit[$i]=floor($cents/$divider) ;
	$word[$i] = $unit[$i]=='*'? $tens[$digit[$i]] : $digitword[$digit[$i]] ;
	$word[$i] = ($unit[$i+1]=='*' and $digit[$i+1]==1) ? $tenplus[$digit[$i]] : $word[$i] ;
	$word[$i+1] = ($word[$i+1]=='Ten' and $digit[$i]<>0) ? "" : $word[$i+1] ;
	$cents = $cents % $divider ;
	$divider = $divider / 10 ;
	}
$centhand = "" ;
For ($i=2;$i>=1;$i--)	{$centhand .= "$word[$i] $unit[$i] " ; }
$centhand = str_replace("*","",$centhand) ;
$longhand = trim($centhand)=="" ? $longhand : $longhand." And Cents ".$centhand ;

/*---------------Write Receipt Wording--------------------------------------------------------------*/

	$sql= "SELECT invnumber from ${pre}r_match a, ${pre}ar b WHERE a.receiptid=$id and a.invoiceid=b.id ";
	$phpgw->db->query($sql);
	$invlist = "" ;
	while ($phpgw->db->next_record())	$invlist .= $phpgw->db->f('invnumber').", " ;
	$memo1 = lang("Received from,")." <b>$name</b>" ;
	$memo2 = lang("the sum of,")." <b>$currency$rptamount====</b>" ;
	$memo3 = ($cheque<>"") ? lang("as cheque numbered,")." <b>$cheque</b>" : lang("in cash") ;
	$memo = "<br>$memo1<br>$memo2<br>$memo3<br>" ;
	$invmemo = ($invlist<>"") ? lang("in payment of the invoice(s),")." $invlist.<br><br>" : ".<br><br>" ;
	$amtword = lang("Amount in words,")."<br>$currency <b>$longhand</b> ".lang("ONLY") ;

	$t->set_var('memo',$memo) ;
	$t->set_var('invmemo',$invmemo) ;
	$t->set_var('amtword',$amtword) ;

/*--------------------Write bottom Section------------------------------------------*/

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=lang('Official Receipt Image (Use browser print function to output receipt shown above):');
	$t->set_var('lang_title',$title);
	$note1=lang('[This is a sample subject to tailoring per individual printer & receipt format]');
	$note1a=lang('For email function to work, your email/SMTP/DNS environment must be properly setup.');
	$t->set_var('lang_note1',"$note1<br>$note1a");
	$note2=lang('<b>Warning:  Make sure that the receipt had been properly allocated to the appropriate invoices, before generating, mailing or emailing the official receipt.</b>');
	$t->set_var('lang_note2',$note2);

	$t->set_var('email_action',$phpgw->link("/$app/${tran}off.php","id=$id&filter=$filter")) ;
	$t->set_var('lang_email',lang('Email Receipt'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php","filter=$filter")) ;
	$t->set_var('lang_done',lang('Done'));
	if ($email)	{
		$err = (!($err=="")) ? $err : "" ;
		$error=lang("Error") ; $noemail=lang("No email sent") ;
		$custmsg = lang("Customer") ;	$rptmsg = lang("Receipt") ;
		$successmsg = lang("Email successfully queued for despatch to") ;
		$failuremsg = lang("Email fails to deliver to") ;

		if (!$custemail)				$err = lang("Customer email missing") ;
		if ($custemail and strpos($custemail,'@')=='')	$err = lang("Invalid customer email") ;
		if (!$comemail)					$err = lang("Company return email missing");
		if ($comemail and strpos($comemail,'@')=='')	$err = lang("Invalid company return email");
		if ($err) {
			$note1 = "$custmsg/$name -- $rptmsg/$id -- $noemail -- $error: $err" ;
			$t->set_var('lang_note1',$note1) ;
			}
		   else {
			$recipient = "$emailname < $custemail >" ;
			$subject = lang("Receipt from %1",$company) ;
			$bdmarker = "CK-ERP_".md5(uniqid(time())) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Bcc: $company < $comemail >\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$headers.= "MIME-Version: 1.0\n" ;
			$headers.= "Content-Type: multipart/mixed; boundary=\"$bdmarker\"\n" ;
			$message = "--$bdmarker\n" ;
			$message.= "Content-Type: text/html; charset=$charset\n" ;
			$message.= "Content-Transfer-Encoding: 7bit\n" ;
			$contentid = md5(uniqid(time())) ;
			$htmlpart = str_replace($logourl,"cid:$contentid",$t->parse('out','items',report)) ;
			$message.= str_replace('{done_section}','',$htmlpart) ;
			$message.= "--$bdmarker\n" ;
			$message.= "Content-Type: image/png\n" ;
			$message.= "Content-Transfer-Encoding: base64\n" ;
			$message.= "Content-ID: $contentid\n\n" ;
			$fd = fopen("$logofile","r");
			$message.= chunk_split(base64_encode(fread($fd,filesize($logofile))))."\n";
			$message.= "--$bdmarker--\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$result = mail($recipient,$subject,$message,$headers) ;
			if ($result)	$note1 = "$custmsg/$name -- $rptmsg/$id -- $successmsg $custemail" ;
				else	$note1 = "$custmsg/$name -- $rptmsg/$id -- $failuremsg $custemail" ;
			$t->set_var('lang_note1',$note1);
			}
		}
	$t->parse('done_section','done',true);
	$t->pparse('out','items',report);
	ExecMethod('ck-api.process.process_footer') ;

?>
