<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: worksheetlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'worksheet' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$detail = ($_GET["detail"]) ? $_GET["detail"] : $_POST["detail"] ;
	$where = urldecode(stripslashes($filter)) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array(	'report'	=>"${tran}list.tpl",
				'worksheets'	=>"${tran}list.tpl",
				'summary'	=>"${tran}list.tpl"	));
	$t->set_block('worksheets','worksheet_row','worksheet_section');
	$t->set_block('summary','summary_row','summary_section');
	$db_type = $ckapi[hostsys][dbtype] ;
	$float = ($db_type=="mysql") ? "double" : "float" ;

	$pos = strpos($where,' WHERE ') ;
	$posequal = strpos($where,'=',$pos) ;
	$beginbal = substr($where,$pos+7,$posequal-$pos-7) ;
	$pos = strpos($where,' AND ') ;
	$posequal = strpos($where,'=',$pos) ;
	$endbal = substr($where,$pos+5,$posequal-$pos-5) ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
$tr_color2 = $ckapi[hostsys][tr_color2] ;
$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;
$t->set_var('lang_title',lang('Bank Reconciliation Worksheet'));
$t->set_var('lang_bankac',lang('Bank Account'));
$pos = strpos($where,'chart_id=') ;
$posspace = strpos($where,' ',$pos) ;
$chart_id = substr($where,$pos+10,$posspace-$pos-11) ;
$phpgw->db->query("SELECT accno,description FROM ${pre}chart WHERE id=$chart_id");
$phpgw->db->next_record() ;
$bankac = $phpgw->db->f('accno')."--".$phpgw->db->f('description') ;
$t->set_var('bankac',$bankac);

$note = lang('Item Detail (click column heading to re-sort table)') ;
$t->set_var('lang_note',$note);
$t->set_var('lang_imported',lang('Imported Ledger Items'));
$t->set_var('lang_suspense',lang('Suspense Items'));
$t->set_var('lang_bankitem',lang('Bank Statement Items not included in Ledger'));

$link = "/$app/${tran}list.php" ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,$link,lang('Item Date')));
$t->set_var('sort_source',$nm->show_sort_order($sort,'source',$order,$link,lang('Source')));
$t->set_var('sort_description',$nm->show_sort_order($sort,'description',$order,$link,lang('Description')));
$t->set_var('sort_refnumber',$nm->show_sort_order($sort,'refnumber',$order,$link,lang('Ref Number')));
$t->set_var('sort_cheque',$nm->show_sort_order($sort,'cheque',$order,$link,lang('Cheque')));
$t->set_var('sort_status',$nm->show_sort_order($sort,'status',$order,$link,lang('Status')));
$t->set_var('sort_payment',$nm->show_sort_order($sort,'payment',$order,$link,lang('Payment')));
$t->set_var('sort_receipt',$nm->show_sort_order($sort,'receipt',$order,$link,lang('Receipt')));
$t->set_var('sort_others',$nm->show_sort_order($sort,'others',$order,$link,lang('Others')));
$t->set_var('sort_suspense',$nm->show_sort_order($sort,'suspense',$order,$link,lang('Suspense<br>Item')));
$t->set_var('sort_cashin',$nm->show_sort_order($sort,'cashin',$order,$link,lang('Cash<br>In')));
$t->set_var('sort_cashout',$nm->show_sort_order($sort,'cashout',$order,$link,lang('Cash<br>Out')));
$t->set_var('sort_interest',$nm->show_sort_order($sort,'interest',$order,$link,lang('Bank<br>Interest')));
$t->set_var('sort_charge',$nm->show_sort_order($sort,'charge',$order,$link,lang('Bank<br>Charge')));
$t->set_var('sort_adjustment',$nm->show_sort_order($sort,'adjustment',$order,$link,lang('Bank<br>Adj')));
$t->set_var('sort_id',$nm->show_sort_order($sort,'id',$order,$link,lang('Audit Id')));

$user = $ckapi[hostsys][username];
$temp = "${pre}wsl".$user.time() ;
$sql =	"CREATE TABLE $temp AS " ;
$sql.=	"SELECT *,amount as payment,amount as receipt,amount as others,amount as suspense," ;
$sql.=	"amount as cashin,amount as cashout,amount as interest,amount as charge," ;
$sql.=	"amount as adjustment FROM ${pre}bkr_trans $where ORDER BY amount" ;
//$sql.=	"amount as adjustment,trans_id as id FROM ${pre}bkr_trans $where " ;
$phpgw->db->query($sql);
$phpgw->db->query("UPDATE $temp SET payment='' WHERE source<>'APPY' and source<>'PYPY'");
$phpgw->db->query("UPDATE $temp SET receipt='' WHERE source<>'ARRT'");
$phpgw->db->query("UPDATE $temp SET others='' WHERE source<>'GLJL'");
$phpgw->db->query("UPDATE $temp SET suspense='' WHERE source<>'SUSP'");
$phpgw->db->query("UPDATE $temp SET cashin='' WHERE source<>'SICI'");
$phpgw->db->query("UPDATE $temp SET cashout='' WHERE source<>'SICO'");
$phpgw->db->query("UPDATE $temp SET interest='' WHERE source<>'SIBI'");
$phpgw->db->query("UPDATE $temp SET charge='' WHERE source<>'SIBC'");
$phpgw->db->query("UPDATE $temp SET adjustment='' WHERE source<>'SIBA'");
$phpgw->db->query("UPDATE $temp SET amount='' WHERE status<>'c' or status is null");

if (!$order) $order = "transdate" ;	else $detail = "yes" ;
if (!$sort)  $sort = "ASC" ;
$phpgw->db->query("SELECT * FROM $temp ORDER BY $order $sort") ;

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'source'	=> "",
				'description'	=> "",
				'refnumber'	=> "",
				'cheque'	=> "",
				'status'	=> "",
				'payment'	=> "",
				'receipt'	=> "",
				'others'	=> "",
				'suspense'	=> "",
				'cashin'	=> "",
				'cashout'	=> "",
				'interest'	=> "",
				'charge'	=> "",
				'adjustment'	=> "",
				'id'		=> ""			));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('worksheet_section','worksheet_row',True);
	}
while ($phpgw->db->next_record()) {
	$status = "" ;
	if ($phpgw->db->f('status')=='c')	$status = "cleared" ;
	if ($phpgw->db->f('status')=='s')	$status = "stopped" ;
	$payment = ($phpgw->db->f('payment')==0) ? '' : $phpgw->db->f('payment') ;
	$receipt = ($phpgw->db->f('receipt')==0) ? '' : $phpgw->db->f('receipt') ;
	$others = ($phpgw->db->f('others')==0) ? '' : $phpgw->db->f('others') ;
	$suspense = ($phpgw->db->f('suspense')==0) ? '' : $phpgw->db->f('suspense') ;
	$cashin = ($phpgw->db->f('cashin')==0) ? '' : $phpgw->db->f('cashin') ;
	$cashout = ($phpgw->db->f('cashout')==0) ? '' : $phpgw->db->f('cashout') ;
	$interest = ($phpgw->db->f('interest')==0) ? '' : $phpgw->db->f('interest') ;
	$charge = ($phpgw->db->f('charge')==0) ? '' : $phpgw->db->f('charge') ;
	$adjustment = ($phpgw->db->f('adjustment')==0) ? '' : $phpgw->db->f('adjustment') ;
	$t->set_var(array(
		'transdate'	=> $phpgw->db->f('transdate'),
		'source'	=> $phpgw->db->f('source'),
		'description'	=> $phpgw->db->f('description'),
		'refnumber'	=> $phpgw->db->f('refnumber'),
		'cheque'	=> $phpgw->db->f('cheque'),
		'status'	=> $status,
		'payment'	=> $payment,
		'receipt'	=> $receipt,
		'others'	=> $others,
		'suspense'	=> $suspense,
		'cashin'	=> $cashin,
		'cashout'	=> $cashout,
		'interest'	=> $interest,
		'charge'	=> $charge,
		'adjustment'	=> $adjustment,
		'id'		=> $phpgw->db->f('id')				));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('worksheet_section','worksheet_row',true);
	}

$phpgw->db->query("SELECT sum(payment) as payment, sum(amount) as cleared FROM $temp WHERE source='APPY' or source='PYPY'");
$phpgw->db->next_record() ;
$payment = $phpgw->db->f('payment') ;
$paymentc= $phpgw->db->f('cleared') ;
$phpgw->db->query("SELECT sum(receipt) as receipt, sum(amount) as cleared FROM $temp WHERE source='ARRT'");
$phpgw->db->next_record() ;
$receipt = $phpgw->db->f('receipt') ;
$receiptc = $phpgw->db->f('cleared') ;
$phpgw->db->query("SELECT sum(others) as others, sum(amount) as cleared FROM $temp WHERE source='GLJL'");
$phpgw->db->next_record() ;
$others = $phpgw->db->f('others') ;
$othersc = $phpgw->db->f('cleared') ;
$phpgw->db->query("SELECT sum(suspense) as suspense, sum(amount) as cleared FROM $temp WHERE source='SUSP'");
$phpgw->db->next_record() ;
$suspense = $phpgw->db->f('suspense') ;
$suspensec = $phpgw->db->f('cleared') ;
$phpgw->db->query("SELECT sum(cashin) as cashin, sum(amount) as cleared FROM $temp WHERE source='SICI'");
$phpgw->db->next_record() ;
$cashin = $phpgw->db->f('cashin') ;
$cashinc = $phpgw->db->f('cleared') ;
$phpgw->db->query("SELECT sum(cashout) as cashout, sum(amount) as cleared FROM $temp WHERE source='SICO'");
$phpgw->db->next_record() ;
$cashout = $phpgw->db->f('cashout') ;
$cashoutc = $phpgw->db->f('cleared') ;
$phpgw->db->query("SELECT sum(interest) as interest, sum(amount) as cleared FROM $temp WHERE source='SIBI'");
$phpgw->db->next_record() ;
$interest = $phpgw->db->f('interest') ;
$interestc = $phpgw->db->f('cleared') ;
$phpgw->db->query("SELECT sum(charge) as charge, sum(amount) as cleared FROM $temp WHERE source='SIBC'");
$phpgw->db->next_record() ;
$charge = $phpgw->db->f('charge') ;
$chargec = $phpgw->db->f('cleared') ;
$phpgw->db->query("SELECT sum(adjustment) as adjustment, sum(amount) as cleared FROM $temp WHERE source='SIBA'");
$phpgw->db->next_record() ;
$adjustment = $phpgw->db->f('adjustment') ;
$adjustmentc = $phpgw->db->f('cleared') ;

$t->set_var('tr_color',$ckapi[hostsys][th_bg]);
$t->set_var(array(
	'transdate'	=> lang('Total'),
	'source'	=> '',
	'description'	=> lang('Amount'),
	'refnumber'	=> '',
	'cheque'	=> '',
	'status'	=> '',
	'payment'	=> $payment,
	'receipt'	=> $receipt,
	'others'	=> $others,
	'suspense'	=> $suspense,
	'cashin'	=> $cashin,
	'cashout'	=> $cashout,
	'interest'	=> $interest,
	'charge'	=> $charge,
	'adjustment'	=> $adjustment,
	'id'		=> ''));
$t->parse('worksheet_section','worksheet_row',true);
$t->set_var(array(
	'transdate'	=> lang('Total'),
	'source'	=> '',
	'description'	=> lang('Cleared'),
	'refnumber'	=> '',
	'cheque'	=> '',
	'status'	=> '',
	'payment'	=> $paymentc,
	'receipt'	=> $receiptc,
	'others'	=> $othersc,
	'suspense'	=> $suspensec,
	'cashin'	=> $cashinc,
	'cashout'	=> $cashoutc,
	'interest'	=> $interestc,
	'charge'	=> $chargec,
	'adjustment'	=> $adjustmentc,
	'id'		=> ''));
$t->parse('worksheet_section','worksheet_row',true);

$paymentnc	= $payment-$paymentc;
$receiptnc	= $receipt-$receiptc;
$othersnc	= $others-$othersc;
$suspensenc	= $suspense-$suspensec;
$cashinnc	= $cashin-$cashinc;
$cashoutnc	= $cashout-$cashoutc;
$interestnc	= $interest-$interestc;
$chargenc	= $charge-$chargec;
$adjustmentnc	= $adjustment-$adjustmentc;
$t->set_var(array(
	'transdate'	=> lang('Total'),
	'source'	=> lang('Not'),
	'description'	=> lang('Cleared'),
	'refnumber'	=> '',
	'cheque'	=> '',
	'status'	=> '',
	'payment'	=> $paymentnc,
	'receipt'	=> $receiptnc,
	'others'	=> $othersnc,
	'suspense'	=> $suspensenc,
	'cashin'	=> $cashinnc,
	'cashout'	=> $cashoutnc,
	'interest'	=> $interestnc,
	'charge'	=> $chargenc,
	'adjustment'	=> $adjustmentnc,
	'id'		=> ''));
$t->parse('worksheet_section','worksheet_row',true);

// ---------------------------- Print Reconciliation Section----------------------------------------

$note1a = lang('Auditor should check in detail each suspense item.') ;
$note1b = lang('If appropriate, recommend write-off or adjustment according to local GAAP and/or legal requirement.') ;
$note2a = lang('Bank Statement items not included in ledger and with financial effect occurring before the reconciliation day should be entered back into the ledger.') ;
$note2b =lang('Subsequently, reconciliation should be re-done to present a simplified Bank Reconciliation.') ;
$note3a = lang('Long outstanding unpresented check should be voided or stopped via appropriate banking procedure.') ;
$note3b = lang('The associated payment should be reversed.') ;
$note3c = lang("The associated payment liability should be placed in the main ledger's suspense account.") ;
$note4a = lang('Since this worksheet is not persistent over time, a copy of the Bank Reconciliation Statement should be printed after the worksheet is completed.') ;
$note5  = lang("Non-payment items that (had) appeared in bank statement should also be flagged as 'cleared' in the detail worksheet.") ;
$note6  = lang("Be careful not to list an item as both uncleared Ledger Item and as Suspense Item.") ;

$t->set_var('lang_note1',lang("Note 1:")."  $note1a  $note1b");
$t->set_var('lang_note2',lang("Note 2:")."  $note2a  $note2b");
$t->set_var('lang_note3',lang("Note 3:")."  $note3a  $note3b  $note3c");
$t->set_var('lang_note4',lang("Note 4:")."  $note4a");
$t->set_var('lang_note5',lang("Note 5:")."  $note5");
$t->set_var('lang_note6',lang("Note 6:")."  $note6");

$t->set_var('lang_reconciliation',lang('Reconciliation'));
$t->set_var('lang_importednc',lang('Imported Ledger Items - not yet cleared thru Bank Statement'));

$t->set_var('lang_date',lang('Date'));
$t->set_var('lang_ledgerbal',lang('Ledger<br>Balance'));
$t->set_var('lang_payment',lang('Payment'));
$t->set_var('lang_receipt',lang('Receipt'));
$t->set_var('lang_others',lang('Others'));
$t->set_var('lang_suspense',lang('Suspense'));
$t->set_var('lang_cashin',lang('Cash<br>In'));
$t->set_var('lang_cashout',lang('Cash<br>Out'));
$t->set_var('lang_interest',lang('Bank<br>Interest'));
$t->set_var('lang_charge',lang('Bank<br>Charge'));
$t->set_var('lang_adjustment',lang('Bank<br>Adj'));
$t->set_var('lang_bankbal',lang('Bank<br>Balance'));
$t->set_var('lang_adjust',lang('Adjusted Balance')) ;
$recnote = lang('Remember to check the last reconciliation to see if any item needs to be c/f or be discarded') ;
$t->set_var('lang_recnote',$recnote);

$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$pos = strpos($where,'transdate>=') ;
$posspace = strpos($where,' ',$pos) ;
$from = substr($where,$pos+12,10) ;
$t->set_var('from',$from);
$sql =	"SELECT sum(amount) as balance FROM ${pre}acc_trans " ;
$sql.=	"WHERE chart_id='$chart_id' and transdate<'$from'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record() ;
$t->set_var('beginledbal',-$phpgw->db->f('balance'));
$t->set_var('beginbankbal',$beginbal);
$pos = strpos($where,'transdate<=') ;
$posspace = strpos($where,' ',$pos) ;
$to = substr($where,$pos+12,10) ;
$t->set_var('to',$to);
$sql =	"SELECT sum(amount) as balance FROM ${pre}acc_trans " ;
$sql.=	"WHERE chart_id='$chart_id' and transdate<'$to'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record() ;
$endledbal = -$phpgw->db->f('balance') ;
$t->set_var('endledbal',$endledbal);
$t->set_var('endbankbal',$endbal);

$adjustbankbal = $endbal+$paymentnc+$receiptnc+$othersnc+$suspensenc ;
$adjustledbal = $endledbal+$cashin+$cashout+$interest+$charge+$adjustment ;
$t->set_var('adjustbankbal',$adjustbankbal);
$t->set_var('adjustledbal',$adjustledbal);

$t->set_var('lang_discrepancy',lang('Discrepancy'));
$t->set_var('discrepancy',sprintf("%01.2f",$adjustbankbal-$adjustledbal));

$phpgw->db->query("DROP TABLE $temp");

$button = ($detail=='yes') ? lang('Suppress Item Detail') : lang('Show Item Detail') ;
$t->set_var('lang_add',$button);
if ($detail<>"yes")	$t->set_var('worksheet_section','');
$detail = ($detail=='yes') ? '' : 'yes' ;
$getstr = "filter=$filter&detail=$detail" ;
$t->set_var('add_action',$phpgw->link("/$app/${tran}list.php",$getstr));

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','worksheets','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
