<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.image.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class image {

//---- Image Read

    function image_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * from $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	if ($table=="${pre}person")	$dt[name] = $dt[prsnumber] ;
	if ($table=="${pre}org")	$dt[name] = $dt[orgnumber] ;
	
	return $dt ;
	}

//---- Image Detail Validation Checks

    function image_validate() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$maxfile = 10240 ;
	$newimg = "/tmp/$dt[id].ck-erp.img" ;
	if (!$dt[post] and !is_file($newimg))	$err = lang("Image must be previewed before update") ;
	if (is_file($newimg) and filesize($newimg)>$maxfile)
		$err = lang("File size too large (max-10K)") ;
	if ($dt['imagetype']<>"image")
		$err = lang("Image must be of type (image), check if image had been previewed") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Image Detail

    function image_write() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('lang_name',lang("Name/#"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_oldimage',lang('Existing Image'));
	$t->set_var('lang_browse',lang("Click [Browse] to choose new image's file name, then click [Preview New Image]"));
	$t->set_var('lang_newimage',lang('New Image'));

	$id = $dt[id] ;
	$t->set_var('name',$dt[name]);
	$t->set_var('id',$id);
	$t->set_var('table',$ckapi[params][table]);
	$t->set_var('control',$dt[control]);
	$t->set_var('imagetype',$dt['imagetype']);
	$imgdir = $ckapi[hostsys][dataarea]."/images" ;
	$oldimg = "$imgdir/$id.png" ;
	$t->set_var('oldimage',$phpgw->link("/$app/contactview_image.php","imgfile=$oldimg"));
	if (!isset($dt[post]) and isset($_FILES['imagefile'])) {
		$tempimg = $_FILES['imagefile']['tmp_name'] ;
		$types = explode("/",$_FILES['imagefile']['type']) ;
		$dt['imagetype'] = $types[0] ;
		$t->set_var('imagetype',$dt['imagetype']);
		exec("rm -f /tmp/*.ck-erp.img") ;
		$newimg = "/tmp/$id.ck-erp.img" ;
		move_uploaded_file($tempimg, $newimg) ;
		}
	$t->set_var('newimage',$phpgw->link("/$app/contactview_image.php","imgfile=$newimg"));
	$t->parse('out','report',True);
	}

//---- Reformat image Data (image Preview)

    function image_transform() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$preview = &$ckapi[buttons][preview] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	if (isset($preview)) {
		$func = "${class}_validate" ;
		$err = $this->$func() ;
		if ($err) {
			$t->set_var('newimage',$phpgw->link("/$app/contactview_image.php"));
			$t->set_var('message',$err) ;
			}
		}
	}

//---- image Post - PreCommit Routine

    function image_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	if ($op<>'delete') {
		$imgdir = $ckapi[hostsys][dataarea]."/images" ;
		umask(000) ;
		if (!is_dir($imgdir))	mkdir($imgdir,0700) ;
		$newimg = "/tmp/$id.ck-erp.img" ;
		$fd = fopen($newimg,"r");
		$contents = fread($fd,filesize($newimg)) ;
		fclose($fd) ;
		$image = "$imgdir/$id.png" ;
		umask(000) ;
		if ($fp = fopen($image, "w")) {fputs($fp, $contents); fclose($fp);}
		}
	}

    }

?>
