<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.8.1 2004/07/31 C K Wu $ */

	$app = 'ck-crm' ;
	$tran = 'control' ;
	include('../ck-api/ckapi.inc.php') ;

	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

/*---------------------------------------------------------------------------------*/

    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir(ck-hr));
    $t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('message',"");
	$t->set_var('lang_control_report', lang('Customer Relationship Audit Control Report'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_system_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_date', lang('Status Date'));
	$t->set_var('lang_system_date', lang('System Date'));
	$t->set_var('lang_customer', lang('Customer'));
	$t->set_var('lang_contract', lang('Contract'));
	$t->set_var('lang_helpcase', lang('Helpdesk cases'));
	$t->set_var('lang_helpcall', lang('Help calls'));
	$t->set_var('lang_salecase', lang('Sales cases'));
	$t->set_var('lang_salecall', lang('Sale calls'));
	$t->set_var('lang_category', lang('CRM category'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Database Info---------------------------------*/

$na = lang("N/A") ;
$t->set_var('status_date',$rdate) ;
$t->set_var('customer_count',$na) ;
$t->set_var('latest_customer_id',$na) ;
$t->set_var('contract_count',$na) ;
$t->set_var('latest_contract_id',$na) ;
$t->set_var('category_count',$na) ;
$t->set_var('latest_category_id',$na) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}helpcase WHERE start<='$rdate'";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('helpcase_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_helpcase_id',$phpgw->db->f('max_id')) ;

$sql = "SELECT count(a.id) as cnt, max(a.id) as max_id from ${pre}helpcall a, ${pre}helpcase b ";
$sql.= "WHERE caseid=b.id and start<='$rdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('helpcall_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_helpcall_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}salecase WHERE start<='$rdate'";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('salecase_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_salecase_id',$phpgw->db->f('max_id')) ;

$sql = "SELECT count(a.id) as cnt, max(a.id) as max_id from ${pre}salecall a, ${pre}salecase b ";
$sql.= "WHERE caseid=b.id and start<='$rdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('salecall_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_salecall_id',$phpgw->db->f('max_id')) ;


$t->set_var('system_date',date("Y-m-d",time())) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}customer";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_customer_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_customer_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}scontract";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_contract_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_contract_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}helpcase";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_helpcase_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_helpcase_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}helpcall";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_helpcall_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_helpcall_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}salecase";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_salecase_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_salecase_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}salecall";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_salecall_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_salecall_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(id) as category_count, max(id) as max_id from ${pre}category WHERE app='$app'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_category_count',$phpgw->db->f('category_count')) ;
$t->set_var('sys_latest_category_id',$phpgw->db->f('max_id')) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
