<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.customer.inc.php,v 0.8.1 2004/08/31 C K Wu $ */

    class customer {

//---- Customer List Link Adjustement

    function customer_list_adjust() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	$bulkcnt = &$ckapi[params][bulkcnt] ;
	
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$getstr = "order=$order&sort=$sort&id=$dt[id]&filter=$filter" ;
	if (substr_count($dt[name],'____')<=0) {
		$t->set_var('bulk_action',$phpgw->link("/$app/${tran}bulk.php",$getstr)) ;
		$t->set_var('disabled','') ;
		}
	}

//---- Customer Read

    function customer_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("select * from ${pre}customer where id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$phpgw->db->query("select * from ${pre}org where id='$dt[contactid]'");
	$phpgw->db->next_record();
	if ($phpgw->db->num_rows()>0)	$dt[orgid] = $dt[contactid] ;
		else			$dt[prsid] = $dt[contactid] ;
	$phpgw->db->query("select * from ${pre}customertax where customer_id = '$id' and taxtype=1");
	$phpgw->db->next_record();
	$dt[tax1] = $phpgw->db->f('tax_id') ;
	$phpgw->db->query("select * from ${pre}customertax where customer_id = '$id' and taxtype=2");
	$phpgw->db->next_record();
	$dt[tax2] = $phpgw->db->f('tax_id') ;
	if ($op=='copy')	$dt[creditlimit]=0;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Customer Detail Validation Checks

    function customer_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error");
	if ($dt[orgid]<>"")	$dt[contactid] = $dt[orgid] ;
	if ($dt[prsid]<>"")	$dt[contactid] = $dt[prsid] ;
	if ($dt[contactid]<>$dt[oldcontactid]) {
		$phpgw->db->query("SELECT * from ${pre}customer where contactid='$dt[contactid]'");
		if ($phpgw->db->num_rows()>0)		$err = lang("Org/Person belongs to an existing customer") ;
		}
	if ($dt[orgid]=="" and $dt[prsid]=="")		$err=lang("Both Org and Person choices are blank");
	if ($dt[orgid]<>"" and $dt[prsid]<>"")		$err=lang("Customer cannot be both Org and Person");
	if ($dt[terms] and !is_numeric($dt[terms]))	$err=lang("payment term must be numeric");
	if ($dt[terms]<0 or $dt[terms]>366)		$err=lang("payment term must be 0-366 days");
	if ($dt[discount] and !is_numeric($dt[discount]))	$err=lang("discount must be numeric");
	if ($dt[discount]<0 or $dt[discount]>1)		$err=lang("discount must be 0-1");
	
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Customer Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$invoice = lang('invoice') ; $order = lang('sales order');
	$quote = lang('quotation') ; $cashsale = lang('cash sale') ;
	$errmsg1 = lang("This customer is in use within an existing") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}ar WHERE customer='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $invoice id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}so WHERE customer='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $order id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}quote WHERE customer='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $quote id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}pos WHERE customer='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $cashsale id#".$phpgw->db->f('id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Customer Detail

    function customer_write() {
	global $ckapi,$phpgw,$pre ;

	$dt = &$ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;

	$phpgw->db->query("SELECT nativecurr from ${pre}defaults");
	$phpgw->db->next_record();
	$nativecurr = $phpgw->db->Record[nativecurr] ;

	$t->set_var('lang_id',lang('Audit ID:'));
	$t->set_var('lang_org',lang('Organization'));
	$t->set_var('lang_prs',lang('Person'));
	$t->set_var('lang_catid',lang('Category'));
	$t->set_var('lang_terms',lang('Terms:Net'));
	$t->set_var('lang_day',lang('Days'));
	$t->set_var('lang_tax',lang('Tax Included'));
	$t->set_var('lang_taxnote',lang('Invoice Unit Price listed with Tax Included [Initial Default]'));
	$t->set_var('lang_creditlimit',lang('Credit Limit'));
	$t->set_var('nativecurr',$nativecurr);
	$t->set_var('lang_discount',lang('%Discount'));
	$t->set_var('lang_percent',lang('%'));
	$t->set_var('lang_tax1',lang('Primary Tax'));
	$t->set_var('lang_tax2',lang('Secondary Tax'));

	if ($op=='edit' and is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('org_selectlist',contactid_selectlist('',$dt[orgid],'org'));
	$t->set_var('prs_selectlist',contactid_selectlist('',$dt[prsid],'person'));
	$lang_cust = lang('Customer') ;
	$t->set_var('catid_selectlist',category_selectlist("WHERE app='ck-crm' and type='$lang_cust'",$dt[catid]));
	$t->set_var('terms',$dt[terms]);
	$t->set_var('creditlimit',$dt[creditlimit]);
	$t->set_var('discount',$dt[discount]);
	$discpct = $dt[discount]*100 ;
	$t->set_var('lang_discnote',lang("i.e.")." $discpct %");
	if ($dt[taxincluded]=='t' or $dt[taxincluded]=='yes')		$t->set_var('checked',"checked");
	$t->set_var('tax1_selectlist',tax_selectlist("WHERE taxgroup='ar'",$dt[tax1]));
	$t->set_var('tax2_selectlist',tax_selectlist("WHERE taxgroup='ar'",$dt[tax2]));
	$t->parse('out','report',True);
	}

//---- Customer Post Initialisation

    function customer_post_init() {
	global $ckapi,$phpgw,$pre ;

	$dt = &$ckapi[params_post][dt] ;
	$dt[contactid] = ($dt[orgid]<>'') ? $dt[orgid] : $dt[prsid] ;
	if ($dt[orgid]<>'')	$phpgw->db->query("SELECT orgnumber as name FROM ${pre}org WHERE id=$dt[orgid]") ;
	if ($dt[prsid]<>'')	$phpgw->db->query("SELECT prsnumber as name FROM ${pre}person WHERE id=$dt[prsid]") ;
	$phpgw->db->next_record();
	$dt[name] = $phpgw->db->f('name') ;
	$dt[taxincluded] = ($dt[taxincluded]=='yes') ? "t" : "f" ;
	$dt[discount] = ($dt[discount]=="") ? 0 : $dt[discount] ;
	$dt[creditlimit] = ($dt[creditlimit]=="") ? 0 : $dt[creditlimit] ;
	$dt[terms] = ($dt[terms]=="") ? 0 : $dt[terms] ;
	}

//---- Customer Post - PreCommit Routine

    function customer_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;
	$table = "${pre}customertax" ;

	if ($op<>'new')
		$phpgw->db->query("DELETE FROM $table WHERE customer_id=$id and (taxtype=1 or taxtype=2)") ;
	if ($op<>'delete') {
		$sql="INSERT INTO $table (customer_id,tax_id,taxtype) " ;
		if ($dt[tax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[tax1]','1')");
		if ($dt[tax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[tax2]','2')");
		}
	}

    }
