<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.limit.inc.php,v 0.8.1 2004/08/31 C K Wu $ */

    class limit {

//---- limit Read

    function limit_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("select * from ${pre}customer where id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$phpgw->db->query("select * from ${pre}org where id='$dt[contactid]'");
	$phpgw->db->next_record();
	if ($phpgw->db->num_rows()>0)	$dt[orgid] = $dt[contactid] ;
		else			$dt[prsid] = $dt[contactid] ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- limit Detail Validation Checks

    function limit_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error");
	if ($dt[creditlimit]=="")				$err=lang("Credit Limit Missing");
	if ($dt[creditlimit] and !is_numeric($dt[creditlimit]))	$err=lang("Credit Limit must be numeric");
	if ($dt[creditlimit]<0)					$err=lang("Credit Limit must be +ve");
	
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write limit Detail

    function limit_write() {
	global $ckapi,$phpgw,$pre ;

	$dt = &$ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;

	$phpgw->db->query("SELECT nativecurr from ${pre}defaults");
	$phpgw->db->next_record();
	$nativecurr = $phpgw->db->Record[nativecurr] ;

	$t->set_var('lang_id',lang('Audit ID:'));
	$t->set_var('lang_org',lang('Organization'));
	$t->set_var('lang_prs',lang('Person'));
	$limit = lang('Credit Limit') ;
	$t->set_var('lang_creditlimit',"$limit [$nativecurr]");
	$t->set_var('nativecurr',$nativecurr);

	if ($op=='edit' and is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$dt[orgid] = ($dt[orgid]=="") ? 0 : $dt[orgid] ;
	$dt[prsid] = ($dt[prsid]=="") ? 0 : $dt[prsid] ;
	$t->set_var('org_selectlist',contactid_selectlist("WHERE id='$dt[orgid]'",$dt[orgid],'org'));
	$t->set_var('prs_selectlist',contactid_selectlist("WHERE id='$dt[prsid]'",$dt[prsid],'person'));
	$lang_cust = lang('Customer') ;
	$t->set_var('creditlimit',$dt[creditlimit]);
	$t->parse('out','report',True);
	}

//---- limit Post Initialisation

    function limit_post_init() {
	global $ckapi,$phpgw,$pre ;

	$dt = &$ckapi[params_post][dt] ;
	$creditlimit = $dt[creditlimit] ;
	$phpgw->db->query("select * from ${pre}customer where id='$dt[id]'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[creditlimit] = $creditlimit ;
	}

    }
