<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.salecase.inc.php,v 0.8.1 2004/08/31 C K Wu $ */

    class salecase {

//---- Callcase List SQL Formation

    function salecase_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$lang_noncustomer = lang('Non-Customer') ;
	$user = $ckapi[hostsys][username] ;
	$ckapi[params_sql][temp] = $temp = "${pre}tmpsalecase".$user.time() ;
	$fields = "casenumber,name,description,customer,start,a.id as id" ;
	$sql = "SELECT $fields FROM ${pre}salecase a,${pre}customer b, ${pre}org c WHERE a.customer = b.id and b.contactid=c.id" ;
	$phpgw->db->query("CREATE TABLE $temp AS $sql");
	$fields = "casenumber,name,description,customer,start,a.id as id" ;
	$sql = "SELECT $fields FROM ${pre}salecase a,${pre}customer b, ${pre}person c WHERE a.customer = b.id and b.contactid=c.id" ;
	$phpgw->db->query("INSERT INTO $temp $sql") ;
	$fields = "casenumber,'$lang_noncustomer' as name,description,customer,start,id" ;
	$sql = "SELECT $fields FROM ${pre}salecase WHERE customer='0'" ;
	$phpgw->db->query("INSERT INTO $temp $sql") ;
	$last10 = substr($where,strlen($where)-10,10) ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$lang_salecall=lang('salecall'); $lang_closew=lang('close_win'); $lang_closel=lang('close_lost');
		$phpgw->db->query("SELECT id FROM ${pre}category where app='$app' and type='$lang_salecall' and name='$lang_closew'");
		$phpgw->db->next_record() ;
		$clowid = $phpgw->db->f('id') ;
		$phpgw->db->query("SELECT id FROM ${pre}category where app='$app' and type='$lang_salecall' and name='$lang_closel'");
		$phpgw->db->next_record() ;
		$clolid = $phpgw->db->f('id') ;
		if ($ckapi[hostsys][dbtype]=="mysql")	{
			$sql = "SELECT a.* FROM $temp a LEFT JOIN ${pre}salecall b " ;
			$sql.= "ON caseid=a.id and (callcatid='$clowid' or callcatid='$clolid') " ;
			$sql.= "WHERE b.id is null and $where" ;
			}
		  else	{
		  	$sql = "SELECT * FROM $temp WHERE $where EXCEPT " ;
			$sql.=	"SELECT a.* FROM $temp a, ${pre}salecall b " ;
			$sql.=	"WHERE caseid=a.id and (callcatid='$clowid' or callcatid='$clolid')"; 
			}
		}
	  else	$sql =	"SELECT * FROM $temp WHERE $where ORDER BY $order $sort";
	return $sql ;
	}

//---- salecase Data Read

    function salecase_read() {
	global $ckapi,$phpgw,$pre ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$table = $pre."salecall" ;
	$phpgw->db->query("SELECT * FROM $table WHERE caseid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt["calldate$i"]	=	$phpgw->db->f('calldate') ;
		$dt["calltime$i"]	=	$phpgw->db->f('calltime') ;
		$dt["callcatid$i"]	=	$phpgw->db->f('callcatid') ;
		$dt["mediacatid$i"]	=	$phpgw->db->f('mediacatid') ;
		$dt["prsfrom$i"]	=	$phpgw->db->f('prsfrom') ;
		$dt["prsto$i"]		=	$phpgw->db->f('prsto') ;
		$dt["statecatid$i"]	=	$phpgw->db->f('statecatid') ;
		$dt["assigned$i"]	=	$phpgw->db->f('assigned') ;
		$dt["actioned$i"]	=	$phpgw->db->f('actioned') ;
		$dt["deadline$i"]	=	$phpgw->db->f('deadline') ;
		$dt["hours$i"]		=	$phpgw->db->f('hours') ;
		$dt["summary$i"]	=	$phpgw->db->f('summary') ;
		$dt["rowno$i"]		=	"dummy" ;
		}
	if ($ckapi[params_post][op]=="edit")	$dt[oldcasenumber] = $dt[casenumber] ;
	
	return $dt ;
	}

//---- salecase Detail Validation Checks

    function salecase_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error");	$row = lang("Row") ;
	$lang_salecall = lang('salecall'); $lang_initial = lang('initial') ;
	$lang_closew = lang('close_win') ; $lang_closel = lang('close_lost') ;
	$phpgw->db->query("SELECT id FROM ${pre}category where app='$app' and type='$lang_salecall' and name='$lang_initial'");
	$phpgw->db->next_record() ;
	$initial_id = $phpgw->db->f('id') ;
	$phpgw->db->query("SELECT id FROM ${pre}category where app='$app' and type='$lang_salecall' and name='$lang_closew'");
	$phpgw->db->next_record() ;
	$closew_id = $phpgw->db->f('id') ;
	$phpgw->db->query("SELECT id FROM ${pre}category where app='$app' and type='$lang_salecall' and name='$lang_closel'");
	$phpgw->db->next_record() ;
	$closel_id = $phpgw->db->f('id') ;
	if ($dt[casenumber]=="")			$err=lang("Case Number Missing");
	if ($dt[description]=="")			$err=lang("Case Description Missing");
	if ($dt[casecatid]=="")				$err=lang("Case Category ID Missing");
	if ($dt[monitor]=="")				$err=lang("Monitoring Officer ID Missing");
	if ($dt[customer]=="")				$err=lang("Customer ID Missing");
	if ($dt[itemid]=="")				$err=lang("Product/Service ID Missing");
	$amount = $dt[amount] ;
	if ($amount=="")				$err=lang("Expected Sale Amount Missing");
	  else	if (!is_numeric($amount))		$err=lang("Expected Sale Amount must be numeric");
		  else if ($amount<0)			$err=lang("Expected Sale Amount must be +ve");
	$prospect = $dt[prospect] ;
	if ($prospect=="")				$err=lang("Chance of Sale Win Missing");
	  else	if (!is_numeric($prospect))		$err=lang("Chance of Sale Win must be numeric");
		  else if ($prospect<0 or $prospect>1)	$err=lang("Chance of Sale Win must be >=0 and <=1");
	if ($dt[pricatid]=="")				$err=lang("Priority Category ID Missing");
	if ($dt[start]=="")				$err=lang("History Log Starting Date Missing");
	  else	if (input2date($dt[start])=="")		$err=lang("Invalid History Log Starting Date");
	$clo = $maxdate = $maxtime = $ini = "" ;
	For ($i=1;isset($dt["rowno$i"]);$i++) {
		$rowi = "[$row $i]" ;
		$calldate = $dt["calldate$i"] ;
		$calltime = $dt["calltime$i"] ;
		$callcatid = $dt["callcatid$i"] ;
		$hours = $dt["hours$i"] ;
		if ($calldate=="")			$err=$rowi.lang("Call Date Missing");
		if ($calltime=="")			$err=$rowi.lang("Call Time Missing");
		if ($callcatid=="")			$err=$rowi.lang("Call Type ID Missing");
		if ($dt["mediacatid$i"]=="")		$err=$rowi.lang("Call Media ID Missing");
		if ($dt["prsfrom$i"]=="")		$err=$rowi.lang("Person From Missing");
		if ($dt["prsto$i"]=="")			$err=$rowi.lang("Person To Missing");
		if ($dt["statecatid$i"]=="")		$err=$rowi.lang("Caller State of Mind ID Missing");
		if ($dt["assigned$i"]=="")		$err=$rowi.lang("Assigned-to Staff ID Missing");
		if ($dt["deadline$i"]=="")		$err=$rowi.lang("Response Deadline Missing");
		if ($dt["actioned$i"]=="")		$err=$rowi.lang("Actioned-by Staff ID Missing");
		if ($hours=="")				$err=$rowi.lang("Hours Spent Missing");
		if ($dt["summary$i"]=="")		$err=$rowi.lang("Call Summary Missing");

		if (input2date($calldate)=="")		$err=$rowi.lang("Invalid Call Date");
		if (strlen($calltime)<>4)		$err=$rowi.lang("Invalid Call Time [must be 4 chars long]") ;
		if (ereg('[^0-9]',$calltime))		$err=$rowi.lang("Invalid Call Time [only char 0-9 allowed]");
		$hr = substr($calltime,0,2);		$mn = substr($calltime,2,2) ;
		if ($hr<0 or $hr>24)			$err=$rowi.lang("Invalid Call Time [hour must be within 00-24]") ;
		if ($mn<0 or $mn>60)			$err=$rowi.lang("Invalid Call Time [minute must be within 00-60]") ;
		if ($calltime<0 or $calltime>2400)	$err=$rowi.lang("Invalid Call Time [time must be within 0000-2400]") ;
		if (input2date($dt["deadline$i"])=="")	$err=$rowi.lang("Invalid Response Deadline Date");
		if (!is_numeric($hours))		$err=$rowi.lang("Hours Spent must be numeric") ;
		if ($hours<0)				$err=$rowi.lang("Hours Spent must be +ve") ;
		if ($hours*1000%10>0)			$err=$rowi.lang("Invalid Hours Spent [only 2 decimal place allowed]");
		if ($calldate>$dt["deadline$i"])	$err=$rowi.lang("Response Deadline earlier than Call Date");
		if ($callcatid==$closew_id or $callcatid==$closel_id)
			if ($clo<>"")			$err=$rowi.lang("Duplicate Sale Case Closure") ;
				else			{$clo='**'; $close_date=$calldate; $close_time=$calltime;}
		if ($calldate>$maxdate or ($calldate==$maxdate and $calltime>$maxtime))
							{$maxdate=$calldate; $maxtime=$calltime;}
		if ($callcatid==$initial_id)		$ini = '**' ;
		}
	if ($ini=='')					$err=lang("Initial Call Record Missing");
	if ($err<>$rowi.lang("Duplicate Sale Case Closure"))
		if ($clo=='**' and ($maxdate<>$close_date or $maxtime<>$close_time))
							$err=lang("Closure date/time is not the latest within this log") ;
	if ($dt[casenumber]<>$dt[oldcasenumber]) {
		$phpgw->db->query("SELECT * from ${pre}salecase where casenumber='$dt[casenumber]'");
		if ($phpgw->db->num_rows()>0)		$err=lang("Case Name/# already exists") ;
		}
	
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- salecase Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write salecase Header

    function salecase_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit Id:'));
	$t->set_var('lang_casenumber',lang('Case Name/#'));
	$t->set_var('lang_casecat',lang('Case Category'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_start',lang('Date History Log Started'));
	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_contact',lang('Contact'));
	$t->set_var('lang_item',lang('Relevant Product/Service'));
	$t->set_var('lang_priority',lang('Priority'));
	$t->set_var('lang_amount',lang('Sale Amount'));
	$t->set_var('lang_expected',lang('Expected'));
	$t->set_var('lang_prospect',lang("Chance of Sale Win"));
	$t->set_var('lang_monitor',lang('Monitoring Officer'));

	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('casenumber',$dt[casenumber]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('start',$dt[start]) ;
	$t->set_var('amount',$dt[amount]) ;
	$t->set_var('prospect',$dt[prospect]) ;
	$chancepct = $dt[prospect]*100 ;
	$t->set_var('lang_prospnote',lang("i.e.")." $chancepct %");
	$lang_salecase = lang('salecase') ;
	$casecat_sl = category_selectlist("WHERE app='$app' and type='$lang_salecase'",$dt[casecatid]) ;
	$t->set_var('casecat_selectlist',$casecat_sl) ;
	$customer_sl = "<OPTION value='0'>".lang("Non-Customer")."</OPTION>".customer_selectlist('','') ;
	$customer_sl = str_replace("'$dt[customer]'","'$dt[customer]'"." selected",$customer_sl) ;
	$t->set_var('customer_selectlist',$customer_sl) ;
	$t->set_var('item_selectlist',item_selectlist('',$dt[itemid])) ;
	$lang_priority = strtolower(lang('priority')) ;
	$priority_sl = category_selectlist("WHERE app='$app' and type='$lang_priority'",$dt[pricatid]) ;
	$t->set_var('priority_selectlist',$priority_sl) ;
	$yesno_sl = "<OPTION value='y'>".lang('Yes')."</option><OPTION value='n'>".lang('No')."</option>" ;
	$yesno_sl = str_replace("'$dt[billable]'","'$dt[billable]'"." selected",$yesno_sl) ;
	$t->set_var('monitor_selectlist',employee_selectlist('',$dt[monitor])) ;

	if ($ckapi[params_post][op]=="edit")		$t->set_var('oldcasenumber',$dt[oldcasenumber]) ;

	$t->parse('out','report',True);
	}

//---- Write Callcase Detail to Screen

    function salecase_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$t = &$ckapi[objects][template] ;
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$row_ = lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('lang_caselog',lang('Sale Case History Log'));
	$t->set_var('lang_insert',lang('Insert before'));
	$t->set_var('lang_calldate',lang('Date'));
	$t->set_var('lang_calltime',lang('Time<br>[HHmm]'));
	$t->set_var('lang_callcatid',lang('Type'));
	$t->set_var('lang_mediacatid',lang('Media'));
	$t->set_var('lang_prsfrom',lang('Person From'));
	$t->set_var('lang_prsto',lang('Person To'));
	$t->set_var('lang_statecatid',lang('Caller State of Mind'));
	$t->set_var('lang_assigned',lang('<- Followup Action Assigned to'));
	$t->set_var('lang_deadline',lang('<- Response Deadline'));
	$t->set_var('lang_actioned',lang('<- Actioned by'));
	$t->set_var('lang_hours',lang('<- Hours Spent'));
	$t->set_var('lang_summary',lang('Summary'));
	$t->set_var('lang_delete_cap',lang('Delete'));

	$lang_salecall = lang('salecall') ;
	$lang_media = lang('media') ;
	$lang_state = lang('cstate') ;
	$callcatid_sl = category_selectlist("WHERE app='$app' and type='$lang_salecall'",'') ;
	$mediacatid_sl = category_selectlist("WHERE app='$app' and type='$lang_media'",'') ;
	$statecatid_sl = "<OPTION value='0'></OPTION>".category_selectlist("WHERE app='$app' and type='$lang_state'",'') ;
	$employee_sl = "<OPTION value='0'></OPTION>".employee_selectlist('','') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt["rowno$i"]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('calldate_fld',"calldate$i") ;
			$t->set_var('calltime_fld',"calltime$i") ;
			$t->set_var('callcatid_fld',"callcatid$i") ;
			$t->set_var('mediacatid_fld',"mediacatid$i") ;
			$t->set_var('prsfrom_fld',"prsfrom$i") ;
			$t->set_var('prsto_fld',"prsto$i") ;
			$t->set_var('statecatid_fld',"statecatid$i") ;
			$t->set_var('assigned_fld',"assigned$i") ;
			$t->set_var('deadline_fld',"deadline$i") ;
			$t->set_var('actioned_fld',"actioned$i") ;
			$t->set_var('hours_fld',"hours$i") ;
			$t->set_var('summary_fld',"summary$i") ;
			$t->set_var('rowno_fld',"rowno$i") ;
			$t->set_var('calldate',"") ;
			$t->set_var('calltime',"") ;
			$t->set_var('callcatid_selectlist',$callcatid_sl);
			$t->set_var('mediacatid_selectlist',$mediacatid_sl);
			$t->set_var('prsfrom',"") ;
			$t->set_var('prsto',"") ;
			$t->set_var('statecatid_selectlist',$statecatid_sl);
			$t->set_var('assigned_selectlist',$employee_sl);
			$t->set_var('deadline',"") ;
			$t->set_var('actioned_selectlist',$employee_sl);
			$t->set_var('hours',"") ;
			$t->set_var('summary',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$calldate	=	$dt['calldate'.$i] ;
		$calltime	=	$dt['calltime'.$i] ;
		$callcatid	=	$dt['callcatid'.$i] ;
		$mediacatid	=	$dt['mediacatid'.$i] ;
		$prsfrom	=	$dt['prsfrom'.$i] ;
		$prsto		=	$dt['prsto'.$i] ;
		$statecatid	=	$dt['statecatid'.$i] ;
		$assigned	=	$dt['assigned'.$i] ;
		$deadline	=	$dt['deadline'.$i] ;
		$actioned	=	$dt['actioned'.$i] ;
		$hours		=	$dt['hours'.$i] ;
		$summary	=	$dt['summary'.$i] ;
		$t->set_var('calldate_fld',"calldate$j") ;
		$t->set_var('calltime_fld',"calltime$j") ;
		$t->set_var('callcatid_fld',"callcatid$j") ;
		$t->set_var('mediacatid_fld',"mediacatid$j") ;
		$t->set_var('prsfrom_fld',"prsfrom$j") ;
		$t->set_var('prsto_fld',"prsto$j") ;
		$t->set_var('statecatid_fld',"statecatid$j") ;
		$t->set_var('assigned_fld',"assigned$j") ;
		$t->set_var('deadline_fld',"deadline$j") ;
		$t->set_var('actioned_fld',"actioned$j") ;
		$t->set_var('hours_fld',"hours$j") ;
		$t->set_var('summary_fld',"summary$j") ;
		$t->set_var('rowno_fld',"rowno$j") ;
		$t->set_var('calldate',$calldate) ;
		$t->set_var('calltime',$calltime) ;
		$t->set_var('callcatid_selectlist',str_replace("'$callcatid'","'$callcatid' selected",$callcatid_sl));
		$t->set_var('mediacatid_selectlist',str_replace("'$mediacatid'","'$mediacatid' selected",$mediacatid_sl));
		$t->set_var('prsfrom',$prsfrom) ;
		$t->set_var('prsto',$prsto) ;
		$t->set_var('statecatid_selectlist',str_replace("'$statecatid'","'$statecatid' selected",$statecatid_sl));
		$t->set_var('assigned_selectlist',str_replace("'$assigned'","'$assigned' selected",$employee_sl));
		$t->set_var('deadline',$deadline) ;
		$t->set_var('actioned_selectlist',str_replace("'$actioned'","'$actioned' selected",$employee_sl));
		$t->set_var('hours',$hours) ;
		$t->set_var('summary',$summary) ;
		if ($posted)	$t->set_var('insrowno',"done");  else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done");  else $t->set_var('delrowno',$row_.$j);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('calldate_fld',"calldate$i") ;
		$t->set_var('calltime_fld',"calltime$i") ;
		$t->set_var('callcatid_fld',"callcatid$i") ;
		$t->set_var('mediacatid_fld',"mediacatid$i") ;
		$t->set_var('prsfrom_fld',"prsfrom$i") ;
		$t->set_var('prsto_fld',"prsto$i") ;
		$t->set_var('statecatid_fld',"statecatid$i") ;
		$t->set_var('assigned_fld',"assigned$i") ;
		$t->set_var('deadline_fld',"deadline$i") ;
		$t->set_var('actioned_fld',"actioned$i") ;
		$t->set_var('hours_fld',"hours$i") ;
		$t->set_var('summary_fld',"summary$i") ;
		$t->set_var('rowno_fld',"rowno$i") ;
		$t->set_var('calldate',"") ;
		$t->set_var('calltime',"") ;
		$t->set_var('callcatid_selectlist',$callcatid_sl);
		$t->set_var('mediacatid_selectlist',$mediacatid_sl);
		$t->set_var('prsfrom',"") ;
		$t->set_var('prsto',"") ;
		$t->set_var('statecatid_selectlist',$statecatid_sl);
		$t->set_var('assigned_selectlist',$employee_sl);
		$t->set_var('deadline',"") ;
		$t->set_var('actioned_selectlist',$employee_sl);
		$t->set_var('hours',"") ;
		$t->set_var('summary',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if (($i==1 and $newrow=="") or ($i==2 and $delrowno==1))	$t->set_var('detail_section',"") ;

	$t->parse('out','report',True);
	}

//---- salecase Post - PreCommit Routine

    function salecase_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')	$phpgw->db->query("DELETE from ${pre}salecall where caseid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt["rowno$i"]);$i++) {
			$calldate	=	$dt["calldate$i"] ;
			$calltime	=	$dt["calltime$i"] ;
			$callcatid	=	$dt["callcatid$i"] ;
			$mediacatid	=	$dt["mediacatid$i"] ;
			$prsfrom	=	$dt["prsfrom$i"] ;
			$prsto		=	$dt["prsto$i"] ;
			$statecatid	=	$dt["statecatid$i"] ;
			$assigned	=	$dt["assigned$i"] ;
			$deadline	=	$dt["deadline$i"] ;
			$actioned	=	$dt["actioned$i"] ;
			$hours		=	$dt["hours$i"] ;
			$summary	=	$dt["summary$i"] ;
			$sql = "INSERT INTO ${pre}salecall (caseid,calldate,calltime,callcatid,mediacatid,prsfrom,prsto,statecatid," ;
			$sql.=				"assigned,deadline,actioned,hours,summary) " ;
			$sql.= "VALUES ('$id','$calldate','$calltime','$callcatid','$mediacatid','$prsfrom','$prsto','$statecatid'," ;
			$sql.=				"'$assigned','$deadline','$actioned','$hours','$summary') " ;
			$phpgw->db->query($sql);
			}
		}
	}
	
//---- Callcase Post - PostCommit Routine

    function salecase_post_postcommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;

	$subject1 = lang("You are the monitoring officer of the case") ;
	$subject2 = lang("You are one of the assigned-to staff of the case") ;
	$informmon = lang("Please manually inform monitoring officer") ;
	$user = $ckapi[hostsys][username];
	$err=""; $error=lang("Error"); $noemail=lang("No email sent") ;
	$phpgw->db->query("SELECT id,name FROM ${pre}employee WHERE username='$user'");
	if ($phpgw->db->next_record())	{$crmname = $phpgw->db->f('name'); $crmid = $phpgw->db->f('id');}
		else			$err = lang("HR record of CRM staff missing") ;
	if ($err=="") {
		$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$crmid' and emailcode='BUSI'";
		$phpgw->db->query($sql);
		if ($phpgw->db->next_record())
			$crmemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
		  else	$err = lang("Business email of CRM staff missing") ;
		}
	if ($err=="") {
		$phpgw->db->query("SELECT id,name FROM ${pre}employee WHERE id='$dt[monitor]'") ;
		if ($phpgw->db->next_record())	{$monname = $phpgw->db->f('name'); $monid = $phpgw->db->f('id');}
			else			$err = lang("HR record of monitoring staff missing") ;
		if ($err=="") {
			$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$monid' and emailcode='BUSI'";
			$phpgw->db->query($sql);
			if ($phpgw->db->next_record())
				$monemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
			  else	$err = lang("Business email of monitoring staff missing") ;
			}
		}
	$subject0 = "$lang_tran [id#$id] $actioned" ;
	if ($err<>"")	$ckapi[phrases]["reminder"] = "<br>$error: $err.  $noemail.  $informmon." ;
	  else	{
		$recipient = "$monname < $monemail >" ;
		$subject = "$subject0.  $subject1." ;
		$message = '' ;
		$headers = "From: $crmname < $crmemail >\n" ;
		$charset = lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$headers.= "Return-Path: $crmname < $crmemail >\n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email advising action on sale case successfully queued for despatch to monitoring officer") ;
		$failuremsg=lang("Email advising action on sale case fails to deliver.")."  $informmon";
		if ($result)	$msg = "<br>$successmsg $monname." ;
			else	$msg = "<br>$failuremsg $monname." ;
		$ckapi[phrases]["reminder"] = $msg ;
		}
	$informasg = lang("Please manually inform all assigned-to staff") ;
	$row = lang("Row") ;
	$recipient = "" ;
	if ($err=="") {
		For ($i=1;isset($dt["rowno$i"]);$i++) {
			$assigned = $dt["assigned$i"] ;
			if ($assigned==0)	continue ;
			$rowi = "[$row $i]" ;
			$phpgw->db->query("SELECT id,name FROM ${pre}employee WHERE id='$assigned'") ;
			if ($phpgw->db->next_record())	{$asgname=$phpgw->db->f('name'); $asgid=$phpgw->db->f('id');}
				else			$err = $rowi.lang("HR record of assigned-to staff missing") ;
			if ($err=="") {
				$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$asgid' and emailcode='BUSI'";
				$phpgw->db->query($sql);
				if ($phpgw->db->next_record())
					$asgemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
				  else	$err = $rowi.lang("Business email of assigned-to staff missing") ;
				}
			if (substr_count($recipient,$asgname)<=0)	$recipient.= " $asgname < $asgemail >," ;
			}
		}
	if ($err<>"")	$ckapi[phrases]["reminder"].= "<br>$error: $err.  $noemail.  $informasg." ;
	  else	{
		$subject = "$subject0.  $subject2." ;
		$message = '' ;
		$headers = "From: $crmname < $crmemail >\n" ;
		$charset = lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$headers.= "Return-Path: $crmname < $crmemail >\n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email advising action on sale case successfully queued for despatch to assign-to staff,");
		$failuremsg = lang("Email advising action on sale case fails to deliver.")."  $informasg";
		if ($result)	$msg = "<br>$successmsg $recipient." ;
			else	$msg = "<br>$failuremsg $recipient." ;
		$ckapi[phrases]["reminder"].= $msg ;
		}
	}

    }
