<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.contract.inc.php,v 0.11.1 2004/12/31 C K Wu $ */

    class contract {

//---- Contract List SQL Formation

    function contract_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$last10 = substr($where,strlen($where)-10,10) ;
	if ($last10==' AND OPEN '){
		$todayy = date("Y-m-d",mktime()) ;
		$where = substr($where,0,strlen($where)-10) ;
		$where.= " AND start<='$todayy' AND endd>='$todayy'" ;
		}
	$sql =	"SELECT * FROM $table WHERE $where ORDER BY $order $sort";
	return $sql ;
	}
	
//---- Contract Data Read

    function contract_read() {
	global $ckapi,$phpgw,$pre ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$table = $pre."stdterm" ;
	$phpgw->db->query("SELECT * FROM $table WHERE contractid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['stdpara'.$i]	=	$phpgw->db->f('stdpara') ;
		$dt['catid'.$i]		=	$phpgw->db->f('catid') ;
		}
	$table = $pre."spcterm" ;
	$phpgw->db->query("SELECT * FROM $table WHERE contractid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['spcpara'.$i]	=	$phpgw->db->f('spcpara') ;
		$dt['detail'.$i]	=	$phpgw->db->f('detail') ;
		}
	if ($ckapi[params_post][op]=="edit")	$dt[oldcntnumber] = $dt[cntnumber] ;
	
	return $dt ;
	}

//---- Write Contract Header

    function contract_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit Id:'));
	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_cntnumber',lang('Contract Name/#'));
	$t->set_var('lang_start',lang('Starting Date'));
	$t->set_var('lang_endd',lang('Ending Date'));

	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('customer_selectlist',customer_selectlist("WHERE id='$dt[customer]'",'')) ;
	$t->set_var('cntnumber',$dt[cntnumber]) ;
	$t->set_var('start',$dt[start]) ;
	$t->set_var('endd',$dt[endd]) ;
	if ($ckapi[params_post][op]=="edit")		$t->set_var('oldcntnumber',$dt[oldcntnumber]) ;

	$t->parse('out','report',True);
	}

//---- Write Contract Detail to Screen

    function contract_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$t = &$ckapi[objects][template] ;
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$t->set_block('report','stdterm','stdterm_section');
	$t->set_block('report','spcterm','spcterm_section');

	$stdrow_ = lang('stdRow')." " ;
	$spcrow_ = lang('spcRow')." " ;
	$lang_term = lang('term') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('lang_stdterm',lang('Standard Contract Terms'));
	$t->set_var('lang_spcterm',lang('Special Contract Terms'));
	$t->set_var('lang_insert',lang('Insert before'));
	$t->set_var('lang_paranumber',lang('Paragraph# / Reference#'));
	$t->set_var('lang_std_detail',lang('Standard Term (Code -- Description -- ID)'));
	$t->set_var('lang_spc_detail',lang('Special Term Description (Manual Input)'));
	$t->set_var('lang_delete_cap',lang('Delete'));

	$catid_sl = category_selectlist("WHERE app='ck-crm' and type='$lang_term'",'') ;
	if (isset($insert))	$insrowno = intval(str_replace($stdrow_,"",$insert));
	if ($insrowno==0)	$insrowno = 999999 ;
	if (isset($delete))	$delrowno = intval(str_replace($stdrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt['catid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('stdinsrowno',$stdrow_.$i) ;
			$t->set_var('stdpara_fld',"stdpara$i") ;
			$t->set_var('catid_fld',"catid$i") ;
			$t->set_var('stdrowno_fld',"stdrowno$i") ;
			$t->set_var('stdpara',"") ;
			$t->set_var('catid_selectlist',$catid_sl);
			$t->set_var('stddelrowno',$stdrow_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('stdterm_section','stdterm', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$stdpara	=	$dt['stdpara'.$i] ;
		$catid		=	$dt['catid'.$i] ;
		$t->set_var('stdpara_fld',"stdpara$j") ;
		$t->set_var('catid_fld',"catid$j") ;
		$t->set_var('stdrowno_fld',"stdrowno$j") ;
		$t->set_var('stdpara',$stdpara) ;
		$t->set_var('catid_selectlist',str_replace("'$catid'","'$catid' selected",$catid_sl));
		if ($posted)	$t->set_var('stdinsrowno',"done") ; else	$t->set_var('stdinsrowno',$stdrow_.$j) ;
		if ($posted)	$t->set_var('stddelrowno',"done") ; else	$t->set_var('stddelrowno',$stdrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('stdterm_section','stdterm', True);
		}
	if ($stdnewrow) {
		$t->set_var('stdinsrowno',$stdrow_.$i) ;
		$t->set_var('stdpara_fld','stdpara'.$i) ;
		$t->set_var('catid_fld','catid'.$i) ;
		$t->set_var('stdrowno_fld',"stdrowno$i") ;
		$t->set_var('stdpara',"") ;
		$t->set_var('catid_selectlist',$catid_sl);
		$t->set_var('stddelrowno',$stdrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('stdterm_section','stdterm', True);
		}
	if (($i==1 and $stdnewrow=="") or ($i==2 and $delrowno==1))	$t->set_var('stdterm_section',"") ;

	if (isset($insert))	$insrowno = intval(str_replace($spcrow_,"",$insert));
	if ($insrowno==0)	$insrowno = 999999 ;
	if (isset($delete))	$delrowno = intval(str_replace($spcrow_,"",$delete));
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt['detail'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('spcinsrowno',$spcrow_.$i) ;
			$t->set_var('spcpara_fld',"spcpara$i") ;
			$t->set_var('detail_fld',"detail$i") ;
			$t->set_var('spcrowno_fld',"spcrowno$i") ;
			$t->set_var('spcpara',"") ;
			$t->set_var('detail',"");
			$t->set_var('spcdelrowno',$spcrow_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('spcterm_section','spcterm', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$spcpara	=	$dt['spcpara'.$i] ;
		$detail		=	$dt['detail'.$i] ;
		$t->set_var('spcpara_fld',"spcpara$j") ;
		$t->set_var('detail_fld',"detail$j") ;
		$t->set_var('spcrowno_fld',"spcrowno$j") ;
		$t->set_var('spcpara',$spcpara) ;
		$t->set_var('detail',$detail) ;
		if ($posted)	$t->set_var('spcinsrowno',"done") ; else	$t->set_var('spcinsrowno',$spcrow_.$j) ;
		if ($posted)	$t->set_var('spcdelrowno',"done") ; else	$t->set_var('spcdelrowno',$spcrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('spcterm_section','spcterm', True);
		}
	if ($spcnewrow) {
		$t->set_var('spcinsrowno',$spcrow_.$i) ;
		$t->set_var('spcpara_fld',"spcpara$i") ;
		$t->set_var('detail_fld',"detail$i") ;
		$t->set_var('spcrowno_fld',"spcrowno$i") ;
		$t->set_var('spcpara',"") ;
		$t->set_var('detail',"");
		$t->set_var('spcdelrowno',$spcrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('spcterm_section','spcterm', True);
		}
	if (($i==1 and $spcnewrow=="") or ($i==2 and $delrowno==1))	$t->set_var('spcterm_section',"") ;

	$t->parse('out','report',True);
	}
	
    }
