<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: accountfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ledger' ;
	$tran = 'account' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Accounts :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Account") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$blankopt = "<OPTION value='ALL'></OPTION>" ;
	$asset = lang("Asset") ;
	$liab = lang("Liability") ;
	$equity = lang("Equity") ;
	$income = lang("Income") ;
	$expense = lang("Expense") ;
	$cat_sl = $blankopt ;
	$cat_sl.= "<OPTION value='A'>A -- $asset</OPTION>" ;
	$cat_sl.= "<OPTION value='L'>L -- $liab</OPTION>" ;
	$cat_sl.= "<OPTION value='Q'>Q -- $equity</OPTION>" ;
	$cat_sl.= "<OPTION value='I'>I -- $income</OPTION>" ;
	$cat_sl.= "<OPTION value='E'>E -- $expense</OPTION>" ;
	$posting = lang("posting account") ;
	$heading = lang("heading account") ;
	$type_sl = $blankopt ;
	$type_sl.= "<OPTION value='A'>A -- $posting</OPTION>" ;
	$type_sl.= "<OPTION value='H'>H -- $heading</OPTION>" ;

	$ckapi[filter][] = array(criteria	=>	lang('Account# from') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>lang('Account search starts from this # (format:9999)') );

	$ckapi[filter][] = array(criteria	=>	lang('Account# to') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>lang('Account search ends at this # (format:9999)') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Description') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	"" ,
				note =>lang('Search for target key word in the account description field') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Category') ,
				type		=>	'select' ,
				selectlist	=>	$cat_sl ,
				varname		=>	'category' ,
				defval		=>	"" ,
				note		=>	lang('Search for specific category of account')	) ;

	$ckapi[filter][] = array(criteria	=>	lang('Type') ,
				type		=>	'select' ,
				selectlist	=>	$type_sl ,
				varname		=>	'type' ,
				defval		=>	"" ,
				note		=>	lang('Search for specific type of account')) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
