<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: attribfilter_validate.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ledger' ;
	$tran = 'attrib' ;
	$noheader = True ;  $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$attrib = ($_GET["attrib"]) ? $_GET["attrib"] : $_POST["attrib"] ;
	$caption = ($_GET["caption"]) ? $_GET["caption"] : $_POST["caption"] ;
	$table = ($_GET["table"]) ? $_GET["table"] : $_POST["table"] ;
	$sdfld = ($_GET["sdfld"]) ? $_GET["sdfld"] : $_POST["sdfld"] ;
	$ldfld = ($_GET["ldfld"]) ? $_GET["ldfld"] : $_POST["ldfld"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$sdesc = ($_GET["sdesc"]) ? $_GET["sdesc"] : $_POST["sdesc"] ;
	$ldesc = ($_GET["ldesc"]) ? $_GET["ldesc"] : $_POST["ldesc"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	$err="" ;  $error=lang("Error") ;  $markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	if (strlen($sdesc)>15)				$err=lang("Short Name search string too long");
	if (substr_count($sdesc,$markpri)>0)		$err=lang("Short Name string contains reserved pattern")." - $markpri";
	if (substr_count($sdesc,$marksec)>0)		$err=lang("Short Name string contains reserved pattern")." - $marksec";
	if (substr_count($sdesc," ")>0)			$err="[$sdesc]".lang("Search string should not contain space(s)");
	if (strlen($ldesc)>15)				$err=lang("Description search string too long") ;
	if (substr_count($ldesc,$markpri)>0)		$err=lang("Description string contains reserved pattern")." - $markpri";
	if (substr_count($ldesc,$marksec)>0)		$err=lang("Description string contains reserved pattern")." - $marksec";
	if (substr_count($ldesc," ")>0)			$err="[$ldesc]".lang("Search string should not contain space(s)");

	if ($err)					$err = "<b>$error:  $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	$phpgw->db->query("Select * from ${pre}defaults");
	$phpgw->db->next_record() ;
	switch ($attrib) :
		case "1" : $sdfld=$phpgw->db->f('attrib1sdesc'); $ldfld=$phpgw->db->f('attrib1ldesc'); break ;
		case "2" : $sdfld=$phpgw->db->f('attrib2sdesc'); $ldfld=$phpgw->db->f('attrib2ldesc'); break ;
		case "3" : $sdfld=$phpgw->db->f('attrib3sdesc'); $ldfld=$phpgw->db->f('attrib3ldesc'); break ;
		endswitch ;

	if (!$err) {
					$filter .= $markpri."xtable".$marksec.$table;
					$filter .= $markpri."xattrib".$marksec.$attrib;
		if ($sdesc)		$filter .= $markpri."6$sdfld".$marksec.$sdesc ;
		if ($ldesc)		$filter .= $markpri."6$ldfld".$marksec.$ldesc ;
	
		$filter = urlencode($filter) ;
		$getstr = "attrib=$attrib&caption=$caption&table=$table&sdfld=$sdfld&ldfld=$ldfld&filter=$filter" ;
		Header('Location: '.$phpgw->link("/$app/${tran}list.php",$getstr));
		$phpgw->common->phpgw_exit();
		}
	else
		{
		$getstr = "attrib=$attrib&caption=$caption&table=$table&sdfld=$sdfld&ldfld=$ldfld&" ;
		$getstr.= "sdesc=$sdesc&ldesc=$ldesc&err=$err" ;
		Header('Location: '.$phpgw->link("/$app/${tran}filter.php",$getstr));
		$phpgw->common->phpgw_exit();
		}

?>
