<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: header.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

//	$app = 'ck-ledger' ;
//	include('../ck-api/ckapi.inc.php') ;
	global $ckapi ;
	$pre = $ckapi[params][pre] ;

    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-ledger'));
    $t->set_file(array('ledger_header' => 'header.tpl'));
    $info1 = lang('Ledger') ;
    $info2 = lang("You must read each module's index page in detail.") ;
    $info3 = lang("It contains the Terms & Conditions of usage and re-distribution.") ;
    $t->set_var('info',"$info1  [$info2  $info3]");
    $t->set_var('bg_color',$phpgw_info["theme"]["th_bg"]);

    $t->set_var('link_account',$phpgw->link('/ck-ledger/accountfilter.php'));
    $t->set_var('lang_account',lang('Ledger Account'));
    $t->set_var('link_journal',$phpgw->link('/ck-ledger/journalfilter.php'));
    $t->set_var('lang_journal',lang('Journal'));

    $phpgw->db->query("Select * from ${pre}defaults");
    $phpgw->db->next_record();
    
    if ($phpgw->db->f('attrib1tblmn')=="yes") {
	$caption = $phpgw->db->f('attrib1cap') ;
	$table = $phpgw->db->f('attrib1tbl') ;
	$sdfld = $phpgw->db->f('attrib1sdesc') ;
	$ldfld = $phpgw->db->f('attrib1ldesc') ;
	$getstr= "attrib=1&caption=$caption&table=$table&sdfld=$sdfld&ldfld=$ldfld" ;
	$t->set_var('link_attrib1',$phpgw->link('/ck-ledger/attribfilter.php',$getstr));
	$t->set_var('lang_attrib1',$caption);
	}
      else
	{
	$t->set_var('link_attrib1','');
	$t->set_var('lang_attrib1','');
	}

    if ($phpgw->db->f('attrib2tblmn')=="yes") {
	$caption = $phpgw->db->f('attrib2cap') ;
	$table = $phpgw->db->f('attrib2tbl') ;
	$sdfld = $phpgw->db->f('attrib2sdesc') ;
	$ldfld = $phpgw->db->f('attrib2ldesc') ;
	$getstr= "attrib=2&caption=$caption&table=$table&sdfld=$sdfld&ldfld=$ldfld" ;
	$t->set_var('link_attrib2',$phpgw->link('/ck-ledger/attribfilter.php',$getstr));
	$t->set_var('lang_attrib2',$caption);
	}
      else
	{
	$t->set_var('link_attrib2','');
	$t->set_var('lang_attrib2','');
	}

    if ($phpgw->db->f('attrib3tblmn')=="yes") {
	$caption = $phpgw->db->f('attrib3cap') ;
	$table = $phpgw->db->f('attrib3tbl') ;
	$sdfld = $phpgw->db->f('attrib3sdesc') ;
	$ldfld = $phpgw->db->f('attrib3ldesc') ;
	$getstr= "attrib=3&caption=$caption&table=$table&sdfld=$sdfld&ldfld=$ldfld" ;
	$t->set_var('link_attrib3',$phpgw->link('/ck-ledger/attribfilter.php',$getstr));
	$t->set_var('lang_attrib3',$caption);
	}
      else
	{
	$t->set_var('link_attrib3','');
	$t->set_var('lang_attrib3','');
	}

    $t->set_var('link_report',$phpgw->link('/ck-ledger/reportfilter.php'));
    $t->set_var('lang_report',lang('Reports'));
    
	$readonly = False ;
	$phpgw->db->query("SELECT readonlygrp FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$readonlygrp = $phpgw->db->f('readonlygrp') ;
	$groups = ExecMethod('phpgwapi.accounts.membership') ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']==$readonlygrp)	$readonly = True ;
	if ($readonly) {
		$t->set_var(array('link_account'=>"", 'lang_account'=>""));
		$t->set_var(array('link_journal'=>"", 'lang_journal'=>""));
		$t->set_var(array('link_attrib1'=>"", 'lang_attrib1'=>""));
		$t->set_var(array('link_attrib2'=>"", 'lang_attrib2'=>""));
		$t->set_var(array('link_attrib3'=>"", 'lang_attrib3'=>""));
		}

    $t->pparse('out','ledger_header');
?>
