<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payjournalfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'payjournal' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}gl" ,
				'doneexit'	=> "index.php"				) ;
	$title = lang("Search among existing settled/outstanding Salary Payment :") ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$note1 = lang("Search for the target staff's salary payment") ;

	$note2 = lang('Immediate past payroll period') ;
	$phpgw->db->query("SELECT max(trans_id) as id FROM ${pre}pyrohist");
	$phpgw->db->next_record() ;
	$id = $phpgw->db->Record['id'] ;
	$phpgw->db->query("SELECT description FROM ${pre}gl WHERE id='$id'");
	$phpgw->db->next_record() ;
	$pastdesc = $phpgw->db->Record['description'] ;
	$frommarker = strtolower(lang('from')).'::' ;
	$tomarker = strtolower(lang('to')).'::' ;
	list($dummy,$fromto) = explode($frommarker,$pastdesc) ;
	list($from,$to) = explode($tomarker,$fromto) ;
	$perifrom = trim($from);
	$perito = trim($to);

	$ckapi[filter][] = array(criteria	=>	lang('Which Staff') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.employee_selectlist("","") ,
				varname		=>	'empid' ,
				defval		=>	'' ,
				note		=>	$note1					) ;

	$ckapi[filter][] = array(criteria	=>	lang('Useful Information') ,
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No input required]') ,
				note		=>	"$note2:  $perifrom => $perito"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	$dateformat				) ;

	$ckapi[filter][] = array(criteria	=>	lang('Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	$dateformat				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>


