<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter_validate.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'report' ;
	$noheader = True ;
	$nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actnum = ($_GET["actnum"]) ? $_GET["actnum"] : $_POST["actnum"] ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	if ($err)		$err="Error flagged before validation." ;
	$error = lang("Error") ;
	$phpgw->db->query("SELECT sum(amount) as amount FROM ${pre}acc_trans");
	$phpgw->db->next_record() ;
	$net = sprintf("%01.2f",$phpgw->db->f('amount')) ;
	if ($net<>0)		$err=lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.");

	if ($actnum<5 or $actnum>5)	{$err=lang("Invalid report choice"); $actnum="";}
	if ($rdate) {
		$date=input2date($rdate) ;
		if ($date=="")	$err=lang("Invalid Report Status Date");
			else	$rdate = $date ;
		}
	    else	$rdate=date("Y-m-d") ;
	if ($err)		$err = "<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)	{
		switch ($actnum) {
			case 1:
				Header('Location: '.$phpgw->link("/$app/${tran}filter.php"));
				exit();
			case 2:
				Header('Location: '.$phpgw->link("/$app/${tran}filter.php"));
				exit();
			case 3:
				Header('Location: '.$phpgw->link("/$app/${tran}filter.php"));
				exit();
			case 4:
				Header('Location: '.$phpgw->link("/$app/${tran}filter.php"));
				exit();
			case 5:
				$getstr = "rdate=$rdate" ;
				Header('Location: '.$phpgw->link("/$app/controlreport.php",$getstr));
				exit();
			default:
				echo lang("Should not be here.  Weird Report Number") ;
			}
		}
	else
		{
		$getstr = "actnum=$actnum&rdate=$rdate&err=$err" ;
		Header('Location: '.$phpgw->link("/$app/${tran}filter.php",$getstr));
		exit() ;
		}

?>

