<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.po.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class po {

//---- PO List SQL Formation

    function po_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if ($ckapi[params][tran]=="pont")	$where = "amount=netamount $where" ;	else	$where = "amount<>netamount $where";
	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,duedate,ponumber,name,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}po a, ${pre}vendor b WHERE $where AND a.vendor=b.id " ;
		$sql2 =	"SELECT $fields FROM ${pre}po a, ${pre}vendor b, ${pre}ipmatch c " ;
		$sql2.=	"WHERE $where AND vendor=b.id AND a.id=c.poid " ;
		$sql2.=	"GROUP BY $fields HAVING sum(b_amount)>=amount " ;
		if ($ckapi[hostsys][dbtype]=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}pontl1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}pontl2".$user.time() ;
			$phpgw->db->query("CREATE TABLE $temp1 AS $sql1");
			$phpgw->db->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	else $sql="SELECT $fields FROM ${pre}po a,${pre}vendor b WHERE $where AND vendor=b.id ORDER BY $order $sort";
	return $sql ;
	}

//---- Purchase Order List Link Adjustement

    function po_list_adjust() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$return = "/$app/${tran}list.php" ;
	$getstr = "id=$dt[id]&filter=$filter&return=$return" ;
	$t->set_var('edit_addtax',$phpgw->link("/$app/powtedit.php",$getstr)) ;

	$getstr = "order=$order&sort=$sort&id=$dt[id]&filter=$filter" ;
	if (substr_count($dt[name],'zzzz')<=0)
		$t->set_var('bulk_action',$phpgw->link("/$app/${tran}bulk.php",$getstr)) ;
	$disabled = ($dt[id]=="") ? "disabled" : "" ;
	$t->set_var('disabled',$disabled) ;

	}

//---- PO Data Read

    function po_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$script = $ckapi[params_post][script] ;

	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[taxstatus] = ($tran=="pont") ? "e" : $phpgw->db->f('taxincluded') ;
	$dt[oldisocode] = $dt[isocode] ;
	$phpgw->db->query("SELECT * FROM ${pre}oitem WHERE trans_id='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['itemid'.$i]		=	$phpgw->db->f('itemid') ;
		$dt['itemtype'.$i]		=	$phpgw->db->f('itemtype') ;
		$dt['description'.$i]		=	$phpgw->db->f('description') ;
		$dt['qty'.$i]			=	$phpgw->db->f('qty') ;
		$dt['unit'.$i]			=	$phpgw->db->f('unit') ;
		$dt['cost'.$i]			=	$phpgw->db->f('cost') ;
		$dt['discount'.$i]		=	$phpgw->db->f('discount') ;
		$dt['tax1'.$i]			=	$phpgw->db->f('tax1') ;
		$dt['tax2'.$i]			=	$phpgw->db->f('tax2') ;
		}
	return $dt ;
	}

//---- Purchase Order Add Initialisation

    function po_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt['transdate'] = date("Y-m-d") ;
	$sql = "SELECT isocode,exrate FROM ${pre}currency, ${pre}defaults WHERE nativecurr=isocode" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$dt['isocode'] = $dt['oldisocode'] = $phpgw->db->f('isocode') ;
	$dt['exrate'] = $phpgw->db->f('exrate') ;
	}

//---- Purchase Order Detail Validation Checks

    function po_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	if ($dt[ponumber]=="")			$err=lang('Purchase Order Number Missing');
	if (input2date($dt[transdate])=="")	$err=lang('Invalid Purchase Order Date');
	if (input2date($dt[duedate])=="")	$err=lang('Invalid Due Date');
	if ($dt[exrate]<=0)			$err=lang("Invalid Exchange Rate") ;
	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	if ($dt[isocode]==$phpgw->db->f('nativecurr') and $dt[exrate]<>1)
					$err=lang("Exchange rate for ledger currency must = 1") ;
	$phpgw->db->query("SELECT * FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$phpgw->db->next_record() ;
	$nativeexrate = $phpgw->db->f('exrate') ;
	if ($nativeexrate>0) {
		$ratio = $dt[exrate]/$nativeexrate ;
		if (0.8>$ratio or $ratio>1.2)
					$err=lang("Exchange rate deviates too much from default") ;
		}
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($dt['itemid'.$i]=='')	$err=lang('Item Code Missing');
		if ($dt['qty'.$i] and !is_numeric($dt['qty'.$i]))
					$err=$rowi.lang("Invalid Qty, must be numeric");
		if ($dt['discount'.$i] and !is_numeric($dt['discount'.$i]) and $dt[taxstatus]<>"t")
					$err=$rowi.lang("Invalid Discount, must be numeric");
		if ($dt['cost'.$i] and !is_numeric($dt['cost'.$i]))
					$err=$rowi.lang("Invalid Unit Price, must be numeric");
		if ($dt['tax1'.$i] and !is_numeric($dt['tax1'.$i]))
					$err=$rowi.lang("Invalid Tax1, must be numeric");
		if ($dt['tax2'.$i] and !is_numeric($dt['tax2'.$i]))
					$err=$rowi.lang("Invalid Tax2, must be numeric");
		if (($dt[taxstatus]=="f" or $dt[taxstatus]=="t") and $dt['tax1_pref'.$i]=='')
					$err=$rowi.lang("Blank Choice on Primary Tax Rate");
		if (($dt[taxstatus]=="f" or $dt[taxstatus]=="t") and $dt['tax2_pref'.$i]=='')
					$err=$rowi.lang("Blank Choice on Secondary Tax Rate");
		}
	if ($dt[isocode]<>$dt[oldisocode]) {
		$warn1 = lang('Currency changed') ;
		$warn2 = lang('Default exchange rate loaded') ;
		$warn3 = lang('Ensure pre-existing (discount,price,cost,tax) are correct') ;
		$warn4 = lang('Click [Post PO] to re-activate purchase order posting') ;
		$err = "$warn1;  $warn2;  $warn3;  $warn4" ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write PO Header

    function po_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$script = &$ckapi[params_post][script] ;
	$t = &$ckapi[objects][template] ;

	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$loc_for = ($phpgw->db->f('nativecurr')==$dt[isocode]) ? lang('Local') : lang('*** Foreign ***') ;
	if ($dt[isocode]<>$dt[oldisocode]) {
		$phpgw->db->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
		$phpgw->db->next_record() ;
		$dt[exrate] = $phpgw->db->f('exrate') ;
		$msg1 = lang('Currency changed') ;
		$msg2 = lang('Default exchange rate loaded') ;
		$msg3 = lang('Ensure pre-existing (discount,price,cost,tax) are correct') ;
		$t->set_var('message',"$msg1;  $msg2;  $msg3");
		}
	$taxstatus = $dt[taxstatus] ;
	$t->set_var('lang_ponumber',lang('PO#'));
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_curr_po',lang('Currency Purchase Order'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_transdate',lang('PO Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_shipfrom',lang('Ship From'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_vendor',lang('Vendor'));
	$t->set_var('lang_taxstatus',lang('Unit Price Tax Status'));
	$t->set_var('lang_isocode',lang('Currency'));
	$t->set_var('lang_exrate',lang('Exchange Rate'));
	$t->set_var('lang_totalamt',lang('Total PO Amount'));
	$t->set_var('ponumber',$dt[ponumber]) ;
	$t->set_var('shipfrom',$dt[shipfrom]) ;
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('duedate',$dt[duedate]) ;
	$t->set_var('notes',$dt[notes]);
	$vendor = $dt[vendor] ;
	$t->set_var('vendor',$vendor) ;
	$t->set_var('vendor_selectlist',vendor_selectlist('',$vendor)) ;
	$optiont = lang('Tax Included') ;
	$optionf = lang('Tax Not Included') ;
	$optione = lang('Tax Exempted') ;
	if ($tran=="pont")	$tax_sl = "<OPTION value='e' selected>$optione</OPTION>" ;
	    else {
		$tax_sl = "<OPTION value='t'>$optiont</OPTION>" ;
		$tax_sl.= "<OPTION value='f'>$optionf</OPTION>" ;
		$tax_sl.= "<OPTION value='e'>$optione</OPTION>" ;
		$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
		}
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('isocode_selectlist',isocode_selectlist('',$dt[isocode])) ;
	$t->set_var('exrate',$dt[exrate]) ;
	$t->set_var('oldisocode',$dt['isocode']);

	$msg1 = lang("Due date is an independent input subject to how urgent the ordered goods is needed.");
	$msg2 = lang("UC - Unit Cost, BTUP - Before Tax Unit Price, my std rate - my standard rate as a customer.") ;
	$msg3 = lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$msg4 = lang("If Unit Price includes tax, discount is ignored.") ;
	$msg5 = lang("Posted (Tax Exempted) PO will appear in the Purchase Order [no Tax] list.");
	$msg6 = lang("Manual tax input is allowed.");
	$msg7 = lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	$t->set_var('message',"$msg1<br>$msg2<br>$msg3<br>$msg4  $msg5<br><b>$msg6  $msg7</b>");

	$t->parse('out','report',True);
	}

//---- Reformat Purchase Order Array

    function po_transform() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$temp[id] = $dt[id] ;
	$temp[control] = $dt[control] ;
	$temp[vendor] = $dt[vendor] ;
	$temp[transdate] = $dt[transdate] ;
	$temp[duedate] = $dt[duedate] ;
	$temp[ponumber] = $dt[ponumber] ;
	$temp[taxstatus] = $dt[taxstatus] ;
	$temp[shipfrom] = $dt[shipfrom] ;
	$temp[notes] = $dt[notes] ;
	$temp[isocode] = $dt[isocode] ;
	$temp[oldisocode] = $dt[oldisocode] ;
	$temp[exrate] = $dt[exrate] ;

	if (isset($delete)) {$delrowno = intval(str_replace($row_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$itemid = $dt['itemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($itemid<0)	{
			$itemid = -$itemid ;
			$qty = $dt['qty'.$i]==0 ? 1 : $dt['qty'.$i] ;
			$phpgw->db->query("SELECT * FROM ${pre}assembly WHERE assembly_id='$itemid'");
			while ($phpgw->db->next_record()) {
				$temp['itemid'.$j] = $phpgw->db->f('item_id') ;
				$temp['qty'.$j] = $phpgw->db->f('qty') * $qty ;
				$j++ ;
				}
			continue ;
			}
		$temp['itemid'.$j]		=	$dt['itemid'.$i] ;
		$temp['itemtype'.$j]		=	$dt['itemtype'.$i] ;
		$temp['description'.$j]		=	$dt['description'.$i] ;
		$temp['qty'.$j]			=	$dt['qty'.$i] ;
		$temp['unit'.$j]		=	$dt['unit'.$i] ;
		$temp['cost'.$j]		=	$dt['cost'.$i] ;
		$temp['discount'.$j]		=	$dt['discount'.$i] ;
		$temp['tax1_pref'.$j]		=	$dt['tax1_pref'.$i] ;
		$temp['tax2_pref'.$j]		=	$dt['tax2_pref'.$i] ;
		$temp['tax1'.$j]		=	$dt['tax1'.$i] ;
		$temp['tax2'.$j]		=	$dt['tax2'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow)					$temp['itemid'.$j] = "" ;
	$dt = $temp ;
	unset($temp) ;
	}

//---- Write PO Detail

    function po_detail_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$firstime = $ckapi[params_post][firstime] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$taxstatus = $dt[taxstatus] ;
	$tax_warning = lang("***** Choice Pending") ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	if ($taxstatus<>'e') {
		$tax_pref_slist = "<OPTION value=''></OPTION>" ;
		$tax_pref_slist.= "<OPTION value='i'>".lang('apply item tax rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='v'>".lang('apply vendor rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='s'>".lang('apply my std rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='z'>".lang('tax rate = zero')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='m'>".lang('manual tax input')."</OPTION>" ;
		$vendor = ($dt[vendor]=="") ? 0 : $dt[vendor];
		$sql = "SELECT vendor_id,rate from ${pre}vendortax a, ${pre}tax b " ;
		$sql.= "WHERE vendor_id='$vendor' and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$vtax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,rate from ${pre}vendortax a, ${pre}tax b " ;
		$sql.= "WHERE vendor_id='$vendor' and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$vtax2rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,rate from ${pre}vendortax a, ${pre}tax b, ${pre}vendor c " ;
		$sql.= "WHERE c.name='zzzzMyself' and vendor_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,rate from ${pre}vendortax a, ${pre}tax b, ${pre}vendor c " ;
		$sql.= "WHERE c.name='zzzzMyself' and vendor_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax2rate = $phpgw->db->f(rate) ;
		}
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_number',lang('Item Code -- Id<br>(Inventory/Service)'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_btup',lang('BTUP'));
	$t->set_var('lang_discount',lang('Discount')."<br>$");
	$t->set_var('lang_tax',lang('Tax'));
	$phpgw->db->query("SELECT aptax1cap,aptax2cap,aptax1pref,aptax2pref FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$t->set_var('lang_tax1',$phpgw->db->f(aptax1cap));
	$t->set_var('lang_tax2',$phpgw->db->f(aptax2cap));
	$tax1pref = $phpgw->db->f(aptax1pref) ;
	$tax2pref = $phpgw->db->f(aptax2pref) ;
	$t->set_var('lang_cost',lang('Unit<br>Price'));
	$t->set_var('lang_itemtotal',lang('Item Total'));
	$t->set_var('lang_netamount',lang('Net of Tax'));
	$t->set_var('lang_delete',lang('Delete<br>Button'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_sl = item_selectlist("",'') ;
	$sum_tax1 = $sum_tax2 = $sum_itemtotal = $sum_netamount = 0 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$t->set_var('itemid_fld','itemid'.$i) ;
		$t->set_var('itemtype_fld','itemtype'.$i) ;
		$t->set_var('description_fld','description'.$i);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('unit_fld','unit'.$i);
		$t->set_var('discount_fld','discount'.$i);
		$t->set_var('cost_fld','cost'.$i);
		$t->set_var('tax1_pref_fld','tax1_pref'.$i);
		$t->set_var('tax2_pref_fld','tax2_pref'.$i);
		$t->set_var('tax1_fld','tax1'.$i);
		$t->set_var('tax2_fld','tax2'.$i);
		$itemid = $dt['itemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('item_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$item_sl));
		$itemtype = $dt['itemtype'.$i] ;
		$description = $dt['description'.$i] ;
		$unit = $dt['unit'.$i] ;
		$qty = ($itemid<>'' and $dt['qty'.$i]=='') ? 1 : $dt['qty'.$i] ;
		$discount = $dt['discount'.$i] ;
		$cost = $dt['cost'.$i] ;
		$tax1_pref = ($dt['tax1_pref'.$i] or $posted) ? $dt['tax1_pref'.$i] : $tax1pref ;
		$tax2_pref = ($dt['tax2_pref'.$i] or $posted) ? $dt['tax2_pref'.$i] : $tax2pref ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		if (($tax1_pref=="" or $tax1_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark1',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark1',"");
		if (($tax2_pref=="" or $tax2_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark2',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark2',"");
		$tax1 = $dt['tax1'.$i] ;
		$tax2 = $dt['tax2'.$i] ;
		$itemid = ($itemid=="") ? 0 : $itemid ;
		if (!$itemtype) {
			$phpgw->db->query("SELECT * FROM ${pre}service WHERE id='$itemid'");
			if ($phpgw->db->next_record())	$itemtype = "s" ;
			   else {
				$phpgw->db->query("SELECT * FROM ${pre}parts WHERE id='$itemid'");
				if ($phpgw->db->next_record())	$itemtype = "i" ;
				}
			$description = $description<>'' ? $description : $phpgw->db->f('description');
			$unit = $unit<>'' ? $unit : $phpgw->db->f('unit');
			$cost = ($cost<>'' or $itemid==0) ? $cost : $phpgw->db->f('cost')/$dt[exrate];
			$cost = number_format($cost,2,".",'') ;
			}
		$t->set_var('itemtype',$itemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$unit);
		$t->set_var('qty',$qty);
		$t->set_var('discount',$discount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$cost = number_format($cost,2,".",'') ;
		$cost = ($itemid==0) ? "" : $cost ;
		$t->set_var('cost',$cost);
		switch ($tax1_pref) :
			case "v" :	$tax1rate = $vtax1rate ;	break ;
			case "s" :	$tax1rate = $stax1rate ;	break ;
			case "i" :
				$sql = "SELECT rate from ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
				$sql.= "taxtype='1' and taxgroup='ap'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax1rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax1rate = 0 ;		break ;
			case "m" :	$tax1rate = 0 ;		break ;
			case " " :	$tax1rate = 0 ;		break ;
			case "" :	$tax1rate = 0 ;		break ;
			endswitch ;
		switch ($tax2_pref) :
			case "v" :	$tax2rate = $vtax2rate ;	break ;
			case "s" :	$tax2rate = $stax2rate ;	break ;
			case "i" :
				$sql = "SELECT rate from ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
				$sql.= "taxtype='2' and taxgroup='ap'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax2rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax2rate = 0 ;		break ;
			case "m" :	$tax2rate = 0 ;		break ;
			case " " :	$tax2rate = 0 ;		break ;
			case "" :	$tax2rate = 0 ;		break ;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$t->set_var('btup',$cost);
				$netamount = number_format($qty*$cost-$discount,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				$tax1 = ($keeptax1) ? $tax1 : $netamount*$tax1rate ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $netamount*$tax2rate ;
				$tax2 = number_format($tax2,2,".",'') ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$t->set_var('btup','.');
				$t->set_var('discount','');
				$itemtotal = $taxbase = number_format($qty*$cost,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				if ($keeptax1)		$taxbase -= $tax1 ;
				if ($keeptax2)		$taxbase -= $tax2 ;
				$tax1 = ($keeptax1) ? $tax1 : $taxbase*$tax1rate/(1+$tax1rate+$tax2rate) ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $taxbase*$tax2rate/(1+$tax1rate+$tax2rate) ;
				$tax2 = number_format($tax2,2,".",'') ;
				$netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$t->set_var('btup','.');
				$netamount = number_format($qty*$cost-$discount,2,".",'') ;
				$itemtotal = $netamount ;
				$tax1rate = $tax2rate = 0 ;
				$tax1 = $tax2 = 0 ;
				break ;
			endswitch ;
		$sum_tax1 += $tax1 ;
		$sum_tax2 += $tax2 ;
		$sum_itemtotal += $itemtotal ;
		$sum_netamount += $netamount ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('netamount',$netamount);
		if ($posted)	$t->set_var('rowno',"done") ;
			else	$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);

		$dt['itemid'.$i] = $itemid ;
		$dt['itemtype'.$i] = $itemtype ;
		$dt['description'.$i] = $description ;
		$dt['qty'.$i] = $qty ;
		$dt['cost'.$i] = $cost ;
		$dt['discount'.$i] = $discount ;
		$dt['unit'.$i] = $unit ;
		$dt['tax1'.$i] = $tax1 ;
		$dt['tax2'.$i] = $tax2 ;
		$dt['netamount'.$i] = $netamount ;
		}
	$dt[amount] = number_format($sum_itemtotal,2,".",'') ;
	$dt[netamount] = number_format($sum_netamount,2,".",'') ;
	$t->set_var('lang_totalnet',lang('Total Tax / Net Amount'));
	$t->set_var('lang_totalap',lang('Total Payable'));
	$t->set_var('sum_tax',number_format($sum_tax1+$sum_tax2,2,".",'')) ;
	$t->set_var('sum_netamount',$dt[netamount]) ;
	$t->set_var('sum_itemtotal',$dt[amount]) ;
	$t->parse('out','report',True);
	}

//---- Purchase Order Post Initialisation

    function po_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	if ($dt[taxstatus]=="e")	$dt[taxstatus] = "f" ;
	$dt[taxincluded] = $dt[taxstatus] ;
//	$dt[amount] = $dt[sum_itemtotal] ;
//	$dt[netamount] = $dt[sum_netamount] ;
	}

//---- Purchase Order Post - PreCommit Routine

    function po_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$op = &$ckapi[params_post][op] ;

	if ($op<>'new')		$phpgw->db->query("DELETE FROM ${pre}oitem WHERE trans_id=$id") ;
	if ($op<>'delete') {
		For ($i=1;isset($dt['itemid'.$i]);$i++) {
			$itemid		= $dt['itemid'.$i];
			$itemtype	= $dt['itemtype'.$i];
			$desc		= $dt['description'.$i];
			$unit		= $dt['unit'.$i];
			$qty		= $dt['qty'.$i];
			$cost		= $dt['cost'.$i];
			$discount	= $dt['discount'.$i];
			$tax1		= number_format($dt['tax1'.$i],2,".",'');
			$tax2		= number_format($dt['tax2'.$i],2,".",'');
			$sql = "INSERT INTO ${pre}oitem (trans_id,itemid,itemtype,description," ;
			$sql.= "unit,qty,cost,discount,tax1,tax2) " ;
			$sql.= "VALUES ('$id','$itemid','$itemtype','$desc'," ;
			$sql.= "'$unit','$qty','$cost','$discount','$tax1','$tax2')";
			$phpgw->db->query($sql);
			}
		}
	if ($op=='delete')	$phpgw->db->query("DELETE FROM ${pre}ipmatch where poid=$id") ;
	}
    }

?>
