<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cswtlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-c' ;
	$tran = 'cswt' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}pos" 				) ;
	$note = lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight') ;
	$ckapi[phrases] = array('lang_title'	=> lang("List of Cash Sales [with Tax]") ,
				'lang_add'	=> lang("Add New Cash Sale [with Tax]") ,
				'lang_note'	=> $note				) ;
	$ckapi[columns] = array('transdate'	=> lang('Sale Date') ,
				'shift'		=> lang('Shift') ,
				'cashbox'	=> lang('Cash Box') ,
				'posnumber'	=> lang('Cash Sale# [cashier:date:time]') ,
				'amount'	=> lang('Amount') ,
				'id'		=> lang('Audit ID') 			) ;
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'memo'		=> "/$app/${tran}memo.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_memo'	=> lang("Sales Memo") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
