<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cashboxfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'cashbox' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Cash Boxes :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Cash Box") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$morning = lang('Morning') ;
	$afternoon = lang('Afternoon') ;
	$overnight = lang('Overnight') ;
	$shift_sl = "<OPTION value='ALL'></OPTION>" ;
	$shift_sl.= "<OPTION value='1'>1 - $morning</OPTION>" ;
	$shift_sl.= "<OPTION value='2'>2 - $afternoon</OPTION>" ;
	$shift_sl.= "<OPTION value='3'>3 - $overnight</OPTION>" ;
	$ckapi[filter][] = array(criteria	=>	lang('Shift') ,
				type		=>	'select' ,
				selectlist	=>	$shift_sl ,
				varname		=>	'shift' ,
				defval		=>	"ALL" ,
				note		=>	lang('Search the appropriate shift') );

	$ckapi[filter][] = array(criteria	=>	lang('Cashier') ,
				type		=>	'input' ,
				varname		=>	'cashier' ,
				defval		=>	"" ,
				note		=>lang('Search for target key word in the cashier field') );

	$ckapi[filter][] = array(criteria	=>	lang('Cash Box Name') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	"" ,
				note	=>lang('Search for target key word in the cash box name field') );

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
