<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cashboxlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'cashbox' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}cashbox" 		);
	$ckapi[phrases] = array('lang_title'	=> lang("List of Cash Boxes") ,
				'lang_add'	=> lang("Add New Cash Box") ,
			'lang_note1'	=> lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight')	);
	$ckapi[columns] = array('name'		=> lang('Cashbox Name') ,
				'cashier'	=> lang('Cashier for Current Shift') ,
				'shift'		=> lang('Current Shift') ,
				'location'	=> lang('Location') ,
				'maxcash'	=> lang('Cash Full Warning Level') ,
				'id'		=> lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
