<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.service.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

	class service {

//---- Service Read

    function service_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniqueflds = $ckapi[params][uniqueflds] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("select * from ${pre}service where id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=1 and a.tax_id=b.id and b.taxgroup='ap'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[aptax1] = $phpgw->db->f('tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=2 and a.tax_id=b.id and b.taxgroup='ap'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[aptax2] = $phpgw->db->f('tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=1 and a.tax_id=b.id and b.taxgroup='ar'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[artax1] = $phpgw->db->f('tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=2 and a.tax_id=b.id and b.taxgroup='ar'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[artax2] = $phpgw->db->f('tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=1 and a.tax_id=b.id and b.taxgroup='cs'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[cstax1] = $phpgw->db->f('tax_id') ;
	$sql = "SELECT tax_id FROM ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=2 and a.tax_id=b.id and b.taxgroup='cs'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[cstax2] = $phpgw->db->f('tax_id') ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Service Detail Validation Checks

    function service_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	if ($dt[servicenumber]=="")			$err=lang("Service Name/Number Missing");
	if ($dt[listprice] and !is_numeric($dt[listprice]))
							$err=lang("Invalid list price, must be numeric");
	if ($dt[price] and !is_numeric($dt[price]))	$err=lang("Invalid selling price, must be numeric");
	if ($dt[cost] and !is_numeric($dt[cost]))	$err=lang("Invalid Cost, must be numeric") ;
	if ($dt[listprice] and $dt[price] and ($dt[listprice]<$dt[price]))
							$err=lang("List Price < Selling Price") ;
	if ($dt[servicenumber]<>$dt[oldservicenumber]) {
		$phpgw->db->query("SELECT * FROM ${pre}service where servicenumber='$dt[servicenumber]'");
		if ($phpgw->db->num_rows()>0)		$err=lang("Service Name/# already exists") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Service Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$invoice = lang('invoice') ; $order = lang('order');
	$quote = lang('quotation'); $cashsale = lang('cash sale') ;
	$errmsg1 = lang("This service item is in use within an existing") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}invoice WHERE itemid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $invoice id#".$phpgw->db->f('trans_id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}oitem WHERE itemid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $order/$quote id#".$phpgw->db->f('trans_id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}positem WHERE itemid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $cashsale id#".$phpgw->db->f('trans_id') ;
		}
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Service Detail

    function service_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_tbi',lang("(To be implemented)"));
	$t->set_var('lang_ginfo',lang("General Information"));
	$t->set_var('lang_number',lang("Name/Number"));
	$t->set_var('lang_description',lang("Description"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_quantity',lang("Quantity"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_pricecost',lang("Price/Cost"));
	$t->set_var('lang_listprice',lang("List Price"));
	$t->set_var('lang_price',lang("Selling Price"));
	$t->set_var('lang_priceupdate',lang("Price Last Updated on"));
	$t->set_var('lang_cost',lang("Standard Cost"));
	$t->set_var('lang_costupdate',lang("Cost Last Updated on"));
	$t->set_var('lang_notes',lang("Notes"));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts"));
	$t->set_var('lang_income_accno',lang("Income"));
	$t->set_var('lang_expense_accno',lang("Expense"));
	$t->set_var('lang_aptax1',lang("Primary Tax Paid to Vendor"));
	$t->set_var('lang_aptax2',lang("Secondary Tax Paid to Vendor"));
	$t->set_var('lang_artax1',lang("Primary Tax from Customer"));
	$t->set_var('lang_artax2',lang("Secondary Tax from Customer"));
	$t->set_var('lang_cstax1',lang("Primary Tax for Cash Sale"));
	$t->set_var('lang_cstax2',lang("Secondary Tax for Cash Sale"));
	$t->set_var('lang_reserved',lang("Reserved Space")) ;

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('servicenumber',$dt[servicenumber]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('description',$dt[description]);
	$t->set_var('notes',$dt[notes]);
	$t->set_var('unit',$dt[unit]);
	$t->set_var('listprice',$dt[listprice]);
	$t->set_var('price',$dt[price]);
	$t->set_var('oldprice',$dt[oldprice]);
	$t->set_var('priceupdate',$dt[priceupdate]);
	$t->set_var('cost',$dt[cost]);
	$t->set_var('oldcost',$dt[oldcost]);
	$t->set_var('costupdate',$dt[costupdate]);
	$inc_accno = $dt[income_accno_id] ;
	$t->set_var('income_accno',$inc_accno);
	$t->set_var('inc_acc_option_block', account_selectlist("WHERE link like '%SV_income%'",$inc_accno));
	$exp_accno = $dt[expense_accno_id] ;
	$t->set_var('expense_accno',$exp_accno);
	$t->set_var('exp_acc_option_block',account_selectlist("WHERE link like '%SV_expense%'",$exp_accno));
	$t->set_var('aptax1_selectlist',tax_selectlist("WHERE taxgroup='ap'",$dt[aptax1]));
	$t->set_var('aptax2_selectlist',tax_selectlist("WHERE taxgroup='ap'",$dt[aptax2]));
	$t->set_var('artax1_selectlist',tax_selectlist("WHERE taxgroup='ar'",$dt[artax1]));
	$t->set_var('artax2_selectlist',tax_selectlist("WHERE taxgroup='ar'",$dt[artax2]));
	$t->set_var('cstax1_selectlist',tax_selectlist("WHERE taxgroup='cs'",$dt[cstax1]));
	$t->set_var('cstax2_selectlist',tax_selectlist("WHERE taxgroup='cs'",$dt[cstax2]));

	$t->parse('out','report',True);
	}

//---- Service Post Initialisation

    function service_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$op = &$ckapi[params_post][op] ;

	$dt[priceupdate] = ($dt[oldprice]<>$dt[price] or $op=='new') ? date("Y-m-d") : $dt[priceupdate] ;
	$dt[costupdate] = ($dt[oldcost]<>$dt[cost] or $op=='new') ? date("Y-m-d") : $dt[costupdate] ;
	}

//---- Service Post - PreCommit Routine

    function service_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	if ($op<>'new')		$phpgw->db->query("DELETE FROM ${pre}itemtax WHERE item_id=$id") ;
	if ($op<>'delete') {
		$sql="INSERT INTO ${pre}itemtax (item_id,tax_id,taxtype) " ;
		if ($dt[aptax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[aptax1]','1')");
		if ($dt[aptax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[aptax2]','2')");
		if ($dt[artax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[artax1]','1')");
		if ($dt[artax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[artax2]','2')");
		if ($dt[cstax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[cstax1]','1')");
		if ($dt[cstax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[cstax2]','2')");
		}
	}

    }

?>
