<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: expclist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-sss' ;
	$tran = 'expc' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}pynr_trans" ,
				'sortkey'	=> "staff,name" ,
				'doneexit'	=> "approvefilter.php"			);
	$msg = lang('To allow auto email approval advice, email/dns environment must be correctly setup.');
	$ckapi[phrases] = array('lang_title'	=> lang("Staff Expense/Allowance (E/A) Claim Approval List") ,
				'lang_add'	=> lang("Done") ,
				'message'	=> $msg					);
	$ckapi[columns] = array('staff'		=> lang('Employee Name/#') ,
				'name'		=> lang('E/A Name') ,
				'description'	=> lang('Expense/Allowance Description') ,
				'qty'		=> lang('Quantity') ,
				'unit'		=> lang('Unit') ,
				'unitamt'	=> lang('Unit Amount') ,
				'rate'		=> lang('Pay Rate') ,
				'amount'	=> lang('Amount') ,
				'comment'	=> lang('Comment') ,
				'approved_by'	=> lang('Approved By') ,
				'id'		=> lang('Audit ID') 			);
	$ckapi[links]	 = array(	'approve'	=> "/$app/${tran}approve.php" ,
					'cancel'	=> "/$app/${tran}cancel.php" ,
					'reject'	=> "/$app/${tran}reject.php"	) ;
	$ckapi[lang_links] = array(	'lang_approve'	=> lang("Approve") ,
					'lang_cancel'	=> lang("Cancel Approval") ,
					'lang_reject'	=> lang("Reject") ,
					'lang_log'	=> lang("Log")			) ;

	$proc2 = CreateObject('ck-api.process2') ;
	$proc2->process2_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
