<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ts.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class ts {

//---- TS List SQL Formation

    function ts_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$where = str_replace("approved_by=''","(approved_by='' or approved_by is NULL)",$where) ;
	if (!$order) {$order = "name,year,week" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql = "SELECT name,year,week,hour_ttl,day_ttl,approved_by,a.id " ;
	$sql.= "FROM ${pre}timesheet a, ${pre}employee b  " ;
	$sql.= "WHERE $where and empid=b.id ORDER BY ".$order." ".$sort ;
	return $sql ;
	}

//---- TS List Link Adjustement

    function ts_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	if ($ckapi[params_list][dt][approved_by]=='')
		$t->set_var(array(	'lang_cancel'	=> '',
					'cancel'	=> ''	)) ;
	  else	$t->set_var(array(	'lang_approve'	=> '',
					'lang_reject'	=> '',
					'approve'	=> '',
					'reject'	=> ''	)) ;
	}

//---- TS Read

    function ts_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$sql = "SELECT a.id,empid,name,year,week,hour_ttl,day_ttl,a.control " ;
	$sql.= "FROM ${pre}timesheet a,${pre}employee b " ;
	$sql.= "WHERE a.id=$id and empid=b.id";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$sql = "SELECT a.*,b.* FROM ${pre}ts_trans a, ${pre}timesheet b " ;
	$sql.= "WHERE trans_id='$id' and a.trans_id=b.id ORDER BY a.id";
	$phpgw->db->query($sql);
	$dt[tsyear0] = date("Y") ;
	$dt[tsmonth0] = date("m") ;
	$dt[tsday0] = date("d") ;
	For ($i=1;$phpgw->db->next_record();$i++) {
		$transdate		=	$phpgw->db->f('transdate') ;
		$dt['tsyear'.$i]	=	substr($transdate,0,4) ;
		$dt['tsmonth'.$i]	=	substr($transdate,5,2) ;
		$dt['tsday'.$i]		=	substr($transdate,8,2) ;
		$dt['project'.$i]	=	$phpgw->db->f('project') ;
		$dt['activity'.$i]	=	$phpgw->db->f('activity') ;
		$dt['hour'.$i]		=	$phpgw->db->f('hour') ;
		$dt['day'.$i]		=	$phpgw->db->f('day') ;
		$dt['achieve'.$i]	=	$phpgw->db->f('achieve') ;
		$dt['achival'.$i]	=	$phpgw->db->f('achival') ;
		$dt['achiunit'.$i]	=	$phpgw->db->f('achiunit') ;
		}
	return $dt ;
	}

//---- TS Validation Checks

    function ts_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$err="";
	$error = lang("Error") ;
	if ($dt[reason]=="")	$err=lang("Cancel/Reject Reason Missing") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write ts Header

    function ts_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',lang('Employee'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_year',lang('Year'));
	$t->set_var('lang_week',lang('Week'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$user = $ckapi[hostsys][username];
	$empid = $dt[empid] ;
	$sql = "SELECT b.username FROM ${pre}employee a, ${pre}employee b " ;
	$sql.= "WHERE a.id='$empid' and a.supervisor=b.id";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$where = " WHERE id='$empid' " ;
	$t->set_var('empid_selectlist',employee_selectlist($where,$empid)) ;
	$t->set_var('year_selectlist',year_selectlist('',$dt[year])) ;
	$t->set_var('week_selectlist',week_selectlist('',$dt[week])) ;
	$t->set_var('approved_by',$dt[approved_by]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Write ts Detail

    function ts_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$lang_activity = lang('activity') ;
	$lang_leave = lang('leave') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_pah',lang('Project---Activity/Leave---Hours---Days'));
	$t->set_var('lang_achievement',lang('Result Achieved'));
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_tsyear',lang('Year'));
	$t->set_var('lang_tsmonth',lang('Month'));
	$t->set_var('lang_tsday',lang('Day'));
	$t->set_var('lang_project',lang('Project'));
	$t->set_var('lang_activity',lang('Activity/Leave'));
	$t->set_var('lang_hour',lang('Hour Worked'));
	$t->set_var('lang_day',lang('Days On Leave'));
	$t->set_var('lang_achieve',lang('Achievement'));
	$t->set_var('lang_achival',lang('Value'));
	$t->set_var('lang_achiunit',lang('Unit'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('tsyear0_selectlist',year_selectlist('',$dt[tsyear0],'short')) ;
	$t->set_var('tsmonth0_selectlist',month_selectlist('',$dt[tsmonth0],'short')) ;
	$t->set_var('tsday0_selectlist',day_selectlist('',$dt[tsday0],'short')) ;

	$nullopt = "<OPTION value=''></OPTION>" ;
	$act_sl = hrcodename_selectlist("WHERE type='$lang_activity'",'','long') ;
	$act_sl.= $nullopt ;
	$act_sl.= "<OPTION value=''>".lang('On Leave (Pls enter -0- as hours worked)')."</OPTION>" ;
	$act_sl.= hrcodename_selectlist("WHERE type='$lang_leave'",'','long') ;
	$lang_day = lang('day') ;
	$day_sl = $nullopt."<OPTION value='1'>1 $lang_day</OPTION><OPTION value='0.5'>0.5 $lang_day</OPTION>" ;
	$hour_ttl = 0;
	For ($i=1;isset($dt['tsyear'.$i]);$i++) {
		$t->set_var('tsyear_fld','tsyear'.$i) ;
		$t->set_var('tsmonth_fld','tsmonth'.$i) ;
		$t->set_var('tsday_fld','tsday'.$i) ;
		$t->set_var('project_fld','project'.$i) ;
		$t->set_var('activity_fld','activity'.$i) ;
		$t->set_var('hour_fld','hour'.$i) ;
		$t->set_var('day_fld','day'.$i) ;
		$t->set_var('achieve_fld','achieve'.$i);
		$t->set_var('achival_fld','achival'.$i);
		$t->set_var('achiunit_fld','achiunit'.$i);
		$t->set_var('tsyear_selectlist',year_selectlist('',$dt['tsyear'.$i],'short')) ;
		$t->set_var('tsmonth_selectlist',month_selectlist('',$dt['tsmonth'.$i],'short')) ;
		$t->set_var('tsday_selectlist',day_selectlist('',$dt['tsday'.$i],'short')) ;
		$t->set_var('project_selectlist',$nullopt.project_selectlist('',$dt['project'.$i],'short')) ;
		$default = $dt['activity'.$i] ;
		$t->set_var('activity_selectlist',str_replace("'$default'","'$default' selected",$act_sl)) ;
		$t->set_var('hour',$dt['hour'.$i]) ;
		$default = $dt['day'.$i] ;
		$t->set_var('day_selectlist',str_replace("'$default'","'$default' selected",$day_sl)) ;
		$t->set_var('achieve_selectlist',achieve_selectlist("",$dt['achieve'.$i],'short')) ;
		$t->set_var('achival',$dt['achival'.$i]) ;
		$t->set_var('achiunit',$dt['achiunit'.$i]) ;
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->set_var('lang_total',lang('Total'));
	$t->set_var('hour_ttl',$dt[hour_ttl]) ;
	$t->set_var('day_ttl',$dt[day_ttl]) ;
	$t->set_var('reason',$dt[reason]) ;

	$t->parse('out','report',True);
	}

//---- TS Post - PreCommit Routine

    function ts_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	$empid = $dt[empid] ;
	if ($op=='approve') {
		For ($i=1;isset($dt['tsyear'.$i]);$i++) {
			if ($dt['day'.$i]==0)	continue ;
			$transdate= $dt['tsyear'.$i]."-".$dt['tsmonth'.$i]."-".$dt['tsday'.$i];
			$leavecode	= $dt['activity'.$i] ;
			$duration	= $dt['day'.$i] ;
			$sql ="INSERT INTO ${pre}leave(empid,trans_id,leavefrom,leaveto,leavecode,duration) ";
			$sql.= "VALUES ('$empid','$id','$transdate','$transdate','$leavecode','$duration')";
			$phpgw->db->query($sql);
			}
		}
	if ($op=='cancel')	$phpgw->db->query("DELETE from ${pre}leave where trans_id = '$id'");
	}

//---- ts Post - PostCommit Routine

    function ts_post_postcommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key=>$val)	$ckapi[buttons][$key]=($_GET[$key])? $_GET[$key]:$_POST[$key];
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;

	$lang_year = lang("YEAR") ;
	$lang_week = lang("WEEK") ;
	$lang_approval = lang("Approval") ;
	$lang_reason = lang("Reason") ;
	$inform = lang("Please manually inform") ;
	$year = $dt[year] ;
	$week = $dt[week] ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$dt[empid]' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$superid' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;
	$message = '' ;
	$headers = "From: $supername < $superemail >\n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $supername < $superemail >\n" ;

	switch ($op) :
	    case "approve" :
		$subject = "[$staffname] $lang_tran [$lang_year:$year $lang_week:$week] $actioned." ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email approving timesheet successfully queued for despatch to") ;
		$failuremsg = lang("Email approving timesheet fails to deliver.")."  $inform" ;
		break ;
	    case "cancel" :
		$subject = "[$staffname] $lang_tran [$lang_year:$year $lang_week:$week] " ;
		$subject.= "$lang_approval $actioned.  $lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg =lang("Email advising approval cancellation successfully queued for despatch to");
		$failuremsg =lang("Email advising approval cancellation fails to deliver.")."  $inform" ;
		break ;
	    case "reject" :
		$subject = "[$staffname] $lang_tran [$lang_year:$year $lang_week:$week] $actioned.  " ;
		$subject.= "$lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email rejecting timesheet successfully queued for despatch to") ;
		$failuremsg = lang("Email rejecting timesheet fails to deliver.")."  $inform" ;
		break ;
	    endswitch ;

	if ($result)	$msg = "<br>$successmsg $staffname." ;
		else	$msg = "<br>$failuremsg $staffname." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>
