<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: categoryfilter.php,v 0.10.1 2004/10/31 C K Wu $ */

	$app = 'ck-vrm' ;
	$tran = 'category' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}category" 			) ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Categories :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Category") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$ckapi[filter][] = array(criteria	=>	lang('Category Type') ,
				type		=>	'select' ,
				selectlist	=>	categorytype_selectlist("WHERE app='ck-vrm'",'') ,
				varname		=>	'type' ,
				defval		=>	'' ,
				note		=>	lang('Search for target Category Type'));

	$ckapi[filter][] = array(criteria	=>	lang('Category Name/Abbreviation') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Category Name  field')) ;

	$ckapi[filter][] = array(criteria	=>	lang('Description') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Category Description  field')) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
