<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.8.1 2004/07/31 C K Wu $ */

	$app = 'ck-vrm' ;
	$tran = 'control' ;
	include('../ck-api/ckapi.inc.php') ;

	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;

/*---------------------------------------------------------------------------------*/

    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir(ck-hr));
    $t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('message',"");
	$t->set_var('lang_control_report', lang('Vendor Relationship Audit Control Report'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_system_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_date', lang('Status Date'));
	$t->set_var('lang_system_date', lang('System Date'));
	$t->set_var('lang_vendor', lang('Vendor'));
	$t->set_var('lang_contract', lang('Contract'));
	$t->set_var('lang_vendcase', lang('Contact cases'));
	$t->set_var('lang_vendcall', lang('Contact calls'));
	$t->set_var('lang_category', lang('VRM category'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Database Info---------------------------------*/

$na = lang("N/A") ;
$t->set_var('status_date',$rdate) ;
$t->set_var('vendor_count',$na) ;
$t->set_var('latest_vendor_id',$na) ;
$t->set_var('contract_count',$na) ;
$t->set_var('latest_contract_id',$na) ;
$t->set_var('category_count',$na) ;
$t->set_var('latest_category_id',$na) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}vendcase WHERE start<='$rdate'";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('vendcase_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_vendcase_id',$phpgw->db->f('max_id')) ;

$sql = "SELECT count(a.id) as cnt, max(a.id) as max_id from ${pre}vendcall a, ${pre}vendcase b ";
$sql.= "WHERE caseid=b.id and start<='$rdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('vendcall_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_vendcall_id',$phpgw->db->f('max_id')) ;


$t->set_var('system_date',date("Y-m-d",time())) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}vendor";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_vendor_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_vendor_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}pcontract";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_contract_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_contract_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}vendcase";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_vendcase_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_vendcase_id',$phpgw->db->f('max_id')) ;

$sql="SELECT count(id) as cnt, max(id) as max_id from ${pre}vendcall";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_vendcall_count',$phpgw->db->f('cnt')) ;
$t->set_var('sys_latest_vendcall_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(id) as category_count, max(id) as max_id from ${pre}category WHERE app='$app'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('sys_category_count',$phpgw->db->f('category_count')) ;
$t->set_var('sys_latest_category_id',$phpgw->db->f('max_id')) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
