<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.category.inc.php,v 0.10.1 2004/10/31 C K Wu $ */

    class category {

//---- HR Code Detail Validation Checks

    function category_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$maxname = 10 ;
	$maxdesc = 40 ;
	$desc = $dt[description] ;
	if ($dt[name]=="")			$err = lang("Category name Missing") ;
	   else if (strlen($dt[name])>$maxname)	$err = lang("Category name too long") ;
	if ($desc=="")				$err = lang("Category description Missing") ;
	   else if (strlen($desc)>$maxdesc)	$err = lang("Category description too long") ;
	if ($dt[type]<>$dt[oldtype] or $dt[name]<>$dt[oldname]) {
		$sql = "SELECT * from ${pre}category where type='$dt[type]' and name='$dt[name]'";
		$phpgw->db->query($sql);
		if ($phpgw->db->num_rows()>0)	$err = lang("Type/Name Combo already exists") ;
		}
	if ($dt[app]<>$ckapi[params][app])	$err = lang("Invalid hidden app var -> Inform system admin") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- HR Code Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$allow = $dt[allowdelete] ;
	if ($allow<>"y" and $allow<>"Y")	$err = lang("Category flagged deletion not allowed");
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write HR Code Detail

    function category_write() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$dt[parent] = 0 ;
	$noyes_sl = "<OPTION value='n'>".lang('No')."</OPTION>" ;
	$noyes_sl.= "<OPTION value='y'>".lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_type',lang('Category Type'));
	$t->set_var('lang_name',lang('Category Name'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_adelete',lang('Allow Delete'));
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('app',$ckapi[params][app]);
	$t->set_var('type_selectlist',categorytype_selectlist("WHERE app='ck-vrm'",$dt[type]));
	$t->set_var('oldtype',$dt[oldtype]);
	$t->set_var('name',$dt[name]);
	$t->set_var('oldname',$dt[oldname]);
	$t->set_var('description',$dt[description]);
	$ad_sl = str_replace("'$dt[allowdelete]'","'$dt[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$t->parse('out','report',True);
	}

    }

?>
