<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: adminfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'admin' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$ckapi[phrases] = array('lang_title'	=> lang("Choose Admin Action to Perform :") ,
				'lang_criteria'	=> lang("Admin Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Action") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$chartlist1 = lang('1 -- Default Chart of Accounts') ;
	$chartlist2 = lang('2 -- Chart of Accounts for Non-profit Org (School Band)') ;
	$chartlist3 = lang('3 -- Chart of Accounts for Property Management Org') ;
	$chartlist =	"<OPTION value='1'>$chartlist1</OPTION>" ;
	$chartlist.=	"<OPTION value='2'>$chartlist2</OPTION>" ;
	$chartlist.=	"<OPTION value='3'>$chartlist3</OPTION>" ;
	$instestenv = lang('Install Test Environment') ;
	$insprodenv = lang('Install Production Environment') ;
	$convertchi = lang('Convert big5/gb18030 to utf-8') ;
	$note_chart1 = lang("Generate chosen Chart of Accounts, tax and other essential data.") ;
	$note_chart2 = lang("It is most likely that you will have to adjust these master data to meet your local requirements.");
	$warning1 = lang("For use by Chinese eGroupWare Users only");
	$warning2 = lang("You need to allow Apache to write to your script folders") ;
	$warning3 = lang("Restore the script folders original access right afterwards") ;
	$warning4 = lang("If you are phpGroupWare user, you should terminate immediately") ;

	$ckapi[filter][] = array(criteria	=>	lang('Which Action') ,
				type		=>	'select' ,
				selectlist	=>	"" ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note	=>lang('If wrong action chosen, click [Admin/Setup] to restart'));

	$ckapi[filter][] = array(criteria	=>	lang('Which Chart') ,
				type		=>	'select' ,
				selectlist	=>	$chartlist ,
				varname		=>	'chart' ,
				defval		=>	"" ,
				note		=>lang('Select the target Chart of Account to install'));

	$ckapi[filter][] = array(criteria	=>	lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	$instestenv					);

	$ckapi[filter][] = array(criteria	=>	lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	$insprodenv					);

	$ckapi[filter][] = array(criteria	=>	lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>"<b>$warning1.  $warning2.  $warning3.<br>$warning4.</b>"			);
	
	$act1 = "1 -- $instestenv" ;
	$act2 = "2 -- $insprodenv" ;
	$act3 = "3 -- $convertchi" ;
	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>$act1</OPTION>",
						2=>	"<OPTION value='2'>$act2</OPTION>",
						3=>	"<OPTION value='3'>$act3</OPTION>"	) ;

	$ckapi[filter][actstring] = array(	"0",		/* first entry	*/
						"02",		/* Action 1	*/
						"013",		/* Action 2	*/
						"04",		/* Action 3	*/		) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
