<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: defaultsfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'defaults' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$warning = lang("Make Sure all other users had logged off from the system") ;
	$ckapi[phrases] = array('lang_title'	=> lang("Choose which group of Default Values to Edit :") ,
				'lang_criteria'	=> lang("Group of Default Values") ,
				'lang_value'	=> lang("Parameter Value") ,
				'lang_note'	=> lang("Start Related Action") ,
				'lang_search'	=> lang("Done") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> $warning ,
				'disabled'	=> "disabled"				);

	$lang_edit = lang('Edit') ;
	$lang_view = lang('View Edit History Log') ;
	$link_genedit = $phpgw->link("/$app/defaultsgenedit.php") ;
	$link_lgredit = $phpgw->link("/$app/defaultslgredit.php") ;
	$link_apredit = $phpgw->link("/$app/defaultsapredit.php") ;
	$link_posedit = $phpgw->link("/$app/defaultsposedit.php") ;
	$link_hrpedit = $phpgw->link("/$app/defaultshrpedit.php") ;
	$link_cssedit = $phpgw->link("/$app/defaultscssedit.php") ;
	$phpgw->db->query("SELECT id from ${pre}defaults");
	$phpgw->db->next_record() ;
	$id = $phpgw->db->Record[id] ;
	$loggetstr = "return=/$app/${tran}filter.php&id=$id" ;
	$link_view = $phpgw->link("/$app/loglist.php",$loggetstr) ;

	$ckapi[filter][] = array(criteria	=>	lang('Generic default values') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_genedit'>$lang_edit</a>");

	$ckapi[filter][] = array(criteria	=>	lang('Ledger default values') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_lgredit'>$lang_edit</a>",);

	$ckapi[filter][] = array(criteria	=>	lang('AP/AR/PO/SO/Quotation default values'),
				type		=>	'input' ,
				varname		=>	'' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_apredit'>$lang_edit</a>");

	$ckapi[filter][] = array(criteria	=>	lang('Point of Sale default values'),
				type		=>	'input' ,
				varname		=>	'chart' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_posedit'>$lang_edit</a>");

	$ckapi[filter][] = array(criteria	=>	lang('HR/SSS/Payroll default values'),
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_hrpedit'>$lang_edit</a>");

	$ckapi[filter][] = array(criteria	=>	lang('Customer Self Service default values'),
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_cssedit'>$lang_edit</a>");

	$ckapi[filter][] = array(criteria	=>	lang('[View Default Value Edit History Log]'),
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_view'>$lang_view</a>");

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
