<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invoiceaging.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ap' ;
	$tran = 'invoiceaging' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$vendor = ($_GET["vendor"]) ? $_GET["vendor"] : $_POST["vendor"] ;
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report','invoiceaging.tpl') ;
	$t->set_block('report','invoice_row','invoice_section');

/*---------------------------------------------------------------------------------*/

	$agingrep = lang('VENDOR INVOICE AGING REPORT') ;
	$asof	= lang('as of') ;
	$t->set_var('lang_invoiceaging', "$agingrep $asof $repdate");
	$lang_vendor = lang('Vendor:') ;
	$t->set_var('lang_vendor', "$lang_vendor    ");

	$t->set_var('lang_duedate', lang('DUE DATE'));
	$t->set_var('lang_invnumber', lang('INVOICE#'));
	$t->set_var('lang_invoiceid',lang('AUDIT ID'));
	$t->set_var('lang_isocode', lang('CURRENCY'));
	$t->set_var('lang_amount', lang('AMOUNT'));
	$t->set_var('lang_paidamount', lang('PAID'));
	$t->set_var('lang_osamount', lang('O/S'));
	$t->set_var('lang_separator', '|');
	$t->set_var('lang_notdue', lang('NOT DUE'));
	$t->set_var('lang_0to30', lang('1-30'));
	$t->set_var('lang_31to60', lang('31-60'));
	$t->set_var('lang_61to90', lang('61-90'));
	$t->set_var('lang_91to120', lang('91-120'));
	$t->set_var('lang_120plus', lang('120+'));
	$t->set_var('lang_detail', lang('DETAIL'));
	$t->set_var('lang_history', lang('History'));
	$t->set_var('lang_total', lang('Total'));
	$t->set_var('lang_unallocated', lang('Unallocated'));
	$t->set_var('lang_net', lang('Net O/S'));
	$note1 = lang('Note 1') ;
	$t->set_var('lang_note1',$note1);
	$note1a = lang('These lines are for control reconciliation purpose only') ;
	$note1b = lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 - $note1a. $note1b.");

	$sql = "SELECT name FROM ${pre}vendor WHERE id='$vendor'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$t->set_var('vendor',$phpgw->db->f('name')." -- ".$vendor) ;
	$id = $vendor ;
	$sql ="SELECT sum(amount) as totpaidamt FROM ${pre}payment " ;
	$sql.="WHERE vendor='$id' and transdate <= '$repdate'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$totpaidamt = $phpgw->db->f('totpaidamt') ;
	$sql ="SELECT sum(s_amount) as allocated FROM ${pre}payment a, ${pre}p_match b " ;
	$sql.="WHERE vendor='$id' and transdate <= '$repdate' and a.id=paymentid";
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$allocated = $phpgw->db->f('allocated') ;
	$unallocated = $totpaidamt-$allocated ;

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}ap1".$user.time() ;
	$temp2 = "${pre}ap2".$user.time() ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.="SELECT invnumber,id,isocode,transdate,duedate,amount,netamount,0.0 as paidamount FROM ${pre}ap ";
	$sql.="WHERE vendor='$id' and transdate <= '$repdate'";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT invnumber,a.id,a.isocode,a.transdate,duedate,0.0 as amount,0.0 as netamount,sum(s_amount) as paidamount " ;
	$sql.= "FROM ${pre}ap a, ${pre}p_match b, ${pre}payment c ";
	$sql.= "WHERE a.vendor='$id' and a.transdate<='$repdate' and a.id=b.invoiceid and " ;
	$sql.=				"c.transdate<='$repdate' and c.id=paymentid " ;
	$sql.= "GROUP BY a.transdate,a.isocode,duedate,a.id,invnumber";
	$phpgw->db->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT invnumber,id,isocode,transdate,duedate,sum(amount) as amount,sum(netamount) as netamount," ;
	$sql.=				"sum(paidamount) as paidamount,0.0 as osamount " ;
	$sql.= "FROM $temp1 GROUP BY isocode,transdate,duedate,id,invnumber ";
	$phpgw->db->query($sql);
	$sql = "UPDATE $temp2 SET osamount=amount-paidamount" ;
	$phpgw->db->query($sql);
	$sql = "SELECT * FROM $temp2 WHERE osamount > 0 ORDER BY duedate,id" ;
	$phpgw->db->query($sql) ;

if ($phpgw->db->num_rows()==0) {
	$t->set_var('duedate','') ;
	$t->set_var('invnumber',lang('No invoice outstanding')) ;
	$t->set_var('invoiceid','') ;
	$t->set_var('isocode','') ;
	$t->set_var('amount','') ;
	$t->set_var('paidamount','') ;
	$t->set_var('osamount','') ;
	$t->set_var('notdue','') ;
	$t->set_var('0to30','') ;
	$t->set_var('31to60','') ;
	$t->set_var('61to90','') ;
	$t->set_var('91to120','') ;
	$t->set_var('120plus','') ;
	$t->set_var('history','') ;
	$t->set_var('lang_history','');
	$t->parse('invoice_section','invoice_row',True);
	}
$sumamount = $sumpaid = $sumos = 0 ;
$sumnotdue = $sum30 = $sum60 = $sum90 = $sum120 = $sum120plus = 0 ;
while ($phpgw->db->next_record()) {
	$duedate = $phpgw->db->f('duedate') ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('invnumber',$phpgw->db->f('invnumber')) ;
	$t->set_var('isocode',$phpgw->db->f('isocode')) ;
	$id		=	$phpgw->db->f('id') ;
	$amount		=	$phpgw->db->f('amount') ;
	$netamount	=	$phpgw->db->f('netamount') ;
	$paidamount	=	$phpgw->db->f('paidamount') ;
	$osamount	=	$phpgw->db->f('osamount') ;
	$t->set_var('invoiceid',$id) ;
	$t->set_var('amount',$amount) ;
	$t->set_var('paidamount',$paidamount) ;
	$t->set_var('osamount',$osamount) ;
	$overdue = (strtotime($repdate)-strtotime($duedate))/86400 ;
	$age = $overdue < 0 ? 0 : floor($overdue) ;
	$notdue = $age30 = $age60 = $age90 = $age120 = $age120plus = "" ;
	if ($age==0)				$notdue = $osamount ;
	if ($age>0 and $age<31)		$age30 = $osamount ;
	if ($age>30 and $age<61)	$age60 = $osamount ;
	if ($age>60 and $age<91)	$age90 = $osamount ;
	if ($age>90 and $age<121)	$age120 = $osamount ;
	if ($age>120)				$age120plus = $osamount ;
	$t->set_var('notdue',$notdue) ;
	$t->set_var('0to30',$age30) ;
	$t->set_var('31to60',$age60) ;
	$t->set_var('61to90',$age90) ;
	$t->set_var('91to120',$age120) ;
	$t->set_var('120plus',$age120plus) ;
	if ($amount==$netamount)	$filter = urlencode(" WHERE amount=netamount and a.id=$id ") ;
		else		$filter = urlencode(" WHERE amount<>netamount and a.id=$id ") ;
	$history = $phpgw->link("/$app/invpayhist.php","id=$id&filter=$filter");
	$t->set_var('history',$history) ;
	$t->parse('invoice_section','invoice_row', True);

	$sumamount	+=	$amount ;
	$sumpaid	+=	$paidamount ;
	$sumos		+=	$osamount ;
	$sumnotdue	+=	$notdue ;
	$sum30		+=	$age30 ;
	$sum60		+=	$age60 ;
	$sum90		+=	$age90 ;
	$sum120		+=	$age120 ;
	$sum120plus	+=	$age120plus ;
	}
$t->set_var('sumamount',$sumamount) ;
$t->set_var('sumpaid',$sumpaid) ;
$t->set_var('sumos',$sumos) ;
$t->set_var('sumnotdue',$sumnotdue) ;
$t->set_var('sum30',$sum30) ;
$t->set_var('sum60',$sum60) ;
$t->set_var('sum90',$sum90) ;
$t->set_var('sum120',$sum120) ;
$t->set_var('sum120plus',$sum120plus) ;
$t->set_var('unallocated',$unallocated) ;
$t->set_var('net',$sumos-$unallocated) ;
$t->set_var('lang_notes',lang('Press [done] button at Detail History screen to go on to invoice maintenance'));

$sql = "DROP TABLE $temp1, $temp2" ;
$phpgw->db->query($sql);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
