<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: brstatement.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'brstatement' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$chart_id = ($_GET["chart_id"]) ? $_GET["chart_id"] : $_POST["chart_id"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$bankbal = ($_GET["bankbal"]) ? $_GET["bankbal"] : $_POST["bankbal"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-bank'));
	$t->set_file('report','brstatement.tpl') ;
	$t->set_block('report','bankbal_row','bankbal_section');
	$t->set_block('report','ledgbal_row','ledgbal_section');
	$note1 = lang("Adj Statement Balance <> Adj Ledger Balance") ;
	$note2 = lang("Check to ensure prior periods' statement items are posted back to the Ledger") ;
	$note = "$note1:  $note2." ;

/*---------------------------------------------------------------------------------*/

	$phpgw->db->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'") ;
	$phpgw->db->next_record();
	$bankacline = lang('Bank Account').":  ".$phpgw->db->f('accno')." -- ".$phpgw->db->f('description') ;
	$t->set_var('bankacline',$bankacline);
	$t->set_var('dateline',lang('Reconciliation Date').":  ".$to);

	$t->set_var('lang_brstatement', lang('Bank Reconciliation Statement'));
	$t->set_var('lang_notes','notes.tba');
	$t->set_var('lang_date', lang('Date'));
	$t->set_var('lang_source', lang('Source'));
	$t->set_var('lang_description', lang('Description'));
	$t->set_var('lang_refnumber',lang('Ref Number'));
	$t->set_var('lang_cheque', lang('Cheque#'));
	$t->set_var('lang_status', lang('Status'));
	$t->set_var('lang_amount', lang('Amount'));

/*-----------------List Report Content -----------------------------------
//------------------------------------------------------------------------*/

	$t->set_var('brdate',$to) ;
	$t->set_var('lang_bankbal',lang('Bank Statement Balance')) ;
	$t->set_var('bankbal',$bankbal) ;

	$sql = "SELECT * FROM ${pre}bkr_trans WHERE chart_id='$chart_id' AND transdate<='$to' AND " ;
	$sql.= " substring(source,1,2)<>'SI' AND (status<>'c' or status is null) ORDER BY transdate" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0) {
		$t->set_var('date','') ;
		$t->set_var('source','') ;
		$t->set_var('description',lang('No Ledger Item found')) ;
		$t->set_var('refnumber','') ;
		$t->set_var('cheque','') ;
		$t->set_var('status','') ;
		$t->set_var('amount','') ;
		$t->parse('bankbal_section','bankbal_row',True);
		}
	while ($phpgw->db->next_record()) {
		$amount = $phpgw->db->f('amount') ;
		$t->set_var('date',$phpgw->db->f('transdate')) ;
		$t->set_var('source',$phpgw->db->f('source')) ;
		$t->set_var('description',$phpgw->db->f('description')) ;
		$t->set_var('refnumber',$phpgw->db->f('refnumber')) ;
		$t->set_var('cheque',$phpgw->db->f('cheque')) ;
		$t->set_var('status',$phpgw->db->f('status')) ;
		$t->set_var('amount',$amount) ;
		$t->parse('bankbal_section','bankbal_row',True);
		$bankbal += $amount ;
		}
	$t->set_var('lang_adjbankbal',lang('Adjusted Bank Statement Balance')) ;
	$t->set_var('adjbankbal',$bankbal) ;

	$t->set_var('lang_ledgbal',lang('Ledger (Bank) Account Balance')) ;
	$sql =	"SELECT sum(amount) as balance FROM ${pre}acc_trans " ;
	$sql.=	"WHERE chart_id='$chart_id' and transdate<='$to'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$ledgbal = -$phpgw->db->f('balance') ;
	$t->set_var('ledgbal',$ledgbal) ;

	$sql = "SELECT * FROM ${pre}bkr_trans WHERE chart_id='$chart_id' AND substring(source,1,2)='SI' AND ";
	$sql.= "transdate>='$from' AND transdate<='$to' ORDER BY transdate" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0) {
		$t->set_var('date','') ;
		$t->set_var('source','') ;
		$t->set_var('description',lang('No Bank Statement Item found')) ;
		$t->set_var('refnumber','') ;
		$t->set_var('cheque','') ;
		$t->set_var('status','') ;
		$t->set_var('amount','') ;
		$t->parse('ledgbal_section','ledgbal_row',True);
		}
	while ($phpgw->db->next_record()) {
		$amount = $phpgw->db->f('amount') ;
		$t->set_var('date',$phpgw->db->f('transdate')) ;
		$t->set_var('source',$phpgw->db->f('source')) ;
		$t->set_var('description',$phpgw->db->f('description')) ;
		$t->set_var('refnumber',$phpgw->db->f('refnumber')) ;
		$t->set_var('cheque',$phpgw->db->f('cheque')) ;
		$t->set_var('status',$phpgw->db->f('status')) ;
		$t->set_var('amount',$amount) ;
		$t->parse('ledgbal_section','ledgbal_row',True);
		$ledgbal += $amount ;
		}
	$t->set_var('lang_adjledgbal',lang('Adjusted Ledger (Bank) Account Balance')) ;
	$t->set_var('adjledgbal',$ledgbal) ;
	if ($bankbal==$ledgbal)		$note = "" ;
	$t->set_var('note',$note) ;

/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',lang('Done'));
    $t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
