<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'controlreport' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$chart_id = ($_GET["chart_id"]) ? $_GET["chart_id"] : $_POST["chart_id"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', lang('Bank Reconciliation Audit Control Report'));
	$t->set_var('lang_bankac', lang('Bank Account'));
	$t->set_var('lang_br_date', lang('Bank Reconcilation Date'));
	$t->set_var('lang_system_date', lang('System Date'));
	$t->set_var('lang_ledgitem', lang('Imported Ledger Item'));
	$t->set_var('lang_bankitem', lang('Bank Statement Item'));
	$t->set_var('lang_suspitem', lang('Suspense Item'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_total_amount', lang('Total Amount'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

	$note = lang("This report will not persist over time and cannot be produced retrospectively.");
	$t->set_var('note', lang('Note').":  $note");
	$lang_na = lang("N/A") ;

/*-----------------Gather and Write Status Date Info---------------------------------*/

$phpgw->db->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'") ;
$phpgw->db->next_record();
$t->set_var('bankac', $phpgw->db->f('accno')." -- ".$phpgw->db->f('description') );

$t->set_var('br_date', $to );

$sql =	"SELECT sum(amount) as ledgitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$ledgitem = $phpgw->db->f('ledgitem') ;

$sql =	"SELECT sum(amount) as bankitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate>=$from and transdate<='$to' and substring(source,1,2)='SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$bankitem = $phpgw->db->f('bankitem') ;

$sql =	"SELECT sum(amount) as suspitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source='SUSP'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$suspitem = $phpgw->db->f('suspitem') ;

$sql =	"SELECT count(amount) as ledgitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$ledgitem_count = $phpgw->db->f('ledgitem_count') ;

$sql =	"SELECT count(amount) as bankitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate>='$from' and transdate<='$to' and substring(source,1,2)='SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$bankitem_count = $phpgw->db->f('bankitem_count') ;

$sql =	"SELECT count(amount) as suspitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source='SUSP'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$suspitem_count = $phpgw->db->f('suspitem_count') ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$ledgitem_id = $phpgw->db->f('max_id') ;
if ($ledgitem_count==0)		$ledgitem_id = $lang_na ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate>='$from' and transdate<='$to' and substring(source,1,2)='SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$bankitem_id = $phpgw->db->f('max_id') ;
if ($bankitem_count==0)		$bankitem_id = $lang_na ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"transdate<='$to' and source='SUSP'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$suspitem_id = $phpgw->db->f('max_id') ;
if ($suspitem_count==0)		$suspitem_id = $lang_na ;

$t->set_var('ledgitem',sprintf("%01.2f",$ledgitem)) ;
$t->set_var('bankitem',sprintf("%01.2f",$bankitem)) ;
$t->set_var('suspitem',sprintf("%01.2f",$suspitem)) ;
$t->set_var('ledgitem_count',$ledgitem_count) ;
$t->set_var('bankitem_count',$bankitem_count) ;
$t->set_var('suspitem_count',$suspitem_count) ;
$t->set_var('ledgitem_id',$ledgitem_id) ;
$t->set_var('bankitem_id',$bankitem_id) ;
$t->set_var('suspitem_id',$suspitem_id) ;

/*-----------------Gather and Write Current System Date Info-----------------------------*/

$sql =	"SELECT sum(amount) as ledgitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$ledgitem = $phpgw->db->f('ledgitem') ;

$sql =	"SELECT sum(amount) as bankitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"substring(source,1,2)='SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$bankitem = $phpgw->db->f('bankitem') ;

$sql =	"SELECT sum(amount) as suspitem from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source='SUSP'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$suspitem = $phpgw->db->f('suspitem') ;

$sql =	"SELECT count(amount) as ledgitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$ledgitem_count = $phpgw->db->f('ledgitem_count') ;

$sql =	"SELECT count(amount) as bankitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"substring(source,1,2)='SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$bankitem_count = $phpgw->db->f('bankitem_count') ;

$sql =	"SELECT count(amount) as suspitem_count from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source='SUSP'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$suspitem_count = $phpgw->db->f('suspitem_count') ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source<>'SUSP' and substring(source,1,2)<>'SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$ledgitem_id = $phpgw->db->f('max_id') ;
if ($ledgitem_count==0)		$ledgitem_id = $lang_na ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"substring(source,1,2)='SI'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$bankitem_id = $phpgw->db->f('max_id') ;
if ($bankitem_count==0)		$bankitem_id = $lang_na ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}bkr_trans WHERE chart_id='$chart_id' AND " ;
$sql.=	"source='SUSP'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$suspitem_id = $phpgw->db->f('max_id') ;
if ($suspitem_count==0)		$suspitem_id = $lang_na ;

$t->set_var('system_date',date("Y-m-d",time())) ;
$t->set_var('current_ledgitem',sprintf("%01.2f",$ledgitem)) ;
$t->set_var('current_bankitem',sprintf("%01.2f",$bankitem)) ;
$t->set_var('current_suspitem',sprintf("%01.2f",$suspitem)) ;
$t->set_var('current_ledgitem_count',$ledgitem_count) ;
$t->set_var('current_bankitem_count',$bankitem_count) ;
$t->set_var('current_suspitem_count',$suspitem_count) ;
$t->set_var('current_ledgitem_id',$ledgitem_id) ;
$t->set_var('current_bankitem_id',$bankitem_id) ;
$t->set_var('current_suspitem_id',$suspitem_id) ;


/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',lang('Done'));

    $t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
