<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: importbulk.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'import' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;

	$filter = urldecode(stripslashes($filter)) ;
	$proc = CreateObject('ck-api.process') ;
	$where = $proc->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$db_type = $ckapi[hostsys][dbtype] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('question','confirm.tpl');
	$t->set_var('lang_title',lang("Import Ledger Items"));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

$user = $ckapi[hostsys][username];
$temp1 = "${pre}br1".$user.time() ;
$temp2 = "${pre}br2".$user.time() ;
$sql =	"CREATE TABLE $temp1 AS " ;
$sql.=	"SELECT chart_id,trans_id,a.transdate,source,description,amount " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}gl b WHERE 1=1 $where and trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT chart_id,trans_id,a.transdate,source,description,paynumber as refnumber,cheque,a.amount " ;
$sql.=	"FROM $temp1 a, ${pre}payment b WHERE trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"INSERT INTO $temp2 (chart_id,trans_id,transdate,source,description,refnumber,cheque,amount) ";
$sql.=	"SELECT chart_id,trans_id,a.transdate,source,description,rptnumber,b.cheque,a.amount " ;
$sql.=	"FROM $temp1 a, ${pre}receipt b WHERE trans_id=b.id" ;
$phpgw->db->query($sql);
$sql =	"INSERT INTO $temp2 (chart_id,trans_id,transdate,source,description,amount) " ;
$sql.=	"SELECT * FROM $temp1 WHERE source<>'APPY' and source<>'ARRT'" ;
$phpgw->db->query($sql);
$phpgw->db->query("UPDATE $temp2 SET amount=-amount");
$dashpos = "position('-' in description)+1" ;
$blkpos = "position(' ' in description)-1" ;
$sql = "UPDATE $temp2 SET cheque=substring(description,$dashpos,$blkpos-$dashpos) ";
$sql.= "WHERE source='PYPY'" ;
$phpgw->db->query($sql);

$imported = "(" ;
$phpgw->db->query("SELECT trans_id FROM ${pre}bkr_trans");
while ($phpgw->db->next_record())	$imported.= $phpgw->db->f('trans_id')."," ;
$imported = substr($imported,0,strlen($imported)-1).")";
$phpgw->db->query("DELETE FROM $temp2 WHERE trans_id IN $imported");

$ip = ($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
$user = $ckapi[hostsys][username];
$op = 'new' ;
$now = mktime() ;

$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
$phpgw->db->query($sql);

$sql ="INSERT INTO ${pre}bkr_trans (chart_id,trans_id,transdate,source,description,refnumber,cheque,amount) ";
$sql.=	"SELECT * FROM $temp2" ;
$phpgw->db->query($sql);
$phpgw->db->query("UPDATE ${pre}bkr_trans SET id=trans_id");

$phpgw->db->query("SELECT * FROM $temp2");
For ($i=1;$phpgw->db->next_record();$i++)	$trans_id[$i]=$phpgw->db->f('trans_id') ;
For ($i=1;isset($trans_id[$i]);$i++) {
	$id = $trans_id[$i] ;
	$iptime = "$ip=$now=$script=$id" ;
	$phpgw->db->query("SELECT * FROM ${pre}bkr_trans WHERE trans_id='$id'");
	while ($phpgw->db->next_record()) {
		$headerarr['bkr_trans'] = $phpgw->db->Record;
		$header = addslashes(serialize($headerarr));
		$sql= "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,header,iptime) ";
		$sql.="VALUES ('$id','$app','$script','$ip','$user','$op','$now','$header','$iptime')" ;
		$phpgw->db->query($sql);
		}
	}

$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
$phpgw->db->query($sql);

if (isset($temp1))	$phpgw->db->query("DROP TABLE $temp1,$temp2");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang('Ledger Items Imported'));
	$t->set_var('lang_yes',lang('done'));
	$t->set_var('lang_no',lang('done'));
	$t->set_var('yes_action',$phpgw->link("/$app/${tran}filter.php")) ;
	$t->set_var('no_action',$phpgw->link("/$app/${tran}filter.php")) ;
	$t->pparse('out','question',True);
	ExecMethod('ck-api.process.process_footer') ;

?>
