<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.import.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class import {

//---- Import Item List SQL Formation

    function import_list_sql() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$pre = &$ckapi[params][pre] ;
	$t = &$ckapi[objects][template] ;

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}br1".$user.time() ;
	$temp2 = "${pre}br2".$user.time() ;
	$sql =	"CREATE TABLE $temp1 AS " ;
	$sql.=	"SELECT trans_id,a.transdate,source,description,amount " ;
	$sql.=	"FROM ${pre}acc_trans a, ${pre}gl b WHERE 1=1 $where and trans_id=b.id" ;
	$phpgw->db->query($sql);
	$sql =	"CREATE TABLE $temp2 AS " ;
	$sql.=	"SELECT trans_id,a.transdate,source,description,paynumber as refnumber,cheque,a.amount " ;
	$sql.=	"FROM $temp1 a, ${pre}payment b WHERE trans_id=b.id" ;
	$phpgw->db->query($sql);
	$sql =	"INSERT INTO $temp2 (trans_id,transdate,source,description,refnumber,cheque,amount) ";
	$sql.=	"SELECT trans_id,a.transdate,source,description,rptnumber,b.cheque,a.amount " ;
	$sql.=	"FROM $temp1 a, ${pre}receipt b WHERE trans_id=b.id" ;
	$phpgw->db->query($sql);
	$sql =	"INSERT INTO $temp2 (trans_id,transdate,source,description,amount) " ;
	$sql.=	"SELECT * FROM $temp1 WHERE source<>'APPY' and source<>'ARRT'" ;
	$phpgw->db->query($sql);
	$phpgw->db->query("UPDATE $temp2 SET amount=-amount");

	$imported = "(" ;
	$phpgw->db->query("SELECT trans_id FROM ${pre}bkr_trans");
	while ($phpgw->db->next_record())	$imported.= $phpgw->db->f('trans_id')."," ;
	$imported = substr($imported,0,strlen($imported)-1).")";
	$phpgw->db->query("DELETE FROM $temp2 WHERE trans_id IN $imported");

	$sql =  "SELECT *,trans_id as id FROM $temp2 ORDER BY ".$order." ".$sort ;
	$ckapi[params_sql][temp1] = $temp1 ;
	$ckapi[params_sql][temp2] = $temp2 ;
	return $sql ;
	}

//---- Import Item List Link Adjustement

    function import_list_adjust() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params_list][dt] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	if ($source=="PYPY") {
		$dashpos = strpos($description,"-") ;
		$blkpos = strpos($description," ") ;
		$cheque = substr($description,$dashpos+1,$blkpos-$dashpos) ;
		}
	$t->set_var('cheque',$cheque);
	}

    }

?>
