<?php
  /**************************************************************************\
  * ck-bank (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: header.inc.php,v 0.0.5 2002/02/11 C K Wu $ */
  
    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-bank'));
    $t->set_file(array('bank_header' => 'header.tpl'));
    $info1 = lang('Bank Reconciliation') ;
    $info2 = lang("You must read each module's index page in detail.") ;
    $info3 = lang("It contains the Terms & Conditions of usage and re-distribution.") ;
    $t->set_var('info',"$info1  [$info2  $info3]");
    $t->set_var('bg_color',$phpgw_info["theme"]["th_bg"]);
    
    $t->set_var('link_worksheet',$phpgw->link('/ck-bank/worksheetfilter.php'));
    $t->set_var('lang_worksheet',lang('Reconciliation Worksheet'));
    $t->set_var('link_import',$phpgw->link('/ck-bank/importfilter.php'));
    $t->set_var('lang_import',lang('Import Ledger Items'));
    $t->set_var('link_ledger',$phpgw->link('/ck-bank/ledgerfilter.php'));
    $t->set_var('lang_ledger',lang('Ledger Items'));
    $t->set_var('link_statement',$phpgw->link('/ck-bank/statementfilter.php'));
    $t->set_var('lang_statement',lang('Bank Statement Items (not included in Ledger)'));
    $t->set_var('link_suspense',$phpgw->link('/ck-bank/suspensefilter.php'));
    $t->set_var('lang_suspense',lang('Suspense Items'));
    $t->set_var('link_report',$phpgw->link('/ck-bank/reportfilter.php'));
    $t->set_var('lang_report',lang('Reports'));

	$readonly = False ;
	$phpgw->db->query("SELECT readonlygrp FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$readonlygrp = $phpgw->db->f('readonlygrp') ;
	$groups = ExecMethod('phpgwapi.accounts.membership') ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']==$readonlygrp)	$readonly = True ;
	if ($readonly) {
		$t->set_var(array('link_worksheet'=>"", 'lang_worksheet'=>""));
		$t->set_var(array('link_import'=>"", 'lang_import'=>""));
		$t->set_var(array('link_ledger'=>"", 'lang_ledger'=>""));
		$t->set_var(array('link_statement'=>"", 'lang_statement'=>""));
		$t->set_var(array('link_suspense'=>"", 'lang_suspense'=>""));
		}

    $t->pparse('out','bank_header');
?>
