<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ledgerlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'ledger' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}bkr_trans" ,
				'doneexit'	=> "${tran}bulk.php"			);
	$msg1 = lang("Individual item edit -> click edit link;") ;
$msg2 = lang("Bulk Update -> click column heading to arrange list in proper order, then click Bulk Update button.");
$msg3 = lang("Non-payment items that (had) appeared in bank statement should also be flagged 'Cleared'.") ;

	$ckapi[phrases] = array('lang_title'	=> lang("List of Ledger Items") ,
				'lang_add'	=> lang("Bulk Update") ,
				'message'	=> "$msg1  $msg2<br>$msg3"		) ;
	$ckapi[columns] = array('transdate'	=> lang('Ledger Date') ,
				'source'	=> lang('Source') ,
				'description'	=> lang('Description') ,
				'refnumber'	=> lang('Ref Number') ,
				'cheque'	=> lang('Cheque') ,
				'amount'	=> lang('Amount (Dr being +ve)'),
				'status'	=> lang('Status') ,
				'id'		=> lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
