<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: worksheetfilter_validate.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'worksheet' ;
	$noheader = True ;  $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$chart_id = ($_GET["chart_id"]) ? $_GET["chart_id"] : $_POST["chart_id"] ;
	$from = ($_GET["from"]) ? $_GET["from"] : $_POST["from"] ;
	$to = ($_GET["to"]) ? $_GET["to"] : $_POST["to"] ;
	$beginbal = ($_GET["beginbal"]) ? $_GET["beginbal"] : $_POST["beginbal"] ;
	$endbal = ($_GET["endbal"]) ? $_GET["endbal"] : $_POST["endbal"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	$err="";  $error=lang("Error") ;
	if ($from=="") 			$err=lang("Reconciliation Period from date missing");
	   else {
	   	$date_from = input2date($from) ;
		if ($date_from=="")	$err=lang("Invalid starting date"); else $from = $date_from ;
		}
	if ($to=="") 			$err=lang("Reconciliation Period to date missing");
	   else {
		$date_to = input2date($to) ;
		if ($date_to=="")	$err=lang("Invalid ending date"); else $to = $date_to ;
		}
	if ($beginbal=="") 		$err=lang("Beginning Bank Statement Balance missing");
	if (!is_numeric($beginbal))	$err=lang("Beginning Bank Statement Balance must be numeric") ;
	if ($endbal=="") 		$err=lang("Ending Bank Statement Balance missing");
	if (!is_numeric($endbal))	$err=lang("Ending Bank Statement Balance must be numeric") ;
	if ($err)	$err = "<b>$error:  $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)
		{
		$filter = " WHERE $beginbal=$beginbal AND $endbal=$endbal AND " ;
		$filter.= " chart_id='$chart_id' AND transdate<='$to' AND " ;
		$filter.= " (substring(source,1,2)='SI' AND transdate>='$from' OR " ;
		$filter.= " substring(source,1,2)<>'SI') " ;
		$filter = urlencode($filter) ;
		$getstr = "filter=$filter&beginbal=$beginbal&endbal=$endbal" ;
		Header('Location: '.$phpgw->link("/$app/${tran}list.php",$getstr));
		exit();
		}
	else
		{
		$getstr = "chart_id=$chart_id&from=$from&to=$to&" ;
		$getstr.= "beginbal=$beginbal&endbal=$endbal&err=$err" ;
		Header('Location: '.$phpgw->link("/$app/${tran}filter.php",$getstr));
		exit();
		}
?>
