<?php
 /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: customerubso.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-crm' ;
	$tran = 'customer' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = urldecode(stripslashes($filter)) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$nm = $phpgw->nextmatchs ;
	$t->set_file(array('report'=>"${tran}ubso.tpl", 'so'=>"${tran}ubso.tpl"));
	$t->set_block('so','so_row','so_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

/*---------------------------------------------------------------------------------*/

	$sql = "SELECT name FROM ${pre}customer WHERE id='$id'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$name = $phpgw->db->f('name') ;
	$t->set_var('lang_title',lang("List of Unbilled SO (Outstanding Unrealised Revenue) for Customer")." -- $name") ;
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));

	$script = "/$app/${tran}ubso.php" ;
	$t->set_var('sort_sonumber',$nm->show_sort_order($sort,"sonumber&id=$id",$order,$script,lang('SO Number')));
	$t->set_var('sort_transdate',$nm->show_sort_order($sort,"transdate&id=$id",$order,$script,lang('SO Date')));
	$t->set_var('sort_duedate',$nm->show_sort_order($sort,"duedate&id=$id",$order,$script,lang('Due Date')));
	$t->set_var('sort_isocode',$nm->show_sort_order($sort,"isocode&id=$id",$order,$script,lang('Currency')));
	$t->set_var('sort_amount',$nm->show_sort_order($sort,"amount&id=$id",$order,$script,lang('SO Amount')));
	$t->set_var('sort_billedamount',$nm->show_sort_order($sort,"billedamount&id=$id",$order,$script,lang('Billed Amount')));
	$t->set_var('sort_osamount',$nm->show_sort_order($sort,"osamount&id=$id",$order,$script,lang('O/S Amount')));
	$t->set_var('lang_id',lang('Audit ID')) ;
	$t->set_var('lang_overdue',lang('Days O/D')) ;
	$t->set_var('lang_notdue',lang('Not Due')) ;
	$t->set_var('lang_age30',lang('1-30')) ;
	$t->set_var('lang_age60',lang('31-60')) ;
	$t->set_var('lang_age90',lang('61-90')) ;
	$t->set_var('lang_age120',lang('91-120')) ;
	$t->set_var('lang_age120plus',lang('120+')) ;
	$note1 = lang("Note 1") ;
	$t->set_var('summary',lang('Summary')." -- $note1") ;
	$t->set_var('lang_unallocated',lang('Unallocated')." -- $note1") ;
	$t->set_var('lang_net',lang('Net O/S')." -- $note1") ;
	$note1a = lang('These lines are for control reconciliation purpose only') ;
	$note1b = lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 - $note1a. $note1b.");

	$sql ="SELECT sum(amount) as totbilled FROM ${pre}ar WHERE customer='$id'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$totbilled = $phpgw->db->f('totbilled') ;
	$sql ="SELECT sum(b_amount) as allocated FROM ${pre}ar a, ${pre}ismatch b WHERE customer='$id' and a.id=invoiceid";
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$allocated = $phpgw->db->f('allocated') ;
	$unallocated = $totbilled-$allocated ;

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}so1".$user.time() ;
	$temp2 = "${pre}so2".$user.time() ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.="SELECT sonumber,id,transdate,duedate,isocode,amount,0.0 as billedamount FROM ${pre}so WHERE customer='$id' ";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT sonumber,id,transdate,duedate,isocode,0.0 as amount,sum(b_amount) as billedamount " ;
	$sql.= "FROM ${pre}so a, ${pre}ismatch b ";
	$sql.= "WHERE customer='$id' and a.id=b.soid GROUP BY transdate,duedate,isocode,id,sonumber";
	$phpgw->db->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT sonumber,id,transdate,duedate,isocode,sum(amount) as amount,sum(billedamount) as billedamount,0.0 as osamount " ;
	$sql.= "FROM $temp1 GROUP BY transdate,duedate,isocode,id,sonumber ";
	$phpgw->db->query($sql);
	$sql = "UPDATE $temp2 SET osamount=amount-billedamount" ;
	$phpgw->db->query($sql);

	if (!$order) 	$order = "duedate,id" ;
	if (!$sort)  	$sort = "ASC" ;
	$sql = "SELECT * FROM $temp2 WHERE osamount > 0 ORDER BY $order $sort" ;
	$phpgw->db->query($sql) ;

	if ($phpgw->db->num_rows()==0) {
		$t->set_var('sonumber',lang('No SO outstanding')) ;
		$t->set_var('transdate','.') ;
		$t->set_var('duedate','.') ;
		$t->set_var('overdue','.') ;
		$t->set_var('isocode','.') ;
		$t->set_var('soamount','.') ;
		$t->set_var('billedamount','.') ;
		$t->set_var('osamount','.') ;
		$t->set_var('id','.') ;
		$t->set_var('notdue','.') ;
		$t->set_var('age30','.') ;
		$t->set_var('age60','.') ;
		$t->set_var('age90','.') ;
		$t->set_var('age120','.') ;
		$t->set_var('age120plus','.') ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('so_section','so_row',True);
		}
	$sumamount = $sumbilled = $sumos = 0 ;
	$sumnotdue = $sum30 = $sum60 = $sum90 = $sum120 = $sum120plus = 0 ;
	while ($phpgw->db->next_record()) {

		$sonumber	=	$phpgw->db->f('sonumber') ;
		$transdate	=	$phpgw->db->f('transdate') ;
		$duedate	=	$phpgw->db->f('duedate') ;
		$isocode	=	$phpgw->db->f('isocode') ;
		$amount		=	$phpgw->db->f('amount') ;
		$billedamount	=	$phpgw->db->f('billedamount') ;
		$osamount	=	$phpgw->db->f('osamount') ;
		$soid		=	$phpgw->db->f('id') ;

		$overdue = (strtotime(date("Y-m-d"))-strtotime($duedate))/86400 ;
		$age = $overdue < 0 ? 0 : floor($overdue) ;
		$notdue = $age30 = $age60 = $age90 = $age120 = $age120plus = "." ;

		if ($age==0)			$notdue = $osamount ;
		if ($age>0 and $age<31)		$age30 = $osamount ;
		if ($age>30 and $age<61)	$age60 = $osamount ;
		if ($age>60 and $age<91)	$age90 = $osamount ;
		if ($age>90 and $age<121)	$age120 = $osamount ;
		if ($age>120)			$age120plus = $osamount ;

		$t->set_var('sonumber',$sonumber) ;
		$t->set_var('transdate',$transdate) ;
		$t->set_var('duedate',$duedate) ;
		$t->set_var('isocode',$isocode) ;
		$t->set_var('soamount',$amount) ;
		$t->set_var('billedamount',$billedamount) ;
		$t->set_var('osamount',$osamount) ;
		$t->set_var('id',$soid) ;
		$overdue = $age==0 ? "" : $overdue ;
		$t->set_var('overdue',$overdue) ;
		$t->set_var('notdue',$notdue) ;
		$t->set_var('age30',$age30) ;
		$t->set_var('age60',$age60) ;
		$t->set_var('age90',$age90) ;
		$t->set_var('age120',$age120) ;
		$t->set_var('age120plus',$age120plus) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('so_section','so_row', True);

		$sumamount	+=	$amount ;
		$sumbilled	+=	$billedamount ;
		$sumos		+=	$osamount ;
		$sumnotdue	+=	$notdue ;
		$sum30		+=	$age30 ;
		$sum60		+=	$age60 ;
		$sum90		+=	$age90 ;
		$sum120		+=	$age120 ;
		$sum120plus	+=	$age120plus ;
		}
	$t->set_var('sumamount',$sumamount) ;
	$t->set_var('sumbilled',$sumbilled) ;
	$t->set_var('sumos',$sumos) ;
	$t->set_var('sumnotdue',$sumnotdue) ;
	$t->set_var('sum30',$sum30) ;
	$t->set_var('sum60',$sum60) ;
	$t->set_var('sum90',$sum90) ;
	$t->set_var('sum120',$sum120) ;
	$t->set_var('sum120plus',$sum120plus) ;
	$t->set_var('unallocated',$unallocated) ;
	$t->set_var('net',$sumos-$unallocated) ;

	$sql = "DROP TABLE $temp1, $temp2" ;
	$phpgw->db->query($sql);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php","filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','so','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
