<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.so.inc.php,v 0.11.1 2004/12/31 C K Wu $ */

    class so {

//---- SO List SQL Formation

    function so_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if ($ckapi[params][tran]=="sont")	$where = "amount=netamount $where" ;	else	$where = "amount<>netamount $where";
	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,duedate,sonumber,name,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}so a, ${pre}customer b WHERE $where AND a.customer=b.id " ;
		$sql2 =	"SELECT $fields FROM ${pre}so a, ${pre}customer b, ${pre}ismatch c " ;
		$sql2.=	"WHERE $where AND customer=b.id AND a.id=c.soid " ;
		$sql2.=	"GROUP BY $fields HAVING sum(b_amount)>=amount " ;
		if ($ckapi[hostsys][dbtype]=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}sontl1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}sontl2".$user.time() ;
			$phpgw->db->query("CREATE TABLE $temp1 AS $sql1");
			$phpgw->db->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* FROM $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	  else	$sql =	"SELECT $fields FROM ${pre}so a, ${pre}customer b WHERE $where AND a.customer=b.id ORDER BY $order $sort";
	return $sql ;
	}

//---- SO List Link Adjustement

    function so_list_adjust() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$return = "/$app/${tran}list.php" ;
	$getstr = "id=$dt[id]&filter=$filter&return=$return" ;
	$t->set_var('edit_addtax',$phpgw->link("/$app/sowtedit.php",$getstr)) ;
	$getstr = "order=$order&sort=$sort&id=$dt[id]&filter=$filter" ;
	$t->set_var('bulk_action',$phpgw->link("/$app/${tran}bulk.php",$getstr)) ;
	$disabled = ($dt[id]=="") ? "disabled" : "" ;
	$t->set_var('disabled',$disabled) ;
	}

//---- SO Data Read

    function so_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$script = $ckapi[params_post][script] ;

	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[taxstatus] = ($tran=="sont") ? "e" : $phpgw->db->f('taxincluded') ;
	$dt[oldisocode] = $dt[isocode] ;
	if ($script=="quote2socopy")	$dt[transdate] = $dt[duedate] = "" ;
	$phpgw->db->query("SELECT * FROM ${pre}oitem WHERE trans_id='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['itemid'.$i]		=	$phpgw->db->f('itemid') ;
		$dt['itemtype'.$i]		=	$phpgw->db->f('itemtype') ;
		$dt['description'.$i]		=	$phpgw->db->f('description') ;
		$dt['qty'.$i]			=	$phpgw->db->f('qty') ;
		$dt['unit'.$i]			=	$phpgw->db->f('unit') ;
		$dt['price'.$i]			=	$phpgw->db->f('price') ;
		$dt['cost'.$i]			=	$phpgw->db->f('cost') ;
		$dt['discount'.$i]		=	$phpgw->db->f('discount') ;
		$dt['tax1'.$i]			=	$phpgw->db->f('tax1') ;
		$dt['tax2'.$i]			=	$phpgw->db->f('tax2') ;
		}
	return $dt ;
	}

//---- Write SO Header

    function so_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$script = &$ckapi[params_post][script] ;
	$t = &$ckapi[objects][template] ;

	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$loc_for = ($phpgw->db->f('nativecurr')==$dt[isocode]) ? lang('Local') : lang('*** Foreign ***');
	if ($dt[isocode]<>$dt[oldisocode]) {
		$phpgw->db->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
		$phpgw->db->next_record() ;
		$dt[exrate] = $phpgw->db->f('exrate') ;
		$msg1 = lang('Currency changed') ;
		$msg2 = lang('Default exchange rate loaded') ;
		$msg3 = lang('Ensure pre-existing (discount,price,cost,tax) are correct') ;
		$t->set_var('message',"$msg1;  $msg2;  $msg3");
		}
	$taxstatus = $dt[taxstatus] ;
	$t->set_var('lang_sonumber',lang('SO#'));
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_curr_so',lang('Currency Sales Order'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_transdate',lang('SO Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_shipfrom',lang('Ship From'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_taxstatus',lang('Unit Price Tax Status'));
	$t->set_var('lang_isocode',lang('Currency'));
	$t->set_var('lang_exrate',lang('Exchange Rate'));
	$t->set_var('lang_totalamt',lang('Total SO Amount'));
	$t->set_var('sonumber',$dt[sonumber]) ;
	$t->set_var('shipfrom',$dt[shipfrom]) ;
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('duedate',$dt[duedate]) ;
	$t->set_var('notes',$dt[notes]);
	$customer = $dt[customer] ;
	$t->set_var('customer',$customer) ;
	$t->set_var('customer_selectlist',customer_selectlist("WHERE id='$customer'",$customer)) ;
	$optiont = lang('Tax Included') ;
	$optionf = lang('Tax Not Included') ;
	$optione = lang('Tax Exempted') ;
	if ($tran=="sont")	$tax_sl = "<OPTION value='e' selected>$optione</OPTION>" ;
	    else {
		$tax_sl = "<OPTION value='t'>".$optiont."</OPTION>" ;
		$tax_sl.= "<OPTION value='f'>".$optionf."</OPTION>" ;
		$tax_sl.= "<OPTION value='e'>".$optione."</OPTION>" ;
		$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
		}
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('isocode_selectlist',isocode_selectlist('',$dt[isocode])) ;
	$t->set_var('exrate',$dt[exrate]) ;

	$t->set_var('message',"");

	$t->parse('out','report',True);
	}

//---- Reformat Sales Order Array

    function so_transform() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row') ;
	$temp[id] = $dt[id] ;
	$temp[control] = $dt[control] ;
	$temp[customer] = $dt[customer] ;
	$temp[transdate] = $dt[transdate] ;
	$temp[duedate] = $dt[duedate] ;
	$temp[sonumber] = $dt[sonumber] ;
	$temp[ordnumber] = $dt[ordnumber] ;
	$temp[taxstatus] = $dt[taxstatus] ;
	$temp[shipfrom] = $dt[shipfrom] ;
	$temp[notes] = $dt[notes] ;
	$temp[isocode] = $dt[isocode] ;
	$temp[oldisocode] = $dt[oldisocode] ;
	$temp[exrate] = $dt[exrate] ;

	if (isset($delete)) {$delrowno = intval(str_replace($row_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$itemid = $dt['itemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($itemid<0)	{
			$itemid = -$itemid ;
			$qty = $dt['qty'.$i]==0 ? 1 : $dt['qty'.$i] ;
			$phpgw->db->query("SELECT * FROM ${pre}assembly WHERE assembly_id='$itemid'");
			while ($phpgw->db->next_record()) {
				$temp['itemid'.$j] = $phpgw->db->f('item_id') ;
				$temp['qty'.$j] = $phpgw->db->f('qty') * $qty ;
				$j++ ;
				}
			continue ;
			}
		$temp['itemid'.$j]		=	$dt['itemid'.$i] ;
		$temp['itemtype'.$j]		=	$dt['itemtype'.$i] ;
		$temp['description'.$j]		=	$dt['description'.$i] ;
		$temp['qty'.$j]			=	$dt['qty'.$i] ;
		$temp['unit'.$j]		=	$dt['unit'.$i] ;
		$temp['price'.$j]		=	$dt['price'.$i] ;
		$temp['discount'.$j]		=	$dt['discount'.$i] ;
		$temp['tax1_pref'.$j]		=	$dt['tax1_pref'.$i] ;
		$temp['tax2_pref'.$j]		=	$dt['tax2_pref'.$i] ;
		$temp['tax1'.$j]		=	$dt['tax1'.$i] ;
		$temp['tax2'.$j]		=	$dt['tax2'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow)					$temp['itemid'.$j] = "" ;
	$dt = $temp ;
	unset($temp) ;
	}

//---- Write SO Detail

    function so_detail_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$firstime = $ckapi[params_post][firstime] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$taxstatus = $dt[taxstatus] ;
	$tax_warning = lang("***** Choice Pending") ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	if ($taxstatus<>'e') {
		$tax_pref_slist = "<OPTION value=''></OPTION>" ;
		$tax_pref_slist.= "<OPTION value='i'>".lang('apply item tax rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='c'>".lang('apply customer rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='s'>".lang('apply my std rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='z'>".lang('tax rate = zero')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='m'>".lang('manual tax input')."</OPTION>" ;
		$customer = ($dt[customer]=="") ? 0 : $dt[customer] ;
		$sql = "SELECT customer_id,rate from ${pre}customertax a, ${pre}tax b " ;
		$sql.= "WHERE customer_id='$customer' and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$ctax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT customer_id,rate from ${pre}customertax a, ${pre}tax b " ;
		$sql.= "WHERE customer_id='$customer' and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$ctax2rate = $phpgw->db->f(rate) ;
		$sql = "SELECT customer_id,rate from ${pre}customertax a, ${pre}tax b, ${pre}customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and " ;
		$sql.= "a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT customer_id,rate from ${pre}customertax a, ${pre}tax b, ${pre}customer c " ;
		$sql.= "WHERE c.name='zzzzMyself' and customer_id=c.id and " ;
		$sql.= "a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax2rate = $phpgw->db->f(rate) ;
		}
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_number',lang('Item Code -- Id<br>(Inventory/Service)'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_btup',lang('BTUP'));
	$t->set_var('lang_discount',lang('Discount<br>$'));
	$t->set_var('lang_tax',lang('Tax'));
	$phpgw->db->query("SELECT artax1cap,artax2cap,artax1pref,artax2pref FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$t->set_var('lang_tax1',$phpgw->db->f(artax1cap));
	$t->set_var('lang_tax2',$phpgw->db->f(artax2cap));
	$tax1pref = $phpgw->db->f(artax1pref) ;
	$tax2pref = $phpgw->db->f(artax2pref) ;
	$t->set_var('lang_price',lang('Unit<br>Price'));
	$t->set_var('lang_itemtotal',lang('Item Total'));
	$t->set_var('lang_netamount',lang('Net of Tax'));
	$t->set_var('lang_delete',lang('Delete<br>Button'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_sl = item_selectlist("",'') ;
	if ($firstime and $ckapi[params][doneexit]=="quote2sofilter.php")	$fromquote = True ;
//	$tax_acc_list = ($fromquote) ? "" : account_selectlist("WHERE link like '%AR_tax%'",'') ;
	$sum_tax1 = $sum_tax2 = $sum_itemtotal = $sum_netamount = 0 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$t->set_var('itemid_fld','itemid'.$i) ;
		$t->set_var('itemtype_fld','itemtype'.$i) ;
		$t->set_var('description_fld','description'.$i);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('unit_fld','unit'.$i);
		$t->set_var('discount_fld','discount'.$i);
		$t->set_var('price_fld','price'.$i);
		$t->set_var('tax1_pref_fld','tax1_pref'.$i);
		$t->set_var('tax2_pref_fld','tax2_pref'.$i);
		$t->set_var('tax1_fld','tax1'.$i);
		$t->set_var('tax2_fld','tax2'.$i);
		$itemid = $dt['itemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('item_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$item_sl));
		$itemtype = $dt['itemtype'.$i] ;
		$description = $dt['description'.$i] ;
		$unit = $dt['unit'.$i] ;
		$qty = ($itemid<>'' and $dt['qty'.$i]=='') ? 1 : $dt['qty'.$i] ;
		$discount = $dt['discount'.$i] ;
		$price = $dt['price'.$i] ;
		$tax1_pref = ($dt['tax1_pref'.$i] or $posted) ? $dt['tax1_pref'.$i] : $tax1pref ;
		$tax2_pref = ($dt['tax2_pref'.$i] or $posted) ? $dt['tax2_pref'.$i] : $tax2pref ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		if (($tax1_pref=="" or $tax1_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark1',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark1',"");
		if (($tax2_pref=="" or $tax2_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark2',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark2',"");
		$tax1 = $dt['tax1'.$i] ;
		$tax2 = $dt['tax2'.$i] ;
		$itemid = ($itemid=="") ? 0 : $itemid ;
		if (!$itemtype or $fromquote) {
			$phpgw->db->query("SELECT * FROM ${pre}service WHERE id='$itemid'");
			if ($phpgw->db->next_record())	$itemtype = "s" ;
			   else {
				$phpgw->db->query("SELECT * FROM ${pre}parts WHERE id='$itemid'");
				if ($phpgw->db->next_record())	$itemtype = "i" ;
				}
			$description = $description<>'' ? $description : $phpgw->db->f('description');
			$unit = $unit<>'' ? $unit : $phpgw->db->f('unit');
			$price = ($price<>'' or $itemid==0) ? $price : $phpgw->db->f('price')/$dt[exrate];
			$price = number_format($price,2,".",'') ;
			}
		$t->set_var('itemtype',$itemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$unit);
		$t->set_var('qty',$qty);
		$t->set_var('discount',$discount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$price = number_format($price,2,".",'') ;
		$price = ($itemid==0) ? "" : $price ;
		$t->set_var('price',$price);
		switch ($tax1_pref) :
			case "c" :	$tax1rate = $ctax1rate ;	break ;
			case "s" :	$tax1rate = $stax1rate ;	break ;
			case "i" :
				$sql = "SELECT rate from ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
				$sql.= "taxtype='1' and taxgroup='ar'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax1rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax1rate = 0 ;		break ;
			case "m" :	$tax1rate = 0 ;		break ;
			case " " :	$tax1rate = 0 ;		break ;
			case "" :	$tax1rate = 0 ;		break ;
			endswitch ;
		switch ($tax2_pref) :
			case "c" :	$tax2rate = $ctax2rate ;	break ;
			case "s" :	$tax2rate = $stax2rate ;	break ;
			case "i" :
				$sql = "SELECT rate from ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
				$sql.= "taxtype='2' and taxgroup='ar'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax2rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax2rate = 0 ;		break ;
			case "m" :	$tax2rate = 0 ;		break ;
			case " " :	$tax2rate = 0 ;		break ;
			case "" :	$tax2rate = 0 ;		break ;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$t->set_var('btup',$price);
				$netamount = number_format($qty*$price-$discount,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				$tax1 = ($keeptax1) ? $tax1 : $netamount*$tax1rate ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $netamount*$tax2rate ;
				$tax2 = number_format($tax2,2,".",'') ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$t->set_var('btup','.');
				$t->set_var('discount','');
				$itemtotal = $taxbase = number_format($qty*$price,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				if ($keeptax1)		$taxbase -= $tax1 ;
				if ($keeptax2)		$taxbase -= $tax2 ;
				$tax1 = ($keeptax1) ? $tax1 : $taxbase*$tax1rate/(1+$tax1rate+$tax2rate) ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $taxbase*$tax2rate/(1+$tax1rate+$tax2rate) ;
				$tax2 = number_format($tax2,2,".",'') ;
				$netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$t->set_var('btup','.');
				$netamount = number_format($qty*$price-$discount,2,".",'') ;
				$itemtotal = $netamount ;
				$tax1rate = $tax2rate = 0 ;
				$tax1 = $tax2 = 0 ;
				break ;
			endswitch ;
		$sum_tax1 += $tax1 ;
		$sum_tax2 += $tax2 ;
		$sum_itemtotal += $itemtotal ;
		$sum_netamount += $netamount ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('netamount',$netamount);
		if ($posted)	$t->set_var('rowno',"done") ;	else	$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		
		$dt['itemid'.$i] = $itemid ;
		$dt['itemtype'.$i] = $itemtype ;
		$dt['description'.$i] = $description ;
		$dt['qty'.$i] = $qty ;
		$dt['price'.$i] = $price ;
		$dt['discount'.$i] = $discount ;
		$dt['unit'.$i] = $unit ;
		$dt['tax1'.$i] = $tax1 ;
		$dt['tax2'.$i] = $tax2 ;
		$dt['netamount'.$i] = $netamount ;
		}

	$dt[amount] = number_format($sum_itemtotal,2,".",'') ;
	$dt[netamount] = number_format($sum_netamount,2,".",'') ;
	$t->set_var('lang_totalnet',lang('Total Tax / Net Amount'));
	$t->set_var('lang_totalap',lang('Total Payable'));
	$t->set_var('sum_tax',number_format($sum_tax1+$sum_tax2,2,".",'')) ;
	$t->set_var('sum_netamount',$dt[netamount]) ;
	$t->set_var('sum_itemtotal',$dt[amount]) ;
	$t->set_var('oldisocode',$dt['isocode']);
	$t->parse('out','report',True);
	}

    }

?>
