<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: attendfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-hr' ;
	$tran = 'attend' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'attend',
				'tran'		=> $tran ,
				'table'		=> "${pre}attendance" 			) ;
	$msg1 = lang('Attendance Records are auto-created via staff signing in/out.') ;
	$msg2 = lang('Normally, HR staff should not create/amend attendance records.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Attendance Record :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Achievement Code") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$type_sl = "<OPTION value='sign-in'>".lang('sign-in')."</OPTION>" ;
	$type_sl.= "<OPTION value='sign-out'>".lang('sign-out')."</OPTION>" ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$attendmsg = lang('Attendance Record falling within (from/to) period will be listed.') ;

	$ckapi[filter][] = array(criteria	=>	lang('Department') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.dept_selectlist('','') ,
				varname		=>	'dept' ,
				defval		=>	'' ,
				note		=>	lang('Search for Attendance Record of target Department'));

	$ckapi[filter][] = array(criteria	=>	lang('Record Type') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.$type_sl ,
				varname		=>	'type' ,
				defval		=>	'' ,
				note		=>	lang('Search for the target Record Type')) ;

	$ckapi[filter][] = array(criteria	=>	lang('Employee Name/#') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Employee Name Field') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Attendance Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$attendmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Attendance Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$attendmsg  $dateformat"		) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
