<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-hr' ;
	$tran = 'control' ;
	include('../ck-api/ckapi.inc.php') ;

	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$status_date = ($_GET["status_date"]) ? $_GET["status_date"] : $_POST["status_date"] ;

/*---------------------------------------------------------------------------------*/

    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir(ck-hr));
    $t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', lang('Human Resources Audit Control Report'));
	$t->set_var('lang_system_date', lang('System Date'));
	$t->set_var('lang_employee', lang('Employee'));
	$t->set_var('lang_code', lang('HR<br>Code'));
	$t->set_var('lang_dept', lang('Depart<br>ment'));
	$t->set_var('lang_address', lang('Address'));
	$t->set_var('lang_phone', lang('Phone'));
	$t->set_var('lang_email', lang('Email'));
	$t->set_var('lang_ec', lang('Emergency<br>Contact'));
	$t->set_var('lang_dates', lang('Important<br>Dates'));
	$t->set_var('lang_leave', lang('Leave<br>Record'));
	$t->set_var('lang_pr', lang('Performance<br>Review'));
	$t->set_var('lang_role', lang('Role<br>Record'));
	$t->set_var('lang_current_status', lang('TOTAL DATABASE STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Database Info---------------------------------*/

$t->set_var('system_date',date("Y-m-d",time())) ;

$sql="SELECT count(id) as employee_count, max(id) as max_id from ${pre}employee WHERE name<>''";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('employee_count',$phpgw->db->f('employee_count')) ;
$t->set_var('latest_employee_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(id) as code_count, max(id) as max_id from ${pre}hrcode WHERE name<>''" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('code_count',$phpgw->db->f('code_count')) ;
$t->set_var('latest_code_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(id) as dept_count, max(id) as max_id from ${pre}department WHERE name<>''" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('dept_count',$phpgw->db->f('dept_count')) ;
$t->set_var('latest_dept_id',$phpgw->db->f('max_id')) ;

$sql =	"SELECT count(contactid) as cnt from ${pre}address,${pre}employee WHERE contactid=id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('address_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_address_id',lang('N/A')) ;

$sql =	"SELECT count(empid) as cnt from ${pre}phone";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('phone_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_phone_id',lang('N/A')) ;

$sql =	"SELECT count(empid) as cnt from ${pre}email" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('email_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_email_id',lang('N/A')) ;

$sql =	"SELECT count(empid) as cnt from ${pre}ec";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('ec_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_ec_id',lang('N/A')) ;

$sql =	"SELECT count(empid) as cnt from ${pre}dates" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('dates_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_dates_id',lang('N/A')) ;

$sql =	"SELECT count(empid) as cnt from ${pre}leave";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('leave_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_leave_id',lang('N/A')) ;

$sql =	"SELECT count(empid) as cnt from ${pre}pr" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('pr_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_pr_id',lang('N/A')) ;

$sql =	"SELECT count(empid) as cnt from ${pre}role";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$t->set_var('role_count',$phpgw->db->f('cnt')) ;
$t->set_var('latest_role_id',lang('N/A')) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link('/ck-hr/reportfilter.php')) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
