<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.gd.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class gd {

//---- Goods Delivery List SQL Formation

    function gd_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$sql =  "SELECT transdate,name as customer,source,description,a.id as id " ;
	$sql.=	"FROM ${pre}il a, ${pre}customer b " ;
	$sql.=	"WHERE substring(source,1,2)='GD' $where and a.to_from=b.id order by ".$order." ".$sort;
	return $sql ;
	}

//---- Goods Delivery Read

    function gd_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * from ${pre}il where id=$id");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[lastcustomer] = $dt[customer] = $phpgw->db->f('to_from') ;

	$phpgw->db->query("SELECT * from ${pre}inv_trans WHERE trans_id='$id'");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['so'.$i]	=	$phpgw->db->f('order_id') ;
		$dt['part'.$i]	=	$phpgw->db->f('parts_id') ;
		$dt['qty'.$i]	=	-$phpgw->db->f('qty') ;
		}
	if ($ckapi[params_post][op]=="view")	$dt[controltot] = lang("N/A") ;
	return $dt ;
	}

//---- Goods Delivery Add Initialisation

    function gd_add_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt['so1'] = $dt['part1'] = $dt['qty1'] = "";
	}

//---- Goods Delivery Validation Checks

    function gd_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$err=""; $error=lang("Error");
	$date=input2date( $dt[transdate] ) ;
	if ($date=="")				$err=lang("Invalid Goods Delivery Date");
	if ($dt["description"]=="")		$err=lang("GD Description Missing");
	$id = $dt[id] ;
	$customer = $dt[customer] ;
	$lastcustomer = $dt[lastcustomer] ;
	$totalqty = 0 ;
	For ($i=1;isset($dt['part'.$i]);$i++) {
		$qty = $dt['qty'.$i] ;
		$so  = $dt['so'.$i] ;
		$part= $dt['part'.$i] ;
		$row = lang("Row") ;
		$rowi = "[$row $i]" ;
		if ($qty and !is_numeric($qty)) $err=$rowi.lang("Invalid Qty, must be numeric");
		if ($qty==0)			$err=$rowi.lang("Invalid Qty, must be non-zero");
		if ($so=="")			$err=$rowi.lang("Invalid SO") ;
		  else	{
			$sql = "SELECT customer from ${pre}so where id='$so' and customer='$customer'" ;
			$phpgw->db->query($sql) ;
			if (!$phpgw->db->next_record()) $err=$rowi.lang("SO belongs to another customer");
			$sql = "SELECT qty from ${pre}oitem where trans_id='$so' and itemid='$part'" ;
			$phpgw->db->query($sql) ;
			if ($phpgw->db->next_record()) {
				$soqty = $phpgw->db->f('qty') ;
				$sql = "SELECT sum(qty) as q from ${pre}inv_trans " ;
				$sql.= "WHERE order_id='$so' and parts_id='$part'";
				if ($op=='edit')		$sql .= " and trans_id<>'$id'" ;
				$phpgw->db->query($sql) ;
				$phpgw->db->next_record() ;
				$q = $phpgw->db->f('q') ;
				if ($qty>($soqty-$q))	$err=$rowi.lang("Receiving Qty > O/S SO qty") ;
				}
			   else				$err=$rowi.lang("SO does not have this part") ;
			}
		$sql = "SELECT sum(qty) as stk from ${pre}inv_trans WHERE parts_id='$part'" ;
		if ($op=='edit')		$sql .= " and trans_id<>'$id'" ;
		$phpgw->db->query($sql) ;
		$phpgw->db->next_record() ;
		$stk = $phpgw->db->f('stk') ;
		if ($qty>($stk))		$err=$rowi.lang("Qty to deliver overdrawn existing stock") ;
		For ($j=1;isset($dt['part'.$j]);$j++) {
			$rowj = "[$row $j]" ;
			if ($dt['part'.$i]==$dt['part'.$j] and $dt['so'.$i]==$dt['so'.$j] and $i<>$j)
						$err=$rowi.$rowj.lang("Rows with same SO&Part#");
			}
		$totalqty += $dt['qty'.$i] ;
		}
	if ($totalqty<>$dt[controltot])		$err=lang("Qty Total <> Inputted Control Total");
	if ($customer<>$lastcustomer and $lastcustomer<>"")
		$err=lang("Customer changed; new SO list loaded; pls re-check all input") ;
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Goods Delivery Header

    function gd_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_customer',lang('Customer :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('customer_selectlist',customer_selectlist('',$dt[customer])) ;
	$t->set_var('lastcustomer',$dt[customer]) ;
	$t->set_var('source',$dt[source]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Write Goods Delivery Detail

    function gd_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_parts',lang('Part Number -- Description -- ID'));
	$t->set_var('lang_so',lang('(Delivered against) SO Number -- ID'));
	$t->set_var('lang_qty',lang('Quantity'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$part_list = part_selectlist("",'') ;
	if ($dt[customer]=="")	$dt[customer]=0 ;
	$so_list = so_selectlist(" WHERE customer='$dt[customer]' ",'') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($dt['part'.$i]);$i++) {
		if ($i<>$rowno) {
			$so	=	$dt['so'.$i];
			$part	=	$dt['part'.$i] ;
			$qty	=	$dt['qty'.$i];
			$j = ($delete and $i>$rowno) ? $i-1 : $i ;
			$t->set_var('so_fld','so'.$j) ;
			$t->set_var('part_fld','part'.$j) ;
			$t->set_var('qty_fld','qty'.$j);
			$t->set_var('so_list',str_replace("'$so'","'$so' selected",$so_list));
			$t->set_var('parts_list',str_replace("'$part'","'$part' selected",$part_list));
			$t->set_var('qty',$qty) ;
			if ($posted)	$t->set_var('rowno',"done");	else	$t->set_var('rowno',$row_.$j);
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('so_fld','so'.$i) ;
		$t->set_var('so_list',$so_list);
		$t->set_var('part_fld','part'.$i) ;
		$t->set_var('parts_list',$part_list);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);		
		}
	$t->set_var('lang_controltot',lang('Quantity Control Total'));
	$t->set_var('controltot',$dt[controltot]) ;	

	$t->parse('out','report',True);
	}

//---- Goods Delivery Post Initialisation

    function gd_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][source] = "GD" ;
	$ckapi[params_post][dt][to_from] = $ckapi[params_post][dt][customer] ;
	}

//---- Goods Delivery Post - PreCommit Routine

    function gd_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$phpgw->db->query("DELETE from ${pre}inv_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['part'.$i]);$i++) {
			$so	= $dt['so'.$i] ;
			$part	= $dt['part'.$i];
			$qty	= -$dt['qty'.$i];
			$sql = "INSERT INTO ${pre}inv_trans (trans_id,order_id,parts_id,qty,transdate)" ;
			$sql.= "VALUES ('$id','$so','$part','$qty','$dt[transdate]')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>
