<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ledger' ;
	$tran = 'controlreport' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$status_date = ($_GET["status_date"]) ? $_GET["status_date"] : $_POST["status_date"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', lang('Ledger Audit Control Report'));
	$t->set_var('lang_journal_date', lang('Journal Date'));
	$t->set_var('lang_system_date', lang('System Date'));
	$t->set_var('lang_dr', lang('Debit'));
	$t->set_var('lang_cr', lang('Credit'));
	$t->set_var('lang_accounts', lang('Accounts'));
	$t->set_var('lang_journals', lang('Journals'));
	$t->set_var('lang_entries', lang('Dr/Cr Entries'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', lang('TOTAL LEDGER STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_status_note', ' '.lang('(note the effect of postdated journals)'));
	$t->set_var('status_date', $status_date );
	$t->set_var('lang_total_amount', lang('Total Amount'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Status Date Info---------------------------------*/


$sql =	"SELECT sum(amount) as cr_amount from ${pre}acc_trans " ;
$sql.=	"WHERE transdate <= '$status_date' AND amount>0" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$cr = $phpgw->db->f('cr_amount') ;

$sql =	"SELECT -sum(amount) as dr_amount from ${pre}acc_trans " ;
$sql.=	"WHERE transdate <= '$status_date' AND amount<0" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$dr = $phpgw->db->f('dr_amount') ;

$sql =	"SELECT count(id) as journal_count from ${pre}gl WHERE transdate <= '$status_date'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$journal_count = $phpgw->db->f('journal_count') ;

$sql =	"SELECT count(chart_id) as entry_count from ${pre}acc_trans WHERE transdate <= '$status_date'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$entry_count = $phpgw->db->f('entry_count') ;

$sql =	"SELECT max(id) as max_id from ${pre}gl WHERE transdate <= '$status_date'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$journal_id = $phpgw->db->f('max_id') ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}acc_trans WHERE transdate <= '$status_date'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$entry_id = $phpgw->db->f('max_id') ;

if ($journal_id>$entry_id) {$max_id=$journal_id;} else {$max_id=$entry_id;}
if ($max_id=="") {$max_id=0;}

$sql =	"SELECT max(id) as max_id from ${pre}chart WHERE id <= $max_id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$account_id = $phpgw->db->f('max_id') ;

$sql =	"SELECT count(accno) as account_count from ${pre}chart WHERE id <= $max_id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$account_count = $phpgw->db->f('account_count') ;

$t->set_var('dr',sprintf("%01.2f",$dr)) ;
$t->set_var('cr',sprintf("%01.2f",$cr)) ;
$t->set_var('account_count',$account_count) ;
$t->set_var('journal_count',$journal_count) ;
$t->set_var('entry_count',$entry_count) ;
$t->set_var('account_id',$account_id) ;
$t->set_var('journal_id',$journal_id) ;
$t->set_var('entry_id',$entry_id) ;

/*-----------------Gather and Write Current System Date Info-----------------------------*/

$sql =	"SELECT sum(amount) as cr_amount from ${pre}acc_trans WHERE amount>0" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$current_cr = $phpgw->db->f('cr_amount') ;

$sql =	"SELECT -sum(amount) as dr_amount from ${pre}acc_trans WHERE amount<0" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$current_dr = $phpgw->db->f('dr_amount') ;

$sql =	"SELECT count(accno) as account_count from ${pre}chart" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$current_account_count = $phpgw->db->f('account_count') ;

$sql =	"SELECT count(id) as journal_count from ${pre}gl" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$current_journal_count = $phpgw->db->f('journal_count') ;

$sql =	"SELECT count(chart_id) as entry_count from ${pre}acc_trans" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$current_entry_count = $phpgw->db->f('entry_count') ;

$sql =	"SELECT max(id) as max_id from ${pre}chart" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$current_account_id = $phpgw->db->f('max_id') ;

$sql =	"SELECT max(id) as max_id from ${pre}gl" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$current_journal_id = $phpgw->db->f('max_id') ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}acc_trans" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$current_entry_id = $phpgw->db->f('max_id') ;

$t->set_var('system_date',date("Y-m-d",time())) ;
$t->set_var('current_dr',sprintf("%01.2f",$current_dr)) ;
$t->set_var('current_cr',sprintf("%01.2f",$current_cr)) ;
$t->set_var('current_account_count',$current_account_count) ;
$t->set_var('current_journal_count',$current_journal_count) ;
$t->set_var('current_entry_count',$current_entry_count) ;
$t->set_var('current_account_id',$current_account_id) ;
$t->set_var('current_journal_id',$current_journal_id) ;
$t->set_var('current_entry_id',$current_entry_id) ;


/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',lang('Done'));

    $t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
