<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.journal.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class journal {

//---- Journal List Link Adjustement

    function journal_list_adjust() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)		$$key = $value ;
	foreach ($ckapi[params_list][dt] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	if (substr($source,0,2)<>"GL") {
		$t->set_var(array(	'lang_edit'	=> "",
					'lang_copy'	=> "",
					'lang_reverse'	=> "",
					'lang_delete'	=> "",
					'edit'		=> "",
					'copy'		=> "",
					'reverse'	=> "",
					'delete'	=> "")) ;
		}
	}

//---- Journal Read

    function journal_read() {
	global $ckapi,$phpgw,$script,$op ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * from ${pre}gl where id=$id");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$sql = "SELECT chart_id,attrib1,attrib2,attrib3,amount " ;
	$sql.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
	$sql.= "WHERE trans_id='$id' and a.chart_id=b.id ORDER BY a.id";
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['accno'.$i]		=	$phpgw->db->f('chart_id') ;
		$dt['attrib1'.$i]	=	$phpgw->db->f('attrib1') ;
		$dt['attrib2'.$i]	=	$phpgw->db->f('attrib2') ;
		$dt['attrib3'.$i]	=	$phpgw->db->f('attrib3') ;
		$cr			=	sprintf("%01.2f",$phpgw->db->f('amount'));
		if ($op=='reverse')		$cr = -$cr ;
		$dr			=	sprintf("%01.2f",-$cr) ;
		if ($cr>0)			$dr='';			else $cr='';
		$dt['dr'.$i]		=	$dr ;
		$dt['cr'.$i]		=	$cr ;
		}
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$dt["old$val"] = $dt[$val] ;
	return $dt ;
	}

//---- Journal Add Initialisation

    function journal_add_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt = array(	'accno1'	=> "",
			'attrib11'	=> "",
			'attrib21'	=> "",
			'attrib31'	=> "",
			'dr1'		=> "",
			'cr1'		=> "",
			'accno2'	=> "",
			'attrib12'	=> "",
			'attrib22'	=> "",
			'attrib32'	=> "",
			'dr2'		=> "",
			'cr2'		=> ""  ) ;
	}

//---- Journal Validation Checks

    function journal_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$date=input2date( $dt[transdate] ) ;
	if ($date=="")				$err=lang("Invalid Journal Date");
	if ($dt["description"]=="")		$err=lang("Journal Description Missing");
	$total_dr=''; $total_cr='';
	For ($i=1;isset($dt['accno'.$i]);$i++) {
		$dr			=	$dt['dr'.$i];
		$cr			=	$dt['cr'.$i];
		$total_dr		+=	$dr ;
		$total_cr		+=	$cr	;
		$row = lang("Row");
		$rowi = "[$row $i]" ;
		if (!ereg('^[0-9]*\\.?[0-9]{0,2}$',$dr) or $dr<0) $err=$rowi.lang("Invalid Dr");
		if (!ereg('^[0-9]*\\.?[0-9]{0,2}$',$cr) or $cr<0) $err=$rowi.lang("Invalid Cr");
		if ($dr==0 and $cr==0)	$err=$rowi.lang("Both Dr&Cr=0 (delete row if needed)");
		if ($dr>0 and $cr>0)	$err=$rowi.lang("Dr and Cr cannot both have value");
		}
	if (sprintf("%01.2f",$total_dr)<>sprintf("%01.2f",$total_cr))
					$err=lang("Total Journal Dr <> Cr");
	$phpgw->db->query("SELECT attrib1cnval,attrib2cnval,attrib3cnval FROM ${pre}defaults");
	$phpgw->db->next_record();
	if ($phpgw->db->f('attrib1cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib11'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib1'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)		$err = lang("Attrib1 value not constant") ;
		}
	if ($phpgw->db->f('attrib2cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib21'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib2'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)		$err = lang("Attrib2 value not constant") ;
		}
	if ($phpgw->db->f('attrib3cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib31'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib3'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = lang("Attrib3 value not constant") ;
		}
	if ($err)				$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Journal Header

    function journal_header_write() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_attrib1',$a1cap);
	$t->set_var('lang_attrib2',$a2cap);
	$t->set_var('lang_attrib3',$a3cap);
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('source',$dt[source]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;

	$t->parse('out','report',True);
	}

//---- Write Journal Detail

    function journal_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;

	if ($op=='view')	$posted = True ;
	$repl_nonbs = ($_GET["repl_nonbs"]) ? $_GET["repl_nonbs"] : $_POST["repl_nonbs"] ;
	$repl_all = ($_GET["repl_all"]) ? $_GET["repl_all"] : $_POST["repl_all"] ;
	if (isset($repl_all)) {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$dt['attrib1'.$i]	=	$dt['attrib1_cap'] ;
			$dt['attrib2'.$i]	=	$dt['attrib2_cap'] ;
			$dt['attrib3'.$i]	=	$dt['attrib3_cap'] ;
			}
		}
	if (isset($repl_nonbs)) {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$accid = $dt['accno'.$i] ;
			$phpgw->db->query("SELECT category FROM ${pre}chart WHERE id='$accid'") ;
			$phpgw->db->next_record();
			$cat = $phpgw->db->f('category') ;
			if ($cat=="I" or $cat=="E") {
				$dt['attrib1'.$i]	=	$dt['attrib1_cap'] ;
				$dt['attrib2'.$i]	=	$dt['attrib2_cap'] ;
				$dt['attrib3'.$i]	=	$dt['attrib3_cap'] ;
				}
			}
		}

	$row_ = lang('Row')." " ;
	$phpgw->db->query("Select * from ${pre}defaults");
	$phpgw->db->next_record();
	$a1cap = $phpgw->db->f('attrib1cap') ;
	$a1tbl = $phpgw->db->f('attrib1tbl') ;
	$a1sdf = $phpgw->db->f('attrib1sdesc') ;
	$a2cap = $phpgw->db->f('attrib2cap') ;
	$a2tbl = $phpgw->db->f('attrib2tbl') ;
	$a2sdf = $phpgw->db->f('attrib2sdesc') ;
	$a3cap = $phpgw->db->f('attrib3cap') ;
	$a3tbl = $phpgw->db->f('attrib3tbl') ;
	$a3sdf = $phpgw->db->f('attrib3sdesc') ;
	$a1slist = attrib_selectlist($a1tbl,$a1sdf,'','') ;
	$a2slist = attrib_selectlist($a2tbl,$a2sdf,'','') ;
	$a3slist = attrib_selectlist($a3tbl,$a3sdf,'','') ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_accno',lang('Account Number'));
	$t->set_var('lang_attrib1',lang("Attribute").":<br>$a1cap");
	$t->set_var('lang_attrib2',lang("Attribute").":<br>$a2cap");
	$t->set_var('lang_attrib3',lang("Attribute").":<br>$a3cap");
	$at1cap = $dt[attrib1_cap] ;
	$at2cap = $dt[attrib2_cap] ;
	$at3cap = $dt[attrib3_cap] ;
	$t->set_var('attrib1cap_selectlist',str_replace("'$at1cap'","'$at1cap'"." selected",$a1slist)) ;
	$t->set_var('attrib2cap_selectlist',str_replace("'$at2cap'","'$at2cap'"." selected",$a2slist)) ;
	$t->set_var('attrib3cap_selectlist',str_replace("'$at3cap'","'$at3cap'"." selected",$a3slist)) ;
	$t->set_var('lang_dr',lang('Debit'));
	$t->set_var('lang_cr',lang('Credit'));
	$t->set_var('lang_delete',lang('Delete'));
	$total_dr = 0;
	$total_cr = 0;
	$acc_list = account_selectlist("WHERE charttype='A'") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['accno'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('accno_fld','accno'.$i) ;
			$t->set_var('attrib1_fld','attrib1'.$i) ;
			$t->set_var('attrib2_fld','attrib2'.$i) ;
			$t->set_var('attrib3_fld','attrib3'.$i) ;
			$t->set_var('dr_fld','dr'.$i);
			$t->set_var('cr_fld','cr'.$i);
			$t->set_var('account_selectlist',$acc_list);
			$t->set_var('attrib1_selectlist',$a1slist) ;
			$t->set_var('attrib2_selectlist',$a2slist) ;
			$t->set_var('attrib3_selectlist',$a3slist) ;
			$t->set_var('dr',"") ;
			$t->set_var('cr',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$chart_id	=	$dt['accno'.$i] ;
		$attrib1	=	$dt['attrib1'.$i] ;
		$attrib2	=	$dt['attrib2'.$i] ;
		$attrib3	=	$dt['attrib3'.$i] ;
		$dr		=	$dt['dr'.$i];
		$cr		=	$dt['cr'.$i];
		$total_dr	+=	$dr ;
		$total_cr	+=	$cr ;
		$accno_fld	=	'accno'.$j ;
		$attrib1_fld	=	'attrib1'.$j ;
		$attrib2_fld	=	'attrib2'.$j ;
		$attrib3_fld	=	'attrib3'.$j ;
		$dr_fld		=	'dr'.$j ;
		$cr_fld		=	'cr'.$j ;
		$t->set_var('accno_fld',$accno_fld) ;
		$t->set_var('attrib1_fld',$attrib1_fld) ;
		$t->set_var('attrib2_fld',$attrib2_fld) ;
		$t->set_var('attrib3_fld',$attrib3_fld) ;
		$t->set_var('dr_fld',$dr_fld);
		$t->set_var('cr_fld',$cr_fld);
		$t->set_var('account_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$acc_list));
		$t->set_var('attrib1_selectlist',str_replace("'$attrib1'","'$attrib1'"." selected",$a1slist));
		$t->set_var('attrib2_selectlist',str_replace("'$attrib2'","'$attrib2'"." selected",$a2slist));
		$t->set_var('attrib3_selectlist',str_replace("'$attrib3'","'$attrib3'"." selected",$a3slist));
		$t->set_var('dr',$dr) ;
		$t->set_var('cr',$cr) ;
		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('accno_fld','accno'.$i) ;
		$t->set_var('attrib1_fld','attrib1'.$i) ;
		$t->set_var('attrib2_fld','attrib2'.$i) ;
		$t->set_var('attrib3_fld','attrib3'.$i) ;
		$t->set_var('dr_fld','dr'.$i);
		$t->set_var('cr_fld','cr'.$i);
		$t->set_var('account_selectlist',$acc_list);
		$t->set_var('attrib1_selectlist',$a1slist) ;
		$t->set_var('attrib2_selectlist',$a2slist) ;
		$t->set_var('attrib3_selectlist',$a3slist) ;
		$t->set_var('dr',"") ;
		$t->set_var('cr',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('total_dr',sprintf("%01.2f",$total_dr)) ;
	$t->set_var('total_cr',sprintf("%01.2f",$total_cr)) ;

	$t->parse('out','report',True);
	}

//---- Journal Post Initialisation

    function journal_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][source] = "GLJL" ;
	}

//---- Journal Post - PreCommit Routine

    function journal_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	if ($op<>'new')		$phpgw->db->query("DELETE from ${pre}acc_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$chart_id	= 	$dt['accno'.$i];
			$attrib1	=	$dt['attrib1'.$i] ;
			$attrib2	=	$dt['attrib2'.$i] ;
			$attrib3	=	$dt['attrib3'.$i] ;
			$dr		=	$dt['dr'.$i] ;
			$cr		=	$dt['cr'.$i] ;
			if ($dr==0) $amount=$cr; else $amount=-$dr;
			$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
			$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
			$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id," ;
			$sql.= "attrib1,attrib2,attrib3,amount,transdate) " ;
			$sql.= "VALUES ('$id','$chart_id'," ;
			$sql.= "'$attrib1','$attrib2','$attrib3','$amount','$dt[transdate]')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>
