<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: bulkpayrollgen.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'bulkpayroll' ;
	include('../ck-api/ckapi.inc.php') ;

	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);
	$period = ($_GET["period"]) ? $_GET["period"] : $_POST["period"] ;
	$datefrom = ($_GET["datefrom"]) ? $_GET["datefrom"] : $_POST["datefrom"] ;
	$dateto = ($_GET["dateto"]) ? $_GET["dateto"] : $_POST["dateto"] ;

	$gp = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir("$app"));
	$t->set_file('report','bulkpayrollscreen.tpl') ;
	$t->set_file('screen','journalscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('screen','journal','journal_section');

	$t->set_var('lang_title',lang('Current Period Payroll'));
	$warning = lang("Remember to email salary advice to all relevant staff.") ;
	$t->set_var('message',"<b>$warning</b>") ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','');

/*------------- Write Journal to Screen Display ----------------------------*/

$p[datefrom] = $datefrom ;
$p[dateto] = $dateto ;
$gp->bulkpayroll_header_write($t, $p) ;

$float = ($ckapi[hostsys][dbtype]=="mysql") ? "double" : "float" ;
$user = $ckapi[hostsys][username];
$temp = "${pre}pyr".$user.time() ;
$temp1 = "${pre}pyr1".$user.time() ;
$creattempsql = "CREATE TABLE $temp (pyrcodeid int,amount $float)" ;
$phpgw->db->query("CREATE TABLE $temp1 as SELECT * FROM ${pre}pyrohist WHERE 1<>1");

$where = "WHERE empid=b.id" ;
if ($period<>'')	$where = "$where and period='$period'" ;
$sql = "SELECT a.id,empid,salary,period,chart_id,bankac,bankacname " ;
$sql.= "FROM ${pre}payroll a,${pre}employee b $where" ;
$phpgw->db->query($sql);
For ($i=1;$phpgw->db->next_record();$i++)	$arr[$i]=$phpgw->db->Record ;

$tot_recur = $tot_nonrecur = $tot_reductn = $tot_net = $tot_contri = 0 ;
For ($j=1;isset($arr[$j]);$j++) {
	$p = $arr[$j] ;
	$id = $p[id] ;
	$p[temp] = $temp ;
	$p[temp1] = $temp1 ;
	$p[creattempsql] = $creattempsql ;
	$phpgw->db->query("SELECT * FROM ${pre}pyrc_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['eaid'.$i]		=	$phpgw->db->f('pyrcodeid') ;
		$p['qty'.$i]		=	$phpgw->db->f('qty') ;
		$p['rate'.$i]		=	$phpgw->db->f('rate') ;
		$p['amount'.$i]		=	$phpgw->db->f('amount') ;
		$p['comment'.$i]	=	$phpgw->db->f('comment') ;
		$p['chart_id'.$i]	=	$phpgw->db->f('chart_id') ;
		}
	$sql = "SELECT * FROM ${pre}pynr_trans " ;
	$sql.= "WHERE empid='$p[empid]' and approved_by<>'' ORDER BY id";
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['nreaid'.$i]		=	$phpgw->db->f('pyrcodeid') ;
		$p['nrapproved_by'.$i]	=	$phpgw->db->f('approved_by') ;
		$p['nrqty'.$i]		=	$phpgw->db->f('qty') ;
		$p['nrrate'.$i]		=	$phpgw->db->f('rate') ;
		$p['nramount'.$i]	=	$phpgw->db->f('amount') ;
		$p['nrcomment'.$i]	=	$phpgw->db->f('comment') ;
		$p['nrchart_id'.$i]	=	$phpgw->db->f('chart_id') ;
		}
	$sql = "SELECT * FROM ${pre}rdtn_trans a,${pre}reductn b " ;
	$sql.= "WHERE pyroid='$id' and rdtnid=b.id ORDER BY a.id" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['rdtnid'.$i] = $phpgw->db->f('rdtnid') ;
		$p['rdchart_id'.$i] = $phpgw->db->f('chart_id') ;
		}
	$sql = "SELECT * FROM ${pre}cntr_trans a,${pre}contri b " ;
	$sql.= "WHERE pyroid='$id' and cntrid=b.id ORDER BY a.id" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$p['cntrid'.$i] = $phpgw->db->f('cntrid') ;
		$p['ac_exp'.$i] = $phpgw->db->f('ac_exp') ;
		$p['ac_liab'.$i] = $phpgw->db->f('ac_liab') ;
		}
	$gp->bulkpayroll_detail_write($t, $p);
	$tot_recur += $p[recur] ;
	$tot_nonrecur += $p[nonrecur] ;
	$tot_reductn += $p[reductn] ;
	$tot_net += $p[net] ;
	$tot_contri += $p[contri] ;
	}

	$t->set_var('tot_recur',$tot_recur) ;
	$t->set_var('tot_nonrecur',$tot_nonrecur) ;
	$t->set_var('tot_reductn',$tot_reductn) ;
	$t->set_var('tot_net',$tot_net) ;
	$t->set_var('tot_contri',$tot_contri) ;

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter" ;
	$t->set_var('action',$phpgw->link("/ck-payroll/bulkpayrollfilter.php",$getstr));
	$t->set_var('done_action',$phpgw->link("/ck-payroll/bulkpayrollfilter.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);


//---- Generate Payroll journal

	$lang_payperiod = lang('Payroll for period') ;
	$lang_from = strtolower(lang('from')) ;
	$lang_to = strtolower(lang('to')) ;
	$t->set_var('lang_jtitle',lang('Payroll Journal Generated'));
	$jl[source] = "PYRO" ;
	$jl[description] = "$lang_payperiod $lang_from::$datefrom $lang_to::$dateto" ;
	$jl[transdate] = date("Y-m-d") ;
	$phpgw->db->next_record();
	$gp->journal_header_write($t, $jl) ;

	$sql = "SELECT chart_id,sum(amount) as amount from $temp1 a, ${pre}chart b " ;
	$sql.= "WHERE a.chart_id=b.id GROUP BY chart_id ORDER BY chart_id";
	$phpgw->db->query($sql);

	$i=1;
	while ($phpgw->db->next_record()) {
		$jl['accno'.$i]		=	$phpgw->db->f('chart_id') ;
		$jl['attrib1'.$i]	=	$phpgw->db->f('attrib1') ;
		$jl['attrib2'.$i]	=	$phpgw->db->f('attrib2') ;
		$jl['attrib3'.$i]	=	$phpgw->db->f('attrib3') ;
		$cr			=	sprintf("%01.2f",$phpgw->db->f('amount'));
		$dr			=	sprintf("%01.2f",-$cr) ;
		if ($cr>0)	{$dr='';} else {$cr='';}
		$jl['dr'.$i]		=	$dr ;
		$jl['cr'.$i]		=	$cr ;
		$i++ ;
		}
	$gp->journal_detail_write($t,$jl,True);


	global $ckapi ;
	$ckapi[params_post][dt] = &$jl ;
	$ckapi[params_post][op] = 'new' ;
	$ckapi[objects][template] = &$t ;
	$ckapi[objects][tranobj] = &$gp ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}gl" ,
				'temp1'		=> $temp1			);
	$ckapi[phrases] = array('lang_title'	=> lang('Current Period Payroll') ,
				'lang_jtitle'	=> lang('Payroll Journal Generated') ,
				'lang_tran'	=> lang('Bulk Payroll Journal') ,
				'reminder'	=> lang("Remember to email salary advice to all relevant staff.")	) ;
	$ckapi[tables][parents] = array("${pre}gl"	=> ""				);
	$ckapi[tables]["children"] = array(	"${pre}acc_trans"	=> "trans_id" ,
						"${pre}pyrohist"	=> "trans_id"	) ;
	$ckapi[buttons] = array('insert'	=> "" ,
				'delete'	=> "" ,
				'newrow'	=> "" ,
				'post'		=> ""				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_post() ;
	$bulkpayroll_msg = 	$ckapi[phrases][message] ;

//---- Delete Paid Non-recurring Allowance/Deduction

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'nrtrans',
				'tran'		=> $tran ,
				'table'		=> "${pre}pynr_trans" ,
				'uniqueflds'	=> ""				);
	$ckapi[phrases] = array('lang_tran'	=> lang("Non-recurring Payroll Item")	) ;
	$ckapi[tables][parents] = array("${pre}pynr_trans"	=> ""		);
	$ckapi[tables]["children"] = "" ;
	$ckapi[buttons] = array('post'		=> "" ,
				'refresh'	=> "" 				) ;

	if ($temp1<>"") {
		For ($j=1;isset($arr[$j]);$j++) {
			$p = $arr[$j] ;
			$sql = "SELECT * FROM ${pre}pynr_trans " ;
			$sql.= "WHERE empid='$p[empid]' and approved_by<>'' ORDER BY id";
			$phpgw->db->query($sql);
			For ($i=1;$phpgw->db->next_record();$i++)	$temparr[$i]=$phpgw->db->Record ;
			if (!is_array($temparr))			continue ;	
			foreach ($temparr as $key => $value) {
				$ckapi[params_post][dt] = $value ;
				$ckapi[params_post][id] = $value[id] ;
				$ckapi[params_post][op] = 'delete' ;
				$proc1->process1_post() ;
				$delete_msg.= "<br>".$ckapi[phrases][message]."." ;
				}
			}
		}

	$t->set_var('message',"<b>$bulkpayroll_msg.$delete_msg</b>");

	$phpgw->db->query("DROP TABLE $temp1");
	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='bulkpayrollgen'");

	$t->pparse('out','screen',True);
	ExecMethod('ck-api.process.process_footer') ;

?>
