<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.nrtrans.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class nrtrans {

//---- Non-recurring Payroll Item List SQL Formation

    function nrtrans_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$sortkey = $ckapi[params][sortkey] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if (!$order)	{if ($sortkey<>"")	$order=$sortkey;	else $order=$field1;}
	if (!$sort)	$sort = "ASC" ;
	$sql =	"SELECT b.name as empname,c.name as pyrname,description," ;
	$sql.=	"a.qty,a.unit,a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}employee b, ${pre}pyrcode c " ;
	$sql.=	"WHERE 1=1 $where and empid=b.id and pyrcodeid=c.id order by $order $sort" ;

	return $sql ;
	}

//---- Non-recurring Payroll Item Read

    function nrtrans_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.chart_id,a.id,a.control " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}payroll b, ${pre}pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $phpgw->db->f('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	if ($op=='add' or $op=='copy') {
		$dt[id] = "" ;
		$dt[approved_by] = lang("payroll staff") ;
		}
	if (is_array($uniqueflds) and $op=='edit')
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Non-recurring Payroll Item Add Initialisation

    function nrtrans_add_init() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[buttons] as $key => $val)	$$key = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	if ($dt[empid]=="" and $dt[lastempid]=="")		return ;
	$dt[empid] = ($dt[empid]=="") ? 0 : $dt[empid] ;
	$phpgw->db->query("SELECT * from ${pre}payroll WHERE empid='$dt[empid]'");
	if ($phpgw->db->num_rows()==0 and (isset($post) or isset($refresh))) {
		$error = lang("Error") ;
		$err = lang("Employee Payroll Master Info missing") ;
		$t->set_var('message',"<b>$error:  $err</b>");
		$ckapi[params][nomaster] = True ;
		}
	$phpgw->db->next_record();
	$dt[salary] = $phpgw->db->f('salary') ;
	$dt[period] = $phpgw->db->f('period') ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $phpgw->db->f('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	if ($op=='add' or $op=='copy') {
		$dt[id] = "" ;
		$dt[approved_by] = lang("payroll staff") ;
		}
	}

//---- Non-recurring Payroll Item Validation Checks

    function nrtrans_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = lang("Error") ;
	$eaid = $dt[eaid] ;
	$qty = $dt[qty] ;
	$amt = $dt[amount] ;
	$dt[empid] = ($dt[empid]=="") ? 0 : $dt[empid] ;
	$phpgw->db->query("SELECT * from ${pre}payroll WHERE empid='$dt[empid]'");
	if ($phpgw->db->num_rows()==0)		$err=lang("Employee Payroll Master Info missing") ;
	$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$eaid'");
	$phpgw->db->next_record();
	if ($qty<$phpgw->db->f('minqty'))	$err=lang("Quantity too low");
	if ($qty>$phpgw->db->f('maxqty'))	$err=lang("Quantity too high");
	if ($amt<$phpgw->db->f('minamt'))	$err=lang("Amount too low");
	if ($amt>$phpgw->db->f('maxamt'))	$err=lang("Amount too high");
	if ($qty=="")				$err=lang("Quantity Missing");
	if ($qty<>"" and !is_numeric($qty))	$err=lang("Quantity must be numeric");
	if ($amt=="")				$err=lang("Amount Missing");
	if ($amt<>"" and !is_numeric($amt))	$err=lang("Amount must be numeric");
	if ($phpgw->db->f('single')=="y" and $dt[eaid]<>$dt[oldeaid]) {
		$sql = "SELECT * from ${pre}pyrc_trans a, ${pre}payroll b " ;
		$sql.= "WHERE a.pyroid=b.id and b.empid='$dt[empid]' and pyrcodeid='$eaid'" ;
		$phpgw->db->query($sql);
		if ($phpgw->db->num_rows()>0)  $err=lang("This Expense/Allowance (recurring) already exists");
		if ($eaid<>$oldeaid) {
			$sql = "SELECT * from ${pre}pynr_trans " ;
			$sql.= "WHERE empid='$dt[empid]' and pyrcodeid='$eaid'" ;
			$phpgw->db->query($sql);
			if ($phpgw->db->num_rows()>0)
				$err=lang("This Expense/Allowance (non-recurring) already exists") ;
			}
		}
	if ($dt[empid]<>$dt[lastempid] or $dt[eaid]<>$dt[lasteaid]) {
		$warn1 = lang("(Employee Name/#) or (Expense/Allowance Type) had just been updated.") ;
		$warn2 = lang("Ensure other data are appropriately adjusted and updated.") ;
		$warn3 = lang("Then re-click [Post ...] button")  ;
		$err = "$warn1<br>$warn2  $warn3" ;
		}
	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Non-recurring Payroll Item Detail

    function nrtrans_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	if ($dt[empid]<>$dt[lastempid])			$this->nrtrans_add_init() ;
	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_salary',lang('Basic Salary'));
	$t->set_var('lang_period',lang('Pay Period'));
	$t->set_var('lang_daypay',lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',lang('Imputed Hourly Pay'));
	$t->set_var('lang_eaid',lang('Expense/Allowance Type'));
	$t->set_var('lang_basis',lang('Basis of Calculation'));
	$t->set_var('lang_qty',lang('Quantity'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_unitamt',lang('Unit Amount'));
	$t->set_var('lang_rate',lang('Pay Rate'));
	$t->set_var('lang_amount',lang('Amount'));
	$t->set_var('lang_comment',lang('Comment'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$t->set_var('lang_chart_id',lang('Payroll Expense Account'));
	$where = (!$uniwhere) ? " WHERE id='$dt[empid]' " : $uniwhere;
	$t->set_var('empid_selectlist',employee_selectlist($where,$dt[empid])) ;
	$t->set_var('lastempid',$dt[empid]) ;
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('salary',$dt[salary]);
	$t->set_var('period',$dt[period]) ;
	$t->set_var('daypay',$dt[daypay]);
	$t->set_var('hourpay',$dt[hourpay]) ;
	$eaid = $dt[eaid] ;
	$t->set_var('eaid_selectlist',eaid_selectlist('',$eaid,'long')) ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var("lasteaid",$eaid);

	$qty = 1 ;
	$eaid = ($eaid=="") ? 0 : $eaid ;
	$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$eaid'");
	$phpgw->db->next_record();
	$basis		=	$phpgw->db->f('basis') ;
	$unit		=	$phpgw->db->f('unit') ;
	$unitamt	=	(substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
	$rate		=	$phpgw->db->f('rate') ;
	$chart_id	=	($dt[rate]==0) ? $phpgw->db->f('chart_id') : $dt[chart_id] ;
	$dt[chart_id]	=	$phpgw->db->f('chart_id') ;
	if (substr_count($basis,'qty')>0)	{$qty = $dt[qty]; $t->set_var('qty_readonly','');}
		else				$t->set_var('qty_readonly','readonly') ;
	if (substr_count($basis,'bs')>0)	$unitamt = $dt[salary] ;
	if (substr_count($basis,'hp')>0)	$unitamt = $dt[hourpay] ;
	if (substr_count($basis,'dp')>0)	$unitamt = $dt[daypay] ;
	$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
	if (substr_count($basis,'amt')>0)	{$amount=$dt[amount]; $t->set_var('amt_readonly','');}
		else				$t->set_var('amt_readonly','readonly') ;
	$dt[qty] = $qty ;
	$dt[unit] = $unit ;
	$dt[unitamt] = $unitamt ;
	$dt[rate] = $rate ;
	$dt[amount] = $amount ;
	$dt[chart_id] = $chart_id ;
	$t->set_var('basis',$basis);
	$t->set_var('qty',$qty);
	$t->set_var('unit',$unit);
	$t->set_var('unitamt',$unitamt);
	$t->set_var('rate',$rate);
	$t->set_var('amount',$amount);
	$t->set_var('comment',$dt[comment]);
	$t->set_var('approved_by',$dt[approved_by]);
	$chartid_sl = account_selectlist("WHERE link like '%PY_expense%'",$chart_id) ;
	$t->set_var('chart_id_selectlist',$chartid_sl);
	if ((($dt[empid]<>$dt[lastempid] and $dt[lastempid]<>"") or ($dt[eaid]<>$dt[lasteaid] and $dt[lasteaid]<>"")) and !$ckapi[params][nomaster]) {
		$warning = lang("Warning") ;
		$warn1 = lang("(Employee Name/#) or (Expense/Allowance Type) had just been updated.") ;
		$warn2 = lang("Ensure other data are appropriately adjusted and updated.") ;
		$t->set_var('message',"<b>$warning:  $warn1<br>$warn2</b>");
		}
	$t->parse('out','report',True);
	}

//---- Non-recurring Payroll Item Post Initialisation

    function nrtrans_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][pyrcodeid] = $ckapi[params_post][dt][eaid] ;
	}

//---- Non-recurring Payroll Item Post - PostCommit Routine

    function nrtrans_post_postcommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$actioned = $ckapi[phrases][actioned] ;

	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT name,id FROM ${pre}employee WHERE username='$user'");
	$phpgw->db->next_record();
	$pystaffname = $phpgw->db->f('name');
	$pystaffid = $phpgw->db->f('id');
	$sql = "SELECT prefix,suffix FROM ${pre}email " ;
	$sql.= "WHERE empid='$pystaffid' and emailcode='BUSI'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$pystaffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
	$sql.= "FROM ${pre}employee a, ${pre}employee b " ;
	$sql.= "WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$sql = "SELECT prefix,suffix FROM ${pre}email " ;
	$sql.= "WHERE empid='$dt[empid]' and emailcode='BUSI'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT prefix,suffix FROM ${pre}email " ;
	$sql.= "WHERE empid='$superid' and emailcode='BUSI'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;
	$subject = lang("%1's Non-recurring Payroll Item [id#%2] %3 by Payroll Staff",$staffname,$id,$actioned) ;
	$message = '' ;
	$headers = "From: $pystaffname < $pystaffemail > \n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $pystaffname < $pystaffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = lang("Email advising action on non-recurring payroll item [id#%1] successfully queued for despatch to",$id) ;
	$failuremsg = lang("Email advising action on non-recurring payroll item [id#%1] fails to deliver.  Please manually inform",$id) ;
	$lang_staff = lang("Staff:") ;
	if ($result)	$msg = "$msg<br>$lang_staff $successmsg $staffname." ;
		else	$msg = "$msg<br>$lang_staff $failuremsg $staffname." ;
	$recipient = "$supername < $superemail >" ;
	$lang_super = lang("Supervisor:") ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($result)	$msg = "$msg<br>$lang_super $successmsg $supername." ;
		else	$msg = "$msg<br>$lang_super $failuremsg $supername." ;
	$ckapi[phrases]["reminder"] = $msg ;

	}

    }

?>
