<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payrolledit.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'payroll' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'payroll',
				'tran'		=> $tran ,
				'table'		=> "${pre}payroll" ,
				'uniqueflds'	=> array("empid")		);
	$msg0 = lang('If basic salary > 0, a single recurring (basesalary) must be present.');
	$msg1 = lang('Basis of Calculation');
	$msg2 = lang('bs - basic salary, pc - allowance/deduction unit amount, dp - imputed daily pay,') ;
	$msg3 = lang('hp - imputed hourly pay, qty - qty input, amt - amount input');
	$msg4 = lang('Reduction/Contribution');
	$msg5 = lang('If Company Contribution is to match Reduction(Employee Contribution),') ;
	$msg6 = lang('then the specific contribution type should have exactly the same setup as its reduction counterpart.');
	$msg = "<b>$msg0</b><br><b>$msg1:</b><br>$msg2  $msg3<br><b>$msg4:</b><br>$msg5 $msg6" ;
	$ckapi[phrases] = array('lang_title'	=> lang("Edit Individual Staff Payroll Master") ,
				'lang_post'	=> lang("Post Individual Staff Payroll Master") ,
				'lang_newrow'	=> lang("Add New Recurring Allowance/Deduction Row") ,
				'lang_rdnewrow'	=> lang('Add New Reduction Row') ,
				'lang_ctnewrow'	=> lang('Add New Contribution Row') ,
				'lang_refresh'	=> lang('Refresh Screen') ,
				'lang_tran'	=> lang("Payroll Master Record") ,
				'message'	=> $msg				) ;
	$ckapi[tables][parents] = array("${pre}payroll"	=> ""			);
	$ckapi[tables]["children"] = array(	"${pre}pyrc_trans"=> "pyroid" ,
						"${pre}rdtn_trans"=> "pyroid" ,
						"${pre}cntr_trans"=> "pyroid"	);
	$ckapi[buttons] = array('insert'	=> "" ,
				'delete'	=> "" ,
				'newrow'	=> "" ,
				'rdnewrow'	=> "" ,
				'ctnewrow'	=> "" ,
				'refresh'	=> "" ,
				'post'		=> ""				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_edit() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
