<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pontbulk.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-po' ;
	$tran = 'pont' ;
	$noheader = $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$shipto = ($_GET["shipto"]) ? $_GET["shipto"] : $_POST["shipto"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=stripslashes($filter);

	if (isset($email)) {
//		$shipto = urlencode($shipto) ;	(* this line is needed for pre-phpgw0.9.16 *)
		$getstring = "shipto=$shipto&order=$order&sort=$sort&filter=$filter" ;
		Header('Location: '.$phpgw->link("/$app/${tran}bulkemail.php",$getstring)) ;
		$phpgw->common->phpgw_exit();
		}

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('report'	=> "${tran}off.tpl",
				'items'	=> "${tran}off.tpl"));
	$t->set_block('items','item_row','item_section');

	$thank = lang('Thank you for being our preferred supplier') ;
	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title = lang('If the sample displayed is OK, press [Email ...] button to start bulk despatch');
	$t->set_var('lang_title',$title);
	$note1 =lang('For email function to work, your email/DNS environment must be properly setup.');
	$t->set_var('lang_note1',$note1);
	$t->set_var('lang_note2','');
	$t->set_var('charset',lang('charset'));
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$t->set_var('logo',$phpgw->link("/ck-admin/logoview_image.php","imgfile=$logofile"));

/*------------- Write Payment to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$shipto = (!$shipto) ? $phpgw->db->f('company') : $shipto ;
	$shiptoaddr1 = $phpgw->db->f('addr1') ;
	$shiptoaddr2 = $phpgw->db->f('addr2') ;
	$shiptoaddr3 = $phpgw->db->f('addr3') ;
	$shiptoaddr4 = $phpgw->db->f('addr4') ;
	$comemail = $phpgw->db->f('email') ;
	$po_rmkid = $phpgw->db->f('po_rmkid') ;
	$phpgw->db->query("SELECT * FROM ${pre}remark where id='$po_rmkid'");
	$phpgw->db->next_record();
	$remark = $phpgw->db->f('description') ;

	$phpgw->db->query("SELECT * FROM ${pre}po WHERE id='$id'");
	$phpgw->db->next_record();
	$vendor = $phpgw->db->f('vendor') ;
	$transdate = $phpgw->db->f('transdate') ;
	$duedate = $phpgw->db->f('duedate') ;
	$ponumber = $phpgw->db->f('ponumber') ;
	$currency = $phpgw->db->f('isocode') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;
	$duedate = date("Y-m-d",strtotime($duedate)) ;

	$phpgw->db->query("SELECT * FROM ${pre}vendor a, ${pre}org b WHERE a.id='$vendor' and contactid=b.id");
	if ($phpgw->db->next_record()) {
		$name = $phpgw->db->f('orgname') ;
		$emailname = lang('Accounts Department') ;
		$contactid = $phpgw->db->f('contactid') ;
		}
	  else	{
		$phpgw->db->query("SELECT * FROM ${pre}vendor a,${pre}person b WHERE a.id='$id' and contactid=b.id");
		$phpgw->db->next_record();
		$name = $emailname = strtoupper($phpgw->db->f('family'))." ".$phpgw->db->f('given') ;
		$contactid = $phpgw->db->f('contactid') ;
		}
	$terms = $phpgw->db->f('terms') ;
	$t->set_var('name',$name) ;
	$phpgw->db->query("SELECT * FROM ${pre}comm WHERE contactid='$contactid' and commcode='wemail'");
	$phpgw->db->next_record();
	$vendoremail = $phpgw->db->f('commdata') ;
	$phpgw->db->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='workaddr'");
	$phpgw->db->next_record();
	$addr1 = $phpgw->db->f('line1') ;
	$addr2 = $phpgw->db->f('line2') ;
	$addr3 = $phpgw->db->f('line3') ;
	$addr4 = $phpgw->db->f('line4') ;

	$t->set_var('lang_po',strtoupper(lang('OFFICIAL PURCHASE ORDER')));
	$t->set_var('lang_transdate',lang('PO Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_ponumber',lang('Number'));
	$t->set_var('lang_vendor',lang('Vendor:'));
	$t->set_var('lang_shipto',lang('Ship To:'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('ponumber',$ponumber) ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$addr1) ;
	$t->set_var('addr2',$addr2) ;
	$t->set_var('addr3',$addr3) ;
	$t->set_var('addr4',$addr4) ;
	$t->set_var('shipto',$shipto) ;
	$t->set_var('shiptoaddr1',$shiptoaddr1) ;
	$t->set_var('shiptoaddr2',$shiptoaddr2) ;
	$t->set_var('shiptoaddr3',$shiptoaddr3) ;
	$t->set_var('shiptoaddr4',$shiptoaddr4) ;

// ---------------------------- Begin list items -----------------------------------------

	$phpgw->db->query("SELECT * FROM ${pre}oitem WHERE trans_id='$id'");
	$total = 0 ;
	while ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$description = $phpgw->db->f('description') ;
		$qty = $phpgw->db->f('qty') ;
		$price = $phpgw->db->f('cost') ;
		$discount = $phpgw->db->f('discount') ;
		$amount = $qty * $price - $discount ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $description,
					'qty'		=> $qty,
      		      	    		'price'		=> $price,
        	    	    		'discount'	=> $discount ,
         		   	    	'amount'	=> $amount ));
		$t->parse('item_section','item_row',true);
		$total+= $amount ;
		}
	$t->set_var('lang_total',lang("PO Total")) ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('lang_term',lang("Terms Net")." $terms ".lang("days")) ;
	$t->set_var('lang_currency',lang("All prices are in")." $currency") ;
	$t->set_var('lang_thank',$thank) ;
	$t->set_var('lang_remark',$remark) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('regenerate_action',$phpgw->link("/$app/${tran}bulk.php","id=$id&order=$order&sort=$sort&filter=$filter")) ;
	$t->set_var('lang_regenerate',lang('Regenerate Purchase Order'));
	$t->set_var('lang_email',lang('Email Purchase Order'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php","order=$order&sort=$sort&filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','items',report);
	ExecMethod('ck-api.process.process_footer') ;

?>
