<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: powtfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-po' ;
	$tran = 'powt' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'po' ,
				'tran'		=> $tran			) ;
	$msg1 = lang('If during data entry/maintenance, all taxes are deleted') ;
	$msg2 = lang('the resultant invoice will be moved to the no tax list');
	$ckapi[phrases] = array('lang_title'	=> lang("Search among posted purchase orders [with Tax] :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Purchase Order [with Tax]") ,
			'lang_search_message'	=> "$msg1,<br>$msg2." ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$warning = lang("Make sure you have completed all Invoice/PO Matching before checking on unbilled POs") ;
	$ckapi[filter][] = array(criteria	=>	lang('Vendor') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.vendor_selectlist("","") ,
				varname		=>	'vendor' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate vendor') );

	$ckapi[filter][] = array(criteria	=>	lang('Currency') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.isocode_selectlist("","") ,
				varname		=>	'isocode' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate currency') );

	$ckapi[filter][] = array(criteria	=>	lang('Purchase Order Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	lang('Purchase Order Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	lang('Purchase Order Number') ,
				type		=>	'input' ,
				varname		=>	'ponumber' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word/number in the purchase order # field') );

	$ckapi[filter][] = array(criteria	=>	lang('Unbilled PO Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	lang("Click box if only non fully billed POs are to be retrieved")."<br><b>".$warning."</b>" );

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
