<?php
 /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: csntmemo.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-c' ;
	$tran = 'csntmemo' ;
	$noheader = $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report',"$tran.tpl") ;
	$t->set_block('report','item','item_section');
	$t->set_block('report','addon','addon_section');
	$t->set_block('report','qcash','qcash_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=lang('Sales Memo Image (Use browser to print the Sales Memo shown above)');
	$t->set_var('lang_title',$title);
	$notes=lang('[This is a sample subject to tailoring per individual printer & Sales Memo format]');
	$t->set_var('lang_notes',$notes);
	$t->set_var('charset',lang('charset'));
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$t->set_var('logo',$phpgw->link("/ck-admin/logoview_image.php","imgfile=$logofile"));

/*------------- Write Payment to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$currency = $phpgw->db->f('nativecurr') ;
	$sm_rmkid = $phpgw->db->f('sm_rmkid') ;
	$phpgw->db->query("SELECT * FROM ${pre}remark where id='$sm_rmkid'");
	$phpgw->db->next_record();
	$remark = $phpgw->db->f('detail') ;

	$phpgw->db->query("SELECT * FROM ${pre}pos WHERE id='$id'");
	$phpgw->db->next_record();
	$transdate = $phpgw->db->f('transdate') ;
	$posnumber = $phpgw->db->f('posnumber') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;

	$t->set_var('lang_memo',strtoupper(lang('SALE MEMO')));
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_posnumber',lang('Ref. Number'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('posnumber',$posnumber) ;

// ---------------------------- Begin list items -----------------------------------------

	$user = $ckapi[hostsys][username];
	$temp = "${pre}memo".$user.time() ;
	$total = 0 ;

	$sql =	"CREATE TABLE $temp AS " ;
	$sql.="SELECT a.id as id,itemid,description,qty,a.price,discount from ${pre}positem a,${pre}parts b ";
	$sql.=	"WHERE trans_id='$id' and itemtype='i' and itemid=b.id " ;
	$phpgw->db->query($sql);
	$sql =	"INSERT INTO $temp (id,itemid,description,qty,price,discount) " ;
	$sql.="SELECT a.id as id,itemid,description,qty,a.price,discount from ${pre}positem a, ${pre}service b ";
	$sql.=	"WHERE trans_id='$id' and itemtype='s' and itemid=b.id " ;
	$phpgw->db->query($sql);
	$sql = "SELECT * FROM $temp ORDER BY id" ;
	$phpgw->db->query($sql) ;
	While ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$qty = $phpgw->db->f('qty') ;
		$price = $phpgw->db->f('price') ;
		$discount = $phpgw->db->f('discount') ;
		$amount = $qty * $price - $discount ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $phpgw->db->f('description'),
					'qty'		=> $qty,
					'price'		=> $price,
					'discount'	=> $discount ,
					'amount'	=> $amount ));
		$t->parse('item_section','item',true);
		$total+= $amount ;
		}
	$t->set_var('lang_total',lang("Total Purchase (Currency:")." $currency)") ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('lang_addon',lang("Add-on Charges/Discounts:")) ;

	$totalp = $total ;
	$sql = "SELECT itemid,name,a.factor as factor FROM ${pre}positem a, ${pre}addon b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='a' and itemid=b.id " ;
	$phpgw->db->query($sql) ;
	if ($phpgw->db->num_rows()<=0)			$t->set_var('addon_section',"") ;
	While ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$factor = $phpgw->db->f('factor') ;
		$amount = $total * $factor ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'name'		=> $phpgw->db->f('name'),
					'factor'	=> $factor*100,
					'amount'	=> $amount ));
		$t->parse('addon_section','addon',true);
		$totalp+= $amount ;
		}
	$t->set_var('lang_totalp',lang("Total Payable (Currency:")." $currency)") ;
	$t->set_var('total_pamount',$totalp) ;
	$t->set_var('lang_qcash',lang("Customer Payments:")) ;

	$sql = "SELECT itemid,name,qty,a.value as value FROM ${pre}positem a, ${pre}qcash b " ;
	$sql.=	"WHERE trans_id='$id' and itemtype='q' and itemid=b.id " ;
	$phpgw->db->query($sql) ;
	While ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$qty = $phpgw->db->f('qty') ;
		$value = $phpgw->db->f('value') ;
		$amount = $qty * $value ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'name'		=> $phpgw->db->f('name'),
					'qty'		=> $qty,
					'value'		=> $value,
					'amount'	=> $amount ));
		$t->parse('qcash_section','qcash',true);
		}
	$t->set_var('lang_totalc',lang("Total Change (Currency:")." $currency)") ;
	$phpgw->db->query("SELECT value FROM ${pre}positem WHERE trans_id='$id' and itemtype='c'") ;
	$phpgw->db->next_record() ;
	$change = $phpgw->db->f('value') ? $phpgw->db->f('value') : 0 ;
	$t->set_var('total_camount',$change) ;

	$t->set_var('lang_thank',lang('Thank you for shopping with us!')) ;
	$t->set_var('lang_remark',$remark) ;

	$phpgw->db->query("DROP TABLE $temp");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link("/$app/csntlist.php","filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);
	ExecMethod('ck-api.process.process_footer') ;

?>
