<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.shiftbal.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class shiftbal {

//---- Shift End Cash Balance List SQL Formation

    function shiftbal_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}shiftbal1".$user.time() ;
	$temp2 = "${pre}shiftbal2".$user.time() ;
	$temp3 = "${pre}shiftbal3".$user.time() ;
	$temp4 = "${pre}shiftbal4".$user.time() ;
	$lang_cash = lang('Cash') ;

	$sql =	"CREATE TABLE $temp1 AS " ;
	$sql.=  "SELECT a.cboxid as cboxid,a.transdate as transdate,a.shift as shift " ;
	$sql.=	"FROM ${pre}cbtran a,${pre}cashbox b WHERE $where and a.cboxid=b.id and trantype='s'" ;
	$phpgw->db->query($sql);
	$sql =	"CREATE TABLE $temp2 AS " ;
	$sql.=	"SELECT d.cboxid as cboxid,d.transdate as transdate,d.shift as shift,sum(qty*a.value) as cashamt " ;
	$sql.=	"FROM ${pre}positem a,${pre}pos b,${pre}qcash c,$temp1 d " ;
	$sql.=	"WHERE b.cboxid=d.cboxid and b.transdate=d.transdate and b.shift=d.shift and " ;
	$sql.=		"name='$lang_cash' and a.trans_id=b.id and a.itemid=c.id " ;
	$sql.=	"GROUP BY d.transdate,d.shift,d.cboxid,itemid" ;
	$phpgw->db->query($sql);
	$sql =	"CREATE TABLE $temp3 AS " ;
	$sql.=	"SELECT c.cboxid as cboxid,c.transdate as transdate,c.shift as shift,cashamt, " ;
	$sql.=		"sum(qty*value) as changeamt FROM ${pre}positem a,${pre}pos b,$temp2 c " ;
	$sql.=	"WHERE b.cboxid=c.cboxid and b.transdate=c.transdate and b.shift=c.shift and " ;
	$sql.=		"itemtype='c' and a.trans_id=b.id " ;
	$sql.=	"GROUP BY c.transdate,c.shift,c.cboxid,itemid,cashamt" ;
	$phpgw->db->query($sql);
	$sql =	"CREATE TABLE $temp4 AS " ;
	$sql.=	"SELECT a.cboxid as cboxid,a.transdate as transdate,a.shift as shift,name,b.cashier as cashier," ;
	$sql.=		"cashamt,changeamt,sum(amount) as cbtamt, 0.00 as balance " ;
	$sql.=	"FROM $temp3 a, ${pre}cbtran b, ${pre}cashbox c " ;
	$sql.=	"WHERE a.cboxid=b.cboxid and a.transdate=b.transdate and a.shift=b.shift and a.cboxid=c.id " ;
	$sql.=	"GROUP BY a.transdate,a.shift,a.cboxid,name,b.cashier,cashamt,changeamt " ;
	$phpgw->db->query($sql) ;
	$phpgw->db->query("UPDATE $temp4 SET balance=cashamt+changeamt+cbtamt") ;

	if (!$order) {$order = "transdate" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql = "SELECT * FROM $temp4 order by $order $sort" ;
	
	return $sql ;
	}

//---- Shift End Cash Balance List Link Adjustement

    function shiftbal_list_adjust() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$t = &$ckapi[objects][template] ;
	
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	$shift = $ckapi[params_list][dt][shift] ;
	$transdate = $ckapi[params_list][dt][transdate] ;
	$cboxid = $ckapi[params_list][dt][cboxid] ;
	$ifilter = "${markpri}01=1" ;
	$ifilter.= "${markpri}1shift${marksec}${shift}" ;
	$ifilter.= "${markpri}1transdate${marksec}${transdate}" ;
	$ifilter.= "${markpri}1cboxid${marksec}${cboxid}";
	$ifilter = urlencode($ifilter) ;
	$view = $phpgw->link("/$app/cashballist.php","filter=$ifilter");
	$t->set_var('view',$view);
	}

    }

?>
