<?php
 /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: quotentbulkemail.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-quote' ;
	$tran = 'quotent' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$filter = urldecode(stripslashes($filter)) ;
	$proc1 = CreateObject('ck-api.process1') ;
	$where = "AND amount=netamount ".$proc1->decode_where($filter) ;
	$filter = urlencode($filter) ;
	$db_type = $ckapi[hostsys][dbtype] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('screen','confirm.tpl') ;
	$t->set_file('report',"${tran}off.tpl") ;
	$t->set_block('report','item_row','item_section');
	$t->set_block('report','done','done_section');
	$t->set_var('done_section',"") ;

	$thank = lang("Thank you for your valued business!") ;
	$charset = lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$logourl = $phpgw->link("/ck-admin/logoview_image.php","imgfile=$logofile") ;	
	$t->set_var('logo',$logourl);
	$caption = lang("We are pleased to quote the following items to meet your purchasing needs.") ;
	$t->set_var('lang_caption',$caption);

/*------------- Write Payment to Screen Display ----------------------------*/

	$t->set_var('lang_quote',strtoupper(lang('QUOTATION')));
	$t->set_var('lang_transdate',lang('Quotation Date'));
	$t->set_var('lang_duedate',lang('Valid Until'));
	$t->set_var('lang_quotenumber',lang('Number'));
	$t->set_var('lang_billto',lang('Bill To:'));
	$t->set_var('lang_shipto',lang('Ship To:'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$quo_rmkid = $phpgw->db->f('quo_rmkid') ;
	$phpgw->db->query("SELECT * FROM ${pre}remark where id='$quo_rmkid'");
	$phpgw->db->next_record();
	$remark = $phpgw->db->f('description') ;

	echo "<br><br>",lang("<b>Quotation Despatch Log</b>"),"<br><br>" ;

	if (!$order) $order = "transdate" ;
	if (!$sort)  $sort = "ASC" ;
	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,duedate,quotenumber,name,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}quote a, ${pre}customer b WHERE a.customer=b.id $where " ;
		$sql2 =	"SELECT $fields FROM ${pre}quote a, ${pre}customer b, ${pre}sqmatch c " ;
		$sql2.=	"WHERE customer=b.id AND a.id=c.quoteid $where " ;
		$sql2.=	"GROUP BY $fields HAVING sum(a_amount)>=amount " ;
		if ($db_type=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}quotentl1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}quotentl2".$user.time() ;
			$phpgw->db->query("CREATE TABLE $temp1 AS $sql1");
			$phpgw->db->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	   else	$sql ="SELECT $fields FROM ${pre}quote a, ${pre}customer b WHERE a.customer=b.id $where ORDER BY $order $sort" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	echo lang("No quotation selected for despatch") ;
	   else	For ($i=1;$phpgw->db->next_record();$i++) $senditem[$i]=$phpgw->db->Record ;

For ($i=1;isset($senditem[$i]);$i++) {
	$t->set_var('item_section',"");
	$id	= $senditem[$i]['id'] ;

	$phpgw->db->query("SELECT * FROM ${pre}quote WHERE id='$id'");
	$phpgw->db->next_record();
	$customer = $phpgw->db->f('customer') ;
	$transdate = $phpgw->db->f('transdate') ;
	$duedate = $phpgw->db->f('duedate') ;
	$quotenumber = $phpgw->db->f('quotenumber') ;
	$currency = $phpgw->db->f('isocode') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;
	$duedate = date("Y-m-d",strtotime($duedate)) ;

	$phpgw->db->query("SELECT * FROM ${pre}customer a, ${pre}org b WHERE a.id='$customer' and contactid=b.id");
	if ($phpgw->db->next_record()) {
		$name = $phpgw->db->f('orgname') ;
		$emailname = lang('Accounts Department') ;
		$contactid = $phpgw->db->f('contactid') ;
		}
	  else	{
		$phpgw->db->query("SELECT * FROM ${pre}customer a,${pre}person b WHERE a.id='$customer' and contactid=b.id");
		$phpgw->db->next_record();
		$name = $emailname = strtoupper($phpgw->db->f('family'))." ".$phpgw->db->f('given') ;
		$contactid = $phpgw->db->f('contactid') ;
		}
	$terms = $phpgw->db->f('terms') ;
	$t->set_var('name',$name) ;
	$t->set_var('shiptoname',$name) ;

	$phpgw->db->query("SELECT * FROM ${pre}comm WHERE contactid='$contactid' and commcode='bemail'");
	$phpgw->db->next_record();
	$custemail = $phpgw->db->f('commdata') ;
	$phpgw->db->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='billaddr'");
	$phpgw->db->next_record();
	$t->set_var('addr1',$phpgw->db->f('line1')) ;
	$t->set_var('addr2',$phpgw->db->f('line2')) ;
	$t->set_var('addr3',$phpgw->db->f('line3')) ;
	$t->set_var('addr4',$phpgw->db->f('line4')) ;
	$phpgw->db->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='shipaddr'");
	$phpgw->db->next_record();
	$t->set_var('shiptoaddr1',$phpgw->db->f('line1')) ;
	$t->set_var('shiptoaddr2',$phpgw->db->f('line2')) ;
	$t->set_var('shiptoaddr3',$phpgw->db->f('line3')) ;
	$t->set_var('shiptoaddr4',$phpgw->db->f('line4')) ;

	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('quotenumber',$quotenumber) ;

	/* ---------------------------- Begin list items --------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}oitem WHERE trans_id='$id'");
	$total = 0 ;
	while ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$description = $phpgw->db->f('description') ;
		$qty = $phpgw->db->f('qty') ;
		$price = $phpgw->db->f('price') ;
		$discount = $phpgw->db->f('discount') ;
		$amount = $qty * $price - $discount ;
		$t->set_var(array('itemid'	=> $itemid,
				'description'	=> $description,
				'qty'		=> $qty,
				'price'		=> $price,
				'discount'	=> $discount ,
				'amount'	=> $amount ));
		$t->parse('item_section','item_row',true);
		$total+= $amount ;
		}
	$t->set_var('lang_total',lang("Quotation Total")) ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('lang_term',lang("Terms Net")." $terms ".lang("days")) ;
	$t->set_var('lang_currency',lang("All prices are in")." $currency") ;
	$t->set_var('lang_thank',$thank) ;
	$t->set_var('lang_remark',$remark) ;

	/*-------------------- Generate Email    ---------------------------------*/

	$err = "" ; $error=lang("Error") ; $noemail=lang("No email sent") ;
	$custmsg = lang("Customer") ;	$quotemsg = lang("Quotation") ;
	$successmsg = lang("Email successfully queued for despatch to") ;
	$failuremsg = lang("Email fails to deliver to") ;
	if (!$custemail)				$err = lang("Customer email address missing") ;
	if ($custemail and strpos($custemail,'@')=='')	$err = lang("Invalid customer email address") ;
	if (!$comemail)					$err = lang("Self return email address missing") ;
	if ($comemail and strpos($comemail,'@')=='')	$err = lang("Invalid self return email address");
	if ($err)	echo "$custmsg/$name -- $quotemsg/$id -- $noemail -- $error: $err<br>" ;
	   else {
		$recipient = "$emailname < $custemail >" ;
		$subject = lang("Quotation#: %1 dated %2",$quotenumber,$transdate) ;
		$bdmarker = "CK-ERP_".md5(uniqid(time())) ;
		$headers = "From: $company < $comemail >\n" ;
		$headers.= "Bcc: $company < $comemail >\n" ;
		$headers.= "Return-Path: $company < $comemail >\n" ;
		$headers.= "MIME-Version: 1.0\n" ;
		$headers.= "Content-Type: multipart/mixed; boundary=\"$bdmarker\"\n" ;
		$message = "--$bdmarker\n" ;
		$message.= "Content-Type: text/html; charset=$charset\n" ;
		$message.= "Content-Transfer-Encoding: 7bit\n" ;
		$contentid = md5(uniqid(time())) ;
		$message.= str_replace($logourl,"cid:$contentid",$t->parse('out','report',true)) ;
		$message.= "--$bdmarker\n" ;
		$message.= "Content-Type: image/png\n" ;
		$message.= "Content-Transfer-Encoding: base64\n" ;
		$message.= "Content-ID: $contentid\n\n" ;
		$fd = fopen("$logofile","r");
		$message.= chunk_split(base64_encode(fread($fd,filesize($logofile))))."\n";
		$message.= "--$bdmarker--\n" ;
		$result = mail($recipient,$subject,$message,$headers) ;
		if ($result)	echo "$custmsg/$name -- $quotemsg/$id -- $successmsg $custemail<br>" ;
			else	echo "$custmsg/$name -- $quotemsg/$id -- $failuremsg $custemail<br>" ;
		}

	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang("Despatch Completed")) ;
	$t->set_var('lang_yes',lang("Done")) ;
	$t->set_var('lang_no',lang("Done")) ;
	$t->set_var('yes_action',$phpgw->link("/$app/${tran}list.php","order=$order&sort=$sort&filter=$filter")) ;
	$t->set_var('no_action',$phpgw->link("/$app/${tran}list.php","order=$order&sort=$sort&filter=$filter")) ;
	$t->pparse('out','screen',true);

	if (isset($temp1))	$phpgw->db->query("DROP TABLE $temp1,$temp2");
	ExecMethod('ck-api.process.process_footer') ;

?>
