<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: timesheetlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-sss' ;
	$tran = 'timesheet' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'timesheet',
				'tran'		=> $tran ,
				'table'		=> "${pre}timesheet" ,
				'sortkey'	=> 'year,week'				);
	$msg = lang('Approved Timesheets cannot be edited nor deleted.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Timesheet List") ,
				'lang_add'	=> lang("Add New Timesheet") ,
				'message'	=> $msg					);
	$ckapi[columns] = array('name'		=> lang('Employee') ,
				'year'		=> lang('Year') ,
				'week'		=> lang('Week') ,
				'hour_ttl'	=> lang('Working Hours') ,
				'day_ttl'	=> lang('Days On Leave') ,
				'approved_by'	=> lang('Approved By') ,
				'id'		=> lang('Audit ID') 			);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>

